#include <bits/stdc++.h>

#define MIN_INT -2147483648
#define MAX_INT 2147483647
#define MIN_LONG -9223372036854775808L
#define MAX_LONG 9223372036854775807L

#define long long long int

using namespace std;

// @author: pashka

vector<int> dx = {-1, 1, 0, 0};
vector<int> dy = {0, 0, -1, 1};
string ds = "UDLR";
int curx, cury;
vector<string> res;
vector<string> a;

int T = 0;
int D[1000][1000];
int PD[1000][1000];

void go_to(int tx, int ty) {
    T++;
    vector<pair<int, int>> q;
    q.push_back({tx, ty});
    D[tx][ty] = T;
    for (int k = 0; k < q.size(); k++) {
        for (int d = 0; d < 4; d++) {
            int xx = q[k].first + dx[d];
            int yy = q[k].second + dy[d];
            if (a[xx][yy] == '.' && D[xx][yy] != T) {
                q.push_back({xx, yy});
                PD[xx][yy] = d ^ 1;
                D[xx][yy] = T;
            }
        }
    }
    assert(D[curx][cury] == T);
    while (curx != tx || cury != ty) {
        int d = PD[curx][cury];
        string s = "M";
        s += ds[d];
        res.push_back(s);
        curx += dx[d];
        cury += dy[d];
    }
}

int pp = 0;
void port(int d) {
    pp ^= 1;
    string s = "";
    s += "OB"[pp];
    s += ds[d];
    res.push_back(s);
}

int main() {
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<int>> c(n, vector<int>(m, -1));
    int cn = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.' && c[i][j] == -1) {
                vector<pair<int, int>> q;
                q.push_back({i, j});
                c[i][j] = cn;
                for (int k = 0; k < q.size(); k++) {
                    for (int d = 0; d < 4; d++) {
                        int xx = q[k].first + dx[d];
                        int yy = q[k].second + dy[d];
                        if (a[xx][yy] == '.' && c[xx][yy] == -1) {
                            q.push_back({xx, yy});
                            c[xx][yy] = cn;
                        }
                    }
                }
                cn++;
            }
        }
    }

    struct portal {
        int sx, sy, d, dx, dy;
    };

    vector<vector<portal>> g(cn);
    for (int i = 0; i < n; i++) {
        int jj = -1;
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 'W') {
                if (jj == -1)
                    jj = j;
            } else {
                jj = -1;
            }
            if (a[i][j] == '.') {
                g[c[i][j]].push_back({i, j, 2, i, jj});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        int jj = -1;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] != 'W') {
                if (jj == -1)
                    jj = j;
            } else {
                jj = -1;
            }
            if (a[i][j] == '.') {
                g[c[i][j]].push_back({i, j, 3, i, jj});
            }
        }
    }
    for (int j = 0; j < m; j++) {
        int ii = -1;
        for (int i = 0; i < n; i++) {
            if (a[i][j] != 'W') {
                if (ii == -1)
                    ii = i;
            } else {
                ii = -1;
            }
            if (a[i][j] == '.') {
                g[c[i][j]].push_back({i, j, 0, ii, j});
            }
        }
    }
    for (int j = 0; j < m; j++) {
        int ii = -1;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i][j] != 'W') {
                if (ii == -1)
                    ii = i;
            } else {
                ii = -1;
            }
            if (a[i][j] == '.') {
                g[c[i][j]].push_back({i, j, 1, ii, j});
            }
        }
    }

//    cout << cn << "\n";
//    for (int i = 0; i < cn; i++) {
//        for (auto p : g[i]) {
//            cout << p.sx << " " << p.sy << " " << p.d << " " << p.dx << " " << p.dy << "\n";
//        }
//        cout << "\n";
//    }

    int st, fn;
    int stx, sty;
    cin >> stx >> sty; stx--; sty--;
    st = c[stx][sty];
    int fnx, fny;
    cin >> fnx >> fny; fnx--; fny--;
    fn = c[fnx][fny];

    vector<int> q;
    vector<portal> pr(cn);
    vector<int> pr2(cn);
    vector<bool> z(cn);
    z[st] = true;
    pr2[st] = -1;
    pr[st] = {-1, -1, -1, -1, -1};
    q.push_back(st);
    for (int i = 0; i < q.size(); i++) {
        for (auto p : g[q[i]]) {
            int y = c[p.dx][p.dy];
            if (y >= 0 && !z[y]) {
                z[y] = true;
                pr[y] = p;
                pr2[y] = q[i];
                q.push_back(y);
            }
        }
    }
    if (!z[fn]) {
        cout << "-1 -1";
        return 0;
    }
    vector<portal> path;
    int cur = fn;
    while (cur != st) {
        path.push_back(pr[cur]);
        cur = pr2[cur];
    }
    reverse(path.begin(), path.end());
    curx = stx;
    cury = sty;
    if (st == fn) {
        go_to(fnx, fny);
    } else {
        int wx = -1, wy = -1, wd = -1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (c[i][j] == st) {
                    for (int d = 0; d < 4; d++) {
                        int xx = i + dx[d];
                        int yy = j + dy[d];
                        if (a[xx][yy] == 'W') {
                            wx = i;
                            wy = j;
                            wd = d;
                        }
                    }
                }
            }
        }
        if (wx == -1) {
            cout << "-1 -1";
            return 0;
        }
        go_to(wx, wy);
        port(wd);
        for (auto p : path) {
            go_to(p.sx, p.sy);
            port(p.d);
            go_to(wx, wy);
            string s = "M";
            s += ds[wd];
            res.push_back(s);
            curx = p.dx;
            cury = p.dy;
            wx = curx;
            wy = cury;
            wd = p.d;
        }
        go_to(fnx, fny);
    }

    int c1 = 0;
    int c2 = 0;
    for (string s : res) {
        if (s[0] == 'M') c1++; else c2++;
    }
    cout << c2 << " " << c1 << "\n";
    for (string s : res) {
        cout << s << "\n";
    }

    return 0;
}