#include <iostream>
#include <math.h>
#include <string.h>

using namespace std;

int main()
{
    const int arraySize = 1001;
    int n;
    string * command;
    char * letter;

    char voteLetter[arraySize] = {};
    int voteQueue = 0;

    cin >> n;

    command = new string[n];
    letter = new char[n];

    int addCount = 0;
    int voteCount = 0;

    for(int i = 0; i < n; i++) {
        cin >> command[i] >> letter[i];

        if(command[i] == "Add") {
            addCount++;
        } else {
            voteCount++;
        }

    }

    if (n % 2 == 1 || voteCount != addCount) {
        cout << "No";
        return 0;
    }

    for(int i = 0; i < n; i++) {
        if(command[i] == "Add") {
            voteQueue++;
            voteLetter[voteQueue] = letter[i];
        } else if (voteQueue == 0) {
            cout << "No";
            return 0;
        }

        if(command[i] == "Add") {

            if(i+1 == n) {
                cout << "No";
                return 0;
            }
        }

        if(command[i] == "Vote" && letter[i] == voteLetter[voteQueue]) {
            voteQueue--;
        } else if(command[i] == "Vote" && letter[i] != voteLetter[voteQueue]) {
            cout << "No";
            return 0;
        }


    }

    cout << "Yes";


    return 0;
}
