#include <iostream>
#include <cmath>

using namespace std;

unsigned long mod = pow(10, 9) + 7;

unsigned long power(unsigned long a, unsigned long n)
{
    a = a % mod;
    if (n == 0) return 1;
    if (n % 2 == 0) return power((a * a) % mod, static_cast<unsigned long> (n / 2)) % mod;
    return (a * power((a * a) % mod, static_cast<unsigned long> ((n - 1) / 2))) % mod;
}

int main()
{
    unsigned long k = 26;


    unsigned long n;
    cin >> n;

    if (n < 4) {
        cout << 0 << endl;
        return 0;
    }

    unsigned long sum = 0;
    for (unsigned long l = 4; l <= n; l++) {
        unsigned long t = (power(k, l - 4)%mod * l) % mod;
        sum += t;
        sum = sum % mod;
    }
    cout << sum << endl;
    return 0;
}
