#include <iostream>
#include <vector>
#include<algorithm>

using namespace std;

size_t p = 1000000000 + 7;

struct problem
{
    size_t count_people = 0;
    vector<size_t> v;
};


size_t f(vector<size_t> v)
{
    size_t sum = 0;
    for (auto iter = v.begin(); iter != v.end(); ++iter)
    {
        sum += (((*iter) * (*iter)) % p );
        sum %= p;
    }
    return (v.size() * sum) % p;
}

int main()
{
    size_t P, M, T;
    cin >> P >> T >> M;
    problem * problems = new problem[T];
    size_t man, probl;
    for (size_t i = 0; i < M; i++)
    {
        cin >> man >> probl;
        problems[probl - 1].count_people++;
        problems[probl - 1].v.push_back(man);
    }

    bool zero = false;

    for (size_t i = 0; i < T; i++)
        if (problems[i].count_people == 0) {zero = true; break;}

    if (zero)
    {
        size_t q = 0;
        vector<size_t> vzero;
        for (size_t i = 0; i < T; i++)
            if (problems[i].count_people == 0) vzero.push_back(i + 1);
        cout << P << " " << vzero.size() << "\n";
        for (auto iter = vzero.begin(); iter != vzero.end(); ++iter)
            cout << *iter << " ";
        return 0;
    }


    vector<size_t> HASH;
    vector<size_t> MAPPING;

    size_t Min = problems[0].count_people;
    for (size_t i = 0; i < T; i++)
        if (problems[i].count_people < Min) Min = problems[i].count_people;

    for (size_t i = 0; i < T; i++)
        if (problems[i].count_people == Min)
        {
            HASH.push_back(f(problems[i].v));
            MAPPING.push_back(i);
        }

    vector<size_t> HASH2 = HASH;
    sort(HASH2.begin(), HASH2.end());
    size_t COUNT = 0, a = -1, MAXCOUNT = 0, MAXELEMENT = -1;
    for (auto iter = HASH2.begin(); iter != HASH2.end(); ++iter)
    {
        if (*iter != a) {if (COUNT > MAXCOUNT) {MAXCOUNT = COUNT; MAXELEMENT = a;} a = *iter; COUNT = 1;}
        else COUNT += 1;
    }

    vector<size_t> result_problems;

    for (size_t i = 0; i < HASH.size(); ++i)
    {
        if (HASH[i] == MAXELEMENT) result_problems.push_back(MAPPING[i]);
    }

    cout << P - problems[result_problems[0]].count_people << " " << result_problems.size() << "\n";

    for (auto iter = result_problems.begin(); iter != result_problems.end(); ++iter)
        cout << (*iter) + 1 << " ";
    return 0;
}
