import java.util.ArrayList;
import java.util.Scanner;

public class D {

    static final int H_MAX = 220;
    static final int H_MIN = 190;
    static final int H_AVG = (H_MAX+H_MIN)/2;
    static final int W_MAX = 250;
    static final int W_MIN = 200;
    static final int W_AVG = (W_MAX+W_MIN)/2;
    static final int S_MAX = 20;
    static final int S_MIN = 10;
    static final int S_AVG = (S_MAX+S_MIN)/2;
    static final int T_MAX = 6;
    static final int T_MIN = 2;
    static final int T_AVG = (T_MAX+T_MIN)/2;
    static final int P_MAX = 7;
    static final int P_MIN = 3;
    static final int P_AVG = (P_MAX+P_MIN)/2;

    public static void main(String[] args) {

        byte N = (byte)input();
        byte[] playerCategory = new byte[N];

        ArrayList<Player> players = new ArrayList<>();

        Player thisPlayer;

        boolean d1_1;
        boolean d2_1;
        boolean d2_2;
        boolean d3_1;
        boolean d3_2;
        for(int i = 0; i<N; i++){
            thisPlayer = new Player();

            thisPlayer.inputStats();

            d1_1 = ((thisPlayer.pH>H_MAX)||(thisPlayer.pW>W_MAX))&&(thisPlayer.coutMax()>=3);

            d2_1 = (thisPlayer.coutMax()>=2 && thisPlayer.coutMoreAvg()>=1);
            d2_2 = (thisPlayer.coutMin()==0 && thisPlayer.coutMoreAvg()>=3);

            d3_1 = (thisPlayer.coutMax()>=1 && thisPlayer.coutMoreAvg()>=1);
            d3_2 = (thisPlayer.coutMoreAvg()>=3);

            if(d1_1 == true) {
                playerCategory[i]=0;
            }
            else if(d2_1==true||d2_2==true) {
                playerCategory[i]=1;
            }
            else if(d3_1==true||d3_2==true) {
                playerCategory[i]=2;
            }
            else {
                playerCategory[i]=3;
            }


        }

        for(int i = 0; i<N; i++){
            System.out.println(playerCategory[i]);
        }

    }

    public static long input(){
        Scanner scanner = new Scanner(System.in);
        return scanner.nextLong();
    }

}

class Player {

    public int pH, pW, pS, pT, pP;

    private int draft;

    public void inputStats(){
        pH = ((int)D.input());
        pW = ((int)D.input());
        pS = ((int)D.input());
        pT = ((int)D.input());
        pP = ((int)D.input());
    }

    public int coutMax(){
        int result = 0;
        if (pH>D.H_MAX) result++;
        if (pW>D.W_MAX) result++;
        if (pS>D.S_MAX) result++;
        if (pT>D.T_MAX) result++;
        if (pP>D.P_MAX) result++;
        return result;
    }
    public int coutMoreAvg(){
        int result = 0;
        if (pH>=D.H_AVG) result++;
        if (pW>=D.W_AVG) result++;
        if (pS>=D.S_AVG) result++;
        if (pT>=D.T_AVG) result++;
        if (pP>=D.P_AVG) result++;
        return result;
    }
    public int coutMin(){
        int result = 0;
        if (pH<D.H_MIN) result++;
        if (pW<D.W_MIN) result++;
        if (pS<D.S_MIN) result++;
        if (pT<D.T_MIN) result++;
        if (pP<D.P_MIN) result++;
        return result;
    }


    public int getDraft() {
        return draft;
    }

    public void setDraft(byte draft) {
        this.draft = draft;
    }
}
