#include <iostream>
#include <synchapi.h>
#include <vector>
#include <set>
#include <map>

typedef long long ll;
typedef unsigned long long ull;
using namespace std;
const int MAXN = 1e5 + 7;
const ull P = 1e5 + 7;

#define int long long

vector<int> g[MAXN];

ull bp(ull a, ull p) {
    if (p == 0) return 1;
    if (p & 1) return a * bp(a, p - 1);
    ull b = bp(a, p / 2);
    return (b * b);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int p, t, m; cin >> p >> t >> m;
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        --a, --b;
        g[b].push_back(a);
    }
    int mn = MAXN;
    for (int i = 0; i < t; i++) {
        if (mn > g[i].size()) {
            mn = g[i].size();
        }
    }
    map<ull, int> mp;
    for (int i = 0; i < t; i++) {
        if (g[i].size() != mn) {
            continue;
        }
        ull hs = 0;
        for (int hum_num : g[i]) {
            hs += bp(P,  hum_num);
        }
        mp[hs]++;
    }
    ull m_hs = 0, sz = 0;
    for (auto p : mp) {
        if (p.second > sz) {
            m_hs = p.first;
            sz = p.second;
        }
    }
    vector<int> ans_task;
    for (int i = 0; i < t; i++) {
        ull hs = 0;
        for (int hum_num : g[i]) {
            hs += bp(P,  hum_num);
        }
        if (hs == m_hs) {
            ans_task.push_back(i);
        }
    }
    cout << p - mn << " " << ans_task.size() << "\n";
    for (auto x : ans_task) cout << x + 1 << " ";
    return 0;
}