#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cmath>
#include <stack>
#include <bitset>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define forn(i,n) for(int i=0;i<n;i++)
#define fornr(i,n) for(int i=n-1;i>=0;i--)
#define forab(i,a,b) for(int i=a;i<b;i++)
#define all(v) v.begin(),v.end()
#define sz(v) int(v.size())
#define first fst
#define second snd
#define push_back pb
#define make_pair mp

typedef double dbl;
typedef unsigned long long ull;
typedef long long ll;
typedef vector<int> vi;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    stack<char> s;
    int n;
    cin >> n;
    forn(i, n) {
        string t;
        char x;
        cin >> t >> x;
        if (t == "Add") {
            s.push(x);
        } else {
            if (s.empty() || s.top() != x) {
                cout << "No\n";
                return 0;
            }
            s.pop();
        }
    }
    if (s.empty()) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
    return 0;
}