#include <iostream>
#include <string>
#include <vector>
#include <deque>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

bool comp(const pair < vector <int>, int > & a, const pair < vector <int>, int > & b) {
    for (int i = 0; i < a.first.size(); ++i) {
        if (a.first[i] < b.first[i]) return 1;
        if (a.first[i] > b.first[i]) return 0;
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int p, t, m;
    cin >> p >> t >> m;
    vector<vector<int>> prob(t, vector<int>());

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        prob[b].push_back(a);
    }

    int maxlen = p + 10;
    for (int i = 0; i < t; i++) {
        if (maxlen > prob[i].size()) {
            maxlen = prob[i].size();
        }
    }

    vector<pair<vector<int>, int>> prob2;
    for (int i = 0; i < t; i++) {
        if (maxlen == prob[i].size()) {
            prob2.push_back(pair{prob[i], i+1});
        }
    }

    sort(prob2.begin(), prob2.end(), comp);

    for (auto i : prob2) {
        for (auto j : i.first) {
            cout << j << " ";
        }
        cout << "\n";
    }

    int maxans = 0;
    int maxi = 0;
    int kol = 1;
    for (int i = 1; i <= prob2.size(); i++) {
        if ((i < prob2.size())&&(prob2[i].first == prob2[i-1].first)) {
            kol++;
        } else {
            if (kol > maxans) {
                maxans = kol;
                maxi = i;
            }
        }
    }

//    if (p - prob2[maxi-1].first.size() == 0) {
//        cout << p - prob2[maxi-1].first.size();
//        return 0;
//    }
    cout << p - prob2[maxi-1].first.size() << " " << maxans << "\n";
    for (int i = maxi - maxans; i < maxi; i++) {
        cout << prob2[i].second << " ";
    }

    return 0;
}
/*
5 2 4
1 2
4 2
4 1
5 1


3 3 9
1 1
1 2
1 3
2 1
2 2
2 3
3 1
3 2
3 3

 */