#include <bits/stdc++.h>
using namespace std;
#define pb                     push_back
#define forn(i, a, b)       for(int i=a; i<=b; ++i)
const int N = 1e5 +10;
int P, M, T;
int deg[N];
vector<int> e[N];
bool cmp(int a, int b) {
    int lo = 0, hi = min(e[a].size(), e[b].size()) -1, ans = -1;
    while (lo <= hi) {
        int mid = lo + hi >> 1;
        if (e[a][mid] != e[b][mid]) {
            ans = mid;
            hi = mid-1;
        } else lo = mid+1;
    }
    if (ans == -1) return (e[a].size() < e[b].size());
    return e[a][ans] < e[b][ans];
}
bool equal(int a, int b) {
    if (e[a].size() != e[b].size()) return false;
    int lo = 0, hi = min(e[a].size(), e[b].size()) -1, ans = -1;
    while (lo <= hi) {
        int mid = lo + hi >> 1;
        if (e[a][mid] != e[b][mid]) {
            ans = mid;
            hi = mid-1;
        } else lo = mid+1;
    }
    if (ans == -1) return true;
}
int main() {
    ios::sync_with_stdio(0);
    cin >> P >> T >> M;
    forn(i, 1, M) {
        int u, v; cin >> u >> v;
        e[v].pb(u);
        deg[v] ++;
    }
    int mn = 1e6+1, ind = -1;
    forn(i, 1, T) if (mn > deg[i]) {
        mn = min(mn, deg[i]);
        ind = i;
    }
    forn(i, 1, T) sort(e[i].begin(), e[i].end());
    vector<int> v;
    forn(i, 1, T) v.pb(i);
    sort(v.begin(), v.end(), cmp);
    vector<int> cur_ans;
    for(int i=0; i<v.size(); ++i) {
        int idx = v[i];
        if (deg[idx] != mn) continue;
        vector<int> new_ans;
        new_ans.pb(idx);
        while (i +1 < v.size() && equal(v[i+1], idx)) {
            i ++;
            new_ans.pb(v[i]);
        }
        if (new_ans.size() > cur_ans.size()) cur_ans = move(new_ans);
    }
    cout << P-mn << ' ' << cur_ans.size() << '\n';
    for(auto x: cur_ans) cout << x << ' ';


}
/*
 3 4 6
 1 1
 1 2
 2 2
 2 3
 3 3
 3 4

 3 5 6
 1 1
 1 2
 2 1
 2 3
 3 1
 3 3
 */