#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
#include <fstream>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;


void solve() {
	long long n;
	cin >> n;
	long long cop = n;
	vector<long long> prime;
	for (long long i = 2; i * i <= cop; ++i)
		if (n % i == 0) {
			while (n % i == 0) {
				n /= i;
				prime.push_back(i);
			}
		}
	if (n != 1)
		prime.push_back(n);
	if (prime.size() == 1) {
		cout << prime[0] << endl;
	}
	else {
		if (prime[0] == 2) {
			if (prime[1] == 2) {
				if (cop % 3 == 0) {
					cout << 3 << endl;
				}
				else
					cout << 4 << endl;
			}
			else
				cout << prime[1];
		}
		else
			cout << prime[0];
	}
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n = 1;
	//cin >> n;
	while (n--) {
		solve();
	}
}