#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
#include <map>
#include <fstream>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;
const int INF = 1e9;
const ll MOD = (ll)(1e9 + 7) * 625ll;

ll binpow(ll a, ll x) {
	if (x == 0) return 1;
	if (x % 2 == 1) {
		return (a * binpow(a, x - 1)) % MOD;
	}
	else {
		ll b = binpow(a, x / 2) % MOD;
		return (b * b) % MOD;
	}
}
void solve() {
	ll n;
	cin >> n;
	if (n <= 3ll) {
		cout << 0;
		return;
	}
	cout << (((binpow(26, n - 3ll) * (25ll * n - 1ll) % MOD - 74) % MOD) / 625ll) % (ll)(1e9 + 7ll);
}

void solve1() {
	string n;
	cin >> n;
	if (n == "1" || n == "2" || n == "3" || n == "5" || n == "7") {
		cout << -1 << endl;
		return;
	}
	if (n == "4" || n == "6" || n == "8") {
		cout << "10 2" << endl;
		return;
	}
	if (n == "9") {
		cout << "10 3" << endl;
		return;
	}
	int sum = 0;
	for (int i = 0; i < n.length(); ++i)
		sum += n[i] - '0';
	if (sum == 1) {
		cout << "10 2" << endl;
		return;
	}
	cout << sum + 1 << " " << sum << endl;
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n = 1;
	//cin >> n;
	while (n--) {
		solve1();
	}
}