#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
#include <map>
#include <fstream>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;
const int INF = 1e9;
const ll MOD = (ll)(1e9 + 7);

ll binpow(ll a, ll x) {
	if (x == 0) return 1;
	if (x % 2 == 1) {
		return (a * binpow(a, x - 1)) % MOD;
	}
	else {
		ll b = binpow(a, x / 2) % MOD;
		return (b * b) % MOD;
	}
}
void solve() {
	ll n;
	cin >> n;
	if (n <= 3ll) {
		cout << 0;
		return;
	}
	cout << (((binpow(26, n - 3ll) * (25ll * n - 1ll) % MOD - 74) % MOD) * 571200004ll) % (ll)(1e9 + 7ll);
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n = 1;
	//cin >> n;
	while (n--) {
		solve();
	}
}