#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>

using namespace std;

unordered_set<int> taskCnt[131072];
vector<int> pipToTask[131072];
int pipCnt[131072];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int p, t, m;
    cin >> p >> t >> m;
    int taskTarget = 1 << 20;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        pipToTask[--x].push_back(--y);
        taskCnt[y].insert(x);
    }

    for (int i = 0; i < t; i++) {
        taskTarget = min((int) taskCnt[i].size(), taskTarget);
    }

    vector<unordered_set<int>> sets;
    for (int i = 0; i < t; i++) {
        if (taskCnt[i].size() == taskTarget) {
            sets.push_back(taskCnt[i]);
            for (int k : taskCnt[i]) {
                pipCnt[k]++;
            }
        }
    }

    int ansTasks = taskTarget;

    for (int i = 0; i < p; i++) {
        if ((t - pipCnt[i]) < ansTasks) {
            for (int k : pipToTask[i]) {
                taskCnt[k].erase(i);
            }
        }
    }

    int target = 1 << 20;

    for (auto i : sets) {
        target = min((int) i.size(), target);
    }

    int ansPip = p - target;
    cout << ansPip << " ";
    int i = 0;
    unordered_set<int> trg;
    vector<int> ans;
    for (; i < t; i++) {
        if (taskCnt[i].size() == target) {
            ans.push_back(i + 1);
            i++;
            break;
        }
    }
    for (; i < t; i++) {
        if (taskCnt[i].size() == target) {
            if (taskCnt[i] == trg) {
                ans.push_back(i + 1);
            }
        }
    }
    cout << ans.size() << endl;
    for (auto k : ans)
        cout << k << " ";
    return 0;
}