
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <climits>

using namespace std;



int main() {

    ios_base::sync_with_stdio(false);

    int p, t, m;
    cin >> p >> t >> m;

    vector< pair<int, int> >cnt(t, make_pair(0, 0));
    for(int i=0;i<t;i++) cnt[i].second = i;
    set<int>s[t];
    for(int i=0;i<m;i++){
        int a,b;
        cin >> a >> b;
        a--; b--;
        s[b].insert(a);
        cnt[b].first++;
    }

    sort(cnt.begin(), cnt.end());

    int ans_p = p - cnt[0].first, ans_t = 0;

    map<set<int>, int>set_cnt;
    set<int>ans_set;
    int max_set = 0;
    for(int i = 0;i < t; i++){
        if(cnt[i].first > cnt[0].first) break;
        set_cnt[s[cnt[i].second]]++;
        if(set_cnt[s[cnt[i].second]] > max_set){
            max_set = set_cnt[s[cnt[i].second]];
            ans_set = s[cnt[i].second];
        }
    }
    cout << ans_p << " " << max_set << endl;
    for(int i=0;i < t;i++){
        if(cnt[i].first > cnt[0].first) break;
        if(s[cnt[i].second] == ans_set){
            cout << cnt[i].second + 1 << " ";
        }
    }

	return 0;
}
