#include <iostream>
#include <cstdio>
#include <algorithm>
#include <fstream>
#include <vector>
#include <cstring>
#include <cmath>
#include <bitset>
#include <map>

/** Typedefs */
using namespace std;

#define mp make_pair;
#define fi first;
#define se second;
typedef long long LL;
typedef long double LD;
#define INF 1e19;
#define S_MOD 1000000007

LL pow_26(LL n) {
    if (n < 7) {
        return (LL) pow(26, n);
    }
    if (n % 2 == 0) {
        LL s = pow_26(n / 2);
        return (s * s) % S_MOD;
    }
    LL s = pow_26((n - 1) / 2);
    return (((s * s) % S_MOD) * 26) % S_MOD;
}

void solve() {
   LL N;

   cin >> N;

   if (N < 4) {
       cout << 0;
       return;
   }

//   cout << (LL) pow(26, N) << "\n";
//   cout << pow_26(N - 3) << "\n";
//   cout << ((((25 * N - 1) % S_MOD * pow_26(N - 3)) % S_MOD - 74) / 625);
   LL ans = 0;
    for (int i = 4; i <= N; i++) {
        ans = (ans + (i * pow_26(i - 4)) % S_MOD) % S_MOD;
    }
    cout << "\n" << ans;

}
int main() {
    ios_base::sync_with_stdio(false);

//    freopen("a.in", "r", stdin);
//    freopen("a.out", "w", stdout);

    solve();
    return 0;
}
