#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <set>
#include <string>
#include <deque>
#include <stack>
#include <queue>

#define MP make_pair
#define PB push_back
#define F first
#define S second
#define EPS 1e-7
#define MOD 1000000007

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long double ld;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int x;
    vector<int> cnt(n + 1);
    for (int i = 0; i < n; i++){
        cin >> x;
        if (--x < n)
            cnt[x]++;
    }
    int ans = 0;
    for (int i=0; i<n; i++) {
        if (cnt[i])
            ans++;
    }
    cout << ans;

    return 0;
}