#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <set>
#include <string>
#include <deque>
#include <stack>
#include <queue>

#define MP make_pair
#define PB push_back
#define F first
#define S second
#define EPS 1e-7
#define MOD 1000000007

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long double ld;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    stack<char> st;
    int k;
    cin >> k;
    for (int i = 0; i < k; i++) {
        string d;
        char c;
        cin >> d >> c;
        if (d[0] == 'A')
            st.push(c);
        else {
            if (st.empty() || st.top() != c) {
                cout << "No";
                return 0;
            }
            st.pop();
        }
    }
    if (st.empty())
        cout << "Yes";
    else
        cout << "No";
    return 0;
}