#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <stack>
#include <queue>

using namespace std;
using ll=long long;

ll n = 2e8;


int main() {
	ios::sync_with_stdio(0);
	int n; cin >> n;
	vector<int> mn = { 190, 200, 10, 2, 3 };
	vector<int> mx = { 220, 250, 20, 6, 7 };

	auto pol = [&](int l, int r, int c) {
		if (c < l) return 0;
		int mid = (l + r + 1) / 2;
		if (c < mid) return 1;
		if (c <= r) return 2;
		return 3;
	};
	auto get = [&](vector<int> a) {
		vector<int> res(5);
		for (int i = 0; i < 5; i++) res[i] = pol(mn[i], mx[i], a[i]);
		vector<int> cnt(4);
		for (int i = 0; i < 4; i++)
			for (auto x : res)
				cnt[i] += x >= i;
		if (cnt[3] >= 3 && max(res[0], res[1]) == 3)
			return 0;
		if ((cnt[3] == 2 && cnt[2] >= 3) || (cnt[1] == 5 && cnt[2] >= 3))
			return 1;
		if ((cnt[3] == 1 && cnt[2] >= 2) || (cnt[2] >= 3))
			return 2;
		return 3;
	};
	while (n--) {
		vector<int> a(5);
		for (auto& x : a) cin >> x;
		cout << get(a) << endl;
	}

}