#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <stack>
#include <queue>

using namespace std;
using ll=long long;

ll n = 2e8;
const ll mod = 1e9 + 7;

ll binpow(ll x, ll n) {
	if (n == 0) return 1;
	ll q = binpow(x, n / 2);
	ll res = q * q; res %= mod;
	if (n % 2)
		res *= x;
	res %= mod;
	return res;
}
ll mul(ll a, ll b) {
	return (a * b) % mod;
}
ll divv(ll a, ll b) {
	return mul(a, binpow(b, mod - 2));
}

int main() {
	ios::sync_with_stdio(0);
	ll n; cin >> n;
	if (n < 4) {
		cout << 0;
		return 0;
	}
	ll a = mul(25, n) - 1; a += mod; a %= mod;
	a = mul(a, binpow(26, n)) + 1; a %= mod;
	a = divv(a, 5 * 5 * 5 * 5);
	a -= (1 + 2 * 26 + 3 * 26 * 26); a += 2 * mod; a %= mod;

	a += mod; a %= mod;


	cout << divv(a, 26 * 26 * 26);

}