#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <stack>
#include <queue>
#include <wtypes.h>

using namespace std;
using ll=long long;
long long  N = 2e6;
vector<long long > ch(N);
long long  num = 1;

vector<vector<long long >> g(N, vector<long long >(26,-1));
vector<long long > countt(N, 0);
vector<long long > deg(N, 0);
vector<string>  word(N,"");
vector<long long > endd(N,0);
vector<long long > parent(N, -1);



void dfs(long long  u) {
	for (auto v : g[u]) {
		if (v != -1) {
			parent[v] = u;
			dfs(v);
			countt[u] += countt[v];
			
		}
	}
}

int  main() {
	ios::sync_with_stdio(0);
	long long  n;
	cin >> n;
	for (long long  i = 0; i < n; i++) {
		string s;
		cin >> s;
		word[i] = s;
		long long  u = 0;
		long long  j = 0;
		while (j < s.size()) {
			if (g[u][s[j]-'a'] == -1)
			{
				g[u][s[j]-'a'] = num;
				num++;
			}
			u = g[u][s[j]-'a'];
			
			j++;
		}
		endd[i] = u;
		countt[u]++;

	}
	dfs(0);
	long long  t;
	cin >> t;
	vector<long long > ans(t,-1);
	vector<vector<pair<long long , long long >>> kek(N);
	for (long long  i = 0; i < t; i++) {
		long long  w, k;
		cin >> w >> k;
		--w;
		kek[w].push_back({ k,i });
	}
	for (long long  i = 0; i < n; i++) {
		long long  u = endd[i];
		vector<long long > r = { countt[u] };
		while (u != 0) {
			long long  newu = parent[u];
			long long  h = countt[newu] - countt[u];
			r.push_back(h);
			u = newu;
		}
		reverse(r.begin(), r.end());
		vector<long long > pref(r.size() + 1);
		pref[0] = 0;
		for (long long  j = 0; j < r.size(); j++) {
			pref[j + 1] = pref[j] + r[j];
		}
		for (auto p : kek[i]) {
			long long  t = 1;
			long long  k = p.first;
			long long  j = 1;
			long long  curans = 0;
			long long  cursum = 0;
			while (cursum< pref[r.size()]) {
				t++;
				long long  newj = lower_bound(pref.begin(), pref.end(), k+cursum) - pref.begin();
				if (newj < r.size() + 1) {
					curans += k;
					if (t == newj)
						cursum = pref[newj];
					else
						cursum += k;
				}
				else {
					curans +=min(pref[r.size()] - cursum,k);
					cursum = pref[r.size()];

				}
				j = newj;
				
			}
			ans[p.second] = curans;
		}
	}
	for (auto a : ans) cout << a << '\n';
}