import java.io.*;
import java.util.*;

public class A {
	
	FastScanner in;
	PrintWriter out;

	public void solve() {
		int n = in.nextInt();
		Stack<Character> st = new Stack<>();
		for (int i = 0; i < n; i++) {
			if (in.next().charAt(0) == 'A') {
				st.add(in.next().charAt(0));
			} else {
				char c = in.next().charAt(0);
				if (st.isEmpty() || st.peek() != c) {
					out.print("No");
					return;
				}
				st.pop();
			}
		}
		if (st.isEmpty()) {
			out.print("Yes");
		} else {
			out.print("No");
		}
	}
	
	public void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		
		solve();
		
		out.close();
	}
	
	class FastScanner {
		StringTokenizer st;
		BufferedReader in;
		
		FastScanner() {
			in = new BufferedReader(new InputStreamReader(System.in));
		}
		
		String nextLine() {
			try {
				return in.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return null;
		}
		
		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(in.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
		
		long nextLong() {
			return Long.parseLong(next());
		}
		
		double nextDouble() {
			return Double.parseDouble(next());
		}
		
		boolean nextBoolean() {
			return Boolean.parseBoolean(next());
		}
	}
	
	public static void main(String[] args) {
		new A().run();
	}

}
