import java.io.*;
import java.util.*;

public class A {
	
	FastScanner in;
	PrintWriter out;

	public void solve() {
		long n = in.nextLong();
		long ans = n;
		if (ans <= 5) {
			out.print(ans);
			return;
		}
		if (ans % 2 == 0) {
			ans /= 2;
		}
		for (long i = 3; i * i <= n; i++) {
			if (n % i == 0) {
				ans = Math.min(ans, i);
			}
		}
		out.print(ans);
	}
	
	public void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		
		solve();
		
		out.close();
	}
	
	class FastScanner {
		StringTokenizer st;
		BufferedReader in;
		
		FastScanner() {
			in = new BufferedReader(new InputStreamReader(System.in));
		}
		
		String nextLine() {
			try {
				return in.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return null;
		}
		
		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(in.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
		
		long nextLong() {
			return Long.parseLong(next());
		}
		
		double nextDouble() {
			return Double.parseDouble(next());
		}
		
		boolean nextBoolean() {
			return Boolean.parseBoolean(next());
		}
	}
	
	public static void main(String[] args) {
		new A().run();
	}

}
