import java.io.*;
import java.util.*;

public class A {
	
	FastScanner in;
	PrintWriter out;

	public void solve() {
		String s = in.next();
		if (s.length() == 1) {
			if (s.equals("1") || s.equals("2") || s.equals("3") || s.equals("5") || s.equals("7")) {
				out.print(-1);
			} else {
				if (s.equals("4") || s.equals("6") || s.equals("8")) {
					out.print("10 2");
				} else {
					out.print("10 3");
				}
			}
			return;
		}
		int n = s.length();
		if ((s.charAt(n - 1) - '0') % 2 == 0) {
			out.print("10 2");
			return;
		}
		if ((s.charAt(n - 1) - '0') != 1) {
			out.print((s.charAt(n - 1) - '0') * 10 + " " + (s.charAt(n - 1) - '0'));
			return;
		}
		long sum = 0;
		for (int i = 0; i < s.length(); i++) {
			sum += s.charAt(i) - '0';
		}
		out.print((sum + 1) + " " + sum);
	}
	
	public void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		
		solve();
		
		out.close();
	}
	
	class FastScanner {
		StringTokenizer st;
		BufferedReader in;
		
		FastScanner() {
			in = new BufferedReader(new InputStreamReader(System.in));
		}
		
		String nextLine() {
			try {
				return in.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return null;
		}
		
		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(in.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
		
		long nextLong() {
			return Long.parseLong(next());
		}
		
		double nextDouble() {
			return Double.parseDouble(next());
		}
		
		boolean nextBoolean() {
			return Boolean.parseBoolean(next());
		}
	}
	
	public static void main(String[] args) {
		new A().run();
	}

}
