#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;

const int mod = 1000 * 1000 * 1000 + 7;

int up(int a, int n) {
    int res = 1;
    for (ll now = a; n; now = (now * now) % mod, n >>= 1) {
        if (n & 1) res = (res * now) % mod;
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    if (n < 4) {
        cout << 0 << '\n';
        return 0;
    }

    ll ans = 0;
    n -= 3;

    ans = (ans + up(26, n + 1) * 1ll * n) % mod;
    ans = (ans - up(26, n) * 1ll * (n + 1));
    ans = (ans + 1) % mod;
    if (ans < 0) ans += mod;

    ans = (ans * 1ll * up(25 * 25, mod - 2)) % mod;

    ll add = up(26, n) - 1;
    add = (add * up(25, mod - 2)) % mod;
    ans += add * 3;

    ans %= mod;
    if (ans < 0) ans += mod;
    cout << ans << '\n';


    return 0;
}