#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

template <typename T> smin(T &a, const T&b) { a = (a < b ? a : b); }
template <typename T> smax(T &a, const T&b) { a = (a > b ? a : b); }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

int solve();

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
ordered_set q;

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef HOME
        freopen("in", "r", stdin);
      freopen("out", "w", stdout);
    #endif
    solve();
    return 0;
}

const ll M = (int)1e9 + 7;

ll bp(ll t, ll st)
{
    if (st == 0)
        return 1;
    ll res = bp(t, st / 2);
    return (((ll)res * res) % M * (st & 1 ? t : 1)) % M;
}

int solve()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector <vector <int>> g(m + 1);
    for (int i = 0; i < k; i++)
    {
        int u, v;
        cin >> u >> v;
        g[v].push_back(u);
    }

    map<vector <int>, vector <int>> table;

    int cur = n + 1;
    for (int i = 1; i <= m; i++)
    {
        smin(cur, (int)g[i].size());
        sort(all(g[i]));
        table[g[i]].push_back(i);
    }
    int ans = 0;
    for (auto &i : table)
        if (i.first.size() == cur && ans < i.second.size())
        {
            ans = i.second.size();
        }
    cout << n - cur << " " << ans << "\n";
    for (auto &i : table)
        if (i.first.size() == cur && ans == i.second.size())
        {
            for (int j : i.second)
                cout << j << " ";
            break;
        }

    return 0;
}
