#include <bits/stdc++.h>

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()
#define sz(a) (int) (a).size()

using namespace std;
using ll = long long;
using ld = long double;
const int BUBENN = 1e7;
const int BUBENN2 = 15000;
const int BUBENNLOGN = 1e5;
const int BUBENN3 = 500;
const int MOD = 1e9 + 7;

/*ll mpow(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1)
            res = 1LL * res * a % MOD;
        a = 1LL * a * a % MOD;
        p >>= 1;
    }
    return res;
}*/

struct Item {
    int lastX, lastY, type, portX, portY, nap, napP, toP;
};
struct Hod {
    int first, second, cnt;
};

Item last[1100][1100];
int dp[1100][1100];
int near[4][1100][1100];
int dd[4][2] = {{0, 1}, {1, 0}, {-1, 0}, {0, -1}};
char decd[4] = {'R', 'D', 'U', 'L'};

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0); cin.tie(0);
    cout.precision(20); cout << fixed;
    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    vector<char> ob(400);
    ob['R'] = 'L';
    ob['L'] = 'R';
    ob['U'] = 'D';
    ob['D'] = 'U';
    for(string &e : v) cin >> e;
    for(int i = 0; i < n; i++) {
        int cur = n;
        for(int j = n - 1; j >= 0; j--) {
            if (v[i][j] == 'W') cur = j - 1;
            near[0][i][j] = cur;
        }
    }
    for(int j = n - 1; j >= 0; j--) {
        int cur = n;
        for(int i = n - 1; i >= 0; i--) {
            if (v[i][j] == 'W') cur = i - 1;
            near[1][i][j] = cur;
        }
    }
    for(int j = n - 1; j >= 0; j--) {
        int cur = 0;
        for(int i = 0; i < n; i++) {
            if (v[i][j] == 'W') cur = i + 1;
            near[2][i][j] = cur;
        }
    }
    for(int i = 0; i < n; i++) {
        int cur = 0;
        for(int j = 0; j < n; j++) {
            if (v[i][j] == 'W') cur = j + 1;
            near[3][i][j] = cur;
        }
    }
    int si, sj, ei, ej;
    cin >> si >> sj >> ei >> ej;
    si--;sj--;ei--;ej--;
    deque<Hod> q;
    q.push_back({si, sj, 1});
    dp[si][sj] = 1;
    last[si][sj] = {-1, -1, -1, -1, -1, -1, -1, -1};
    while(!q.empty()) {
        auto p = q.front();
        q.pop_front();
        if(dp[p.first][p.second] != p.cnt) continue;
        for(int i = 0; i < 4; i++) {
            int ti = p.first + dd[i][0];
            int tj = p.second + dd[i][1];
            if(ti >= 0 && tj >= 0 && ti < n && tj < n && (!dp[ti][tj] || dp[p.first][p.second] < dp[ti][tj]) && v[ti][tj] == '.') {
                last[ti][tj] = {p.first, p.second, 0, 0, 0, i, 0, 0};
                dp[ti][tj] = dp[p.first][p.second];
                q.push_front({ti, tj, dp[ti][tj]});
            }
        }
        if(dp[p.first][p.second] == 1) {
            for(int i = 0; i < 4; i++) {
                int bi = p.first + dd[i][0];
                int bj = p.second + dd[i][1];
                if(bi >= 0 && bj >= 0 && bi < n && bj < n && v[bi][bj] == 'W') {
                    for(int j = 0; j < 4; j++) {
                        int ti = p.first + dd[j][0];
                        int tj = p.second + dd[j][1];
                        if(j == 1 || j == 2) {
                            ti = near[j][p.first][p.second];
                        }
                        else {
                            tj = near[j][p.first][p.second];
                        }
                        if(ti >= 0 && tj >= 0 && ti < n && tj < n && (!dp[ti][tj] || dp[p.first][p.second] + 1 < dp[ti][tj]) && v[ti][tj] == '.') {
                            last[ti][tj] = {p.first, p.second, 1, bi, bj, j, i, decd[j]};
                            dp[ti][tj] = dp[p.first][p.second] + 1;
                            q.push_back({ti, tj, dp[ti][tj]});
                        }
                    }
                }
            }
        } else {
            for(int j = 0; j < 4; j++) {
                int ti = p.first + dd[j][0];
                int tj = p.second + dd[j][1];
                if(j == 1 || j == 2) {
                    ti = near[j][p.first][p.second];
                }
                else {
                    tj = near[j][p.first][p.second];
                }
                if(ti >= 0 && tj >= 0 && ti < n && tj < n && (!dp[ti][tj] || dp[p.first][p.second] + 1 < dp[ti][tj]) && v[ti][tj] == '.') {
                    last[ti][tj] = {p.first, p.second, 2, 0, 0, j, 0, decd[j]};
                    dp[ti][tj] = dp[p.first][p.second] + 1;
                    q.push_back({ti, tj, dp[ti][tj]});
                }
            }
        }
    }
    if(dp[ei][ej] == 0) {
        cout << -1 << " " << -1;
    }
    else {
        int otDob = 0;
        if(dp[ei][ej] == 1) cout << 0 << " ";
        else
        {
            cout << dp[ei][ej] << " ";
            otDob = dp[ei][ej];
        }
        vector<pair<int, int>> h;
        while(ei != -1 && ej != -1) {
            h.push_back({ei, ej});
            Item p = last[ei][ej];
            ei = p.lastX;
            ej = p.lastY;
        }
        reverse(h.begin(), h.end());
        vector<string> ans;
        int lastPos, lastX, lastY;
        bool flag = true;
        for(int i = 1; i < h.size(); i++) {
            int x = h[i].first;
            int y = h[i].second;
            string s = "AA";
            if(last[x][y].type == 0) {
                s[0] = 'M';
                s[1] = decd[last[x][y].nap];
                ans.push_back(s);
            }
            else if(last[x][y].type == 1) {
                s[0] = 'O';
                s[1] = decd[last[x][y].napP];
                ans.push_back(s);
                s[0] = 'B';
                s[1] = decd[last[x][y].nap];
                ans.push_back(s);
                s[0] = 'M';
                s[1] = decd[last[x][y].napP];
                ans.push_back(s);
                lastPos = ans.size() - 1;
                lastX = x;
                lastY = y;
            }
            else if(last[x][y].type == 2) {
                if(flag) {
                    s[0] = 'O';
                    flag = false;
                }
                else {
                    s[0] = 'B';
                    flag = true;
                }
                s[1] = decd[last[x][y].nap];
                ans.push_back(s);
                for(int j = ans.size() - 2; j > lastPos; j--) {
                    s[0] = 'M';
                    s[1] = ob[ans[j][1]];
                    ans.push_back(s);
                }
                s[0] = 'M';
                s[1] = last[lastX][lastY].toP;
                ans.push_back(s);
                lastX = x;
                lastY = y;
                lastPos = ans.size() - 1;
            }
        }
        cout << ans.size() - otDob << endl;
        for(string i : ans) cout << i << "\n";
    }
}
