#ifdef local
#define _GLIBCXX_DEBUG
#define _GLIBCXX_DEBUG_PEDANTIC
#endif // local
#include<bits/stdc++.h>
#define all(x) begin(x), end(x)
#define sz(x) ((int)(x).size())
using namespace std;
using ll  = long long;
int inf = 1e9 + 10;


int main()
{
#ifdef local
    assert(freopen("in.txt", "r", stdin));
#endif // local
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int P, T, m; cin >> P >> T >> m;
    map<int, vector<int>> mp;
    for (int i = 1; i <= T; ++i) mp[i];
    for (int i = 0; i < m; ++i) {
        int x, y; cin >> x >> y; //--x, --y;
        mp[y].push_back(x);
    }
    int mindeg = inf;
    for (auto &p : mp) mindeg = min(mindeg, sz(p.second));
    map<vector<int>, vector<int>> vs;
    for (auto &p : mp) {
        if (sz(p.second) != mindeg) continue;
        sort(all(p.second));
        vs[p.second].push_back(p.first);
    }
    int mxs = 0;
    for (auto &p : vs) mxs = max(mxs, sz(p.second));
    for (auto &p : vs) {
        if (sz(p.second) == mxs) {
            cout << P - mindeg << ' ' << sz(p.second) << '\n';
            for (int x : p.second) cout << x << ' ';
            return 0;
        }
    }
}
