#ifdef local
#define _GLIBCXX_DEBUG
#define _GLIBCXX_DEBUG_PEDANTIC
#endif // local
#include<bits/stdc++.h>
#define all(x) begin(x), end(x)
using namespace std;
using ll  = long long;
using ld = long double;
const ll mod = 1000000007;
struct line {
    ld k, m;
    ld x;

    line(ld x0, ld y0, ld x1, ld y1) {
       k = (y1 - y0) / (x1 - x0);
       m = y0 - k * x0;
    }
};
ld intersect(line a, line b) {
    return (a.m - b.m) / (b.k - a.k);
}

pair<int,int> pt[200003];
int main()
{
#ifdef local
    assert(freopen("in.txt", "r", stdin));
#endif // local
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int x,y,k;
    cin >> x >> y >> k;
    int xl = 0,xr = x ;
    for(int i=  0;i < k;i++) {
        cin >> pt[i].first >> pt[i].second;
    }
    vector<line> up,down;
    for(int i = 1;i<k;i++) {
        if(pt[i].second == pt[0].second) {
            if(pt[i].first < pt[0].first) {
                xl  =max(xl,(pt[0].first + pt[i].first + 1) / 2);
            }
            else {
                xr = min(xr, (pt[0].first + pt[i].first) / 2);
            }
            continue;
        }
        line l(0.5 * (pt[i].first + pt[0].first) ,
               0.5 * (pt[i].second + pt[0].second),
               0.5 * (pt[i].first + pt[0].first) + pt[i].second - pt[0].second,
               0.5 * (pt[i].second + pt[0].second) + pt[0].first - pt[i].first
               );
        if(pt[i].second > pt[0].second ) {
            up.push_back(l);
        }
        else {
            down.push_back(l);
        }
    }
    sort(down.begin(),down.end(),[](line a,line b){return a.k < b.k;});
    sort(up.begin(),up.end(),[](line a,line b){return a.k > b.k;});
    vector<line> ou,od;
    for(auto l : up) {
        if(ou.empty()) {
            l.x = -1e18;
            ou.push_back(l);
        }
        else{
            if(abs(ou.back().k - l.k) < 1e-9) {
                if(l.m < ou.back().m) {
                    ou.pop_back();
                }
                else {
                    continue;
                }
            }
            while(ou.size() > 1 && ou.back().x > intersect(l,ou[ou.size() - 2])) {
                ou.pop_back();
            }
            if(!ou.empty()) {
                l.x = intersect(ou.back(),l);
            }
            ou.push_back(l);
        }
    }
    for(auto l : down) {
        if(od.empty()) {
            l.x = -1e18;
            od.push_back(l);
        }
        else{
            if(abs(od.back().k - l.k) < 1e-9) {
                if(l.m > od.back().m) {
                    od.pop_back();
                }
                else {
                    continue;
                }
            }
            while(od.size() > 1 && od.back().x > intersect(l,od[od.size() - 2])) {
                od.pop_back();
            }
            if(!od.empty()) {
                l.x = intersect(od.back(),l);
            }
            od.push_back(l);
        }
    }
    int p1 = 0,p2 = 0;
    ll ans = 0;
//    cout << xl << ' '<< xr << endl;
    for(int i = xl;i <=xr;i++) {
        while(p1 + 1 < ou.size() && ou[p1 + 1].x < i) {
            p1++;
        }
        while(p2 + 1 < od.size() && od[p2 + 1].x < i) {
            p2++;
        }
        int y1,y2;
        if(ou.empty()) {
            y1 = y;
        }
        else {
            y1 = (int)(min(y * 1.0L + 1e-6,floor(ou[p1].k * i + ou[p1].m + 1e-6)));
        }
        if(od.empty()) {
            y2 = 0;
        }
        else {
            y2 = (int)(max(0.0L,ceil(od[p1].k * i + od[p1].m - 1e-6)));
        }
        ans +=max(0,y1 - y2 + 1);
    }
    cout << ans;
}
