#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

/**
ll gcd(ll a, ll b) {
	return (b ? gcd(b, a % b) : a);
}

template <typename T>
T sqr(T a) {
	return a * a;
}

class point {
public:
	ld x, y;

	ld dist(point a, point b) {
		return sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
	}
};

//
vector<int> t, tADD, a;

void build(int v, int vl, int vr) {
	if (vl == vr) {
		t[v] = a[vl];
		return;
	}
	int vm = (vl + vr) / 2;
	build(2 * v, vl, vm);
	build(2 * v + 1, vm + 1, vr);
	t[v] = t[2 * v] + t[2 * v + 1];
}

int sum(int v, int vl, int vr, int l, int r) {
	if ((vr < l) || (r < vl)) {
		return 0;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return t[v];
		}
		else {
			int vm = (vl + vr) / 2;
			return sum(2 * v, vl, vm, l, r) + sum(2 * v + 1, vm + 1, vr, l, r);
		}
	}
}

void modify(int v, int vl, int vr, int l, int r, int x) {
	if ((vr < l) || (r < vl)) {
		return;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return;
		}
		else {
			int vm = (vl + vr) / 2;
			return;
		}
	}
}

//
*/

int main() {
	/*
	int p, t, m;
	cin >> p >> t >> m;
	vector <pair <bool, pair <int, int> > > a(m);
	vector <int> count_task(t, 0);
	vector <int> answer;
	for (int i = 0; i < m; i++) {
		a[i].first = true;
		cin >> a[i].second.first >> a[i].second.second;
		a[i].second.first--, a[i].second.second--;
		count_task[a[i].second.second]++;
	}
	int minimal = 1e9, marked_task = -1;
	for (int i = 0; i < t; i++) {
		if (minimal > count_task[i]) {
			minimal = count_task[i];
			marked_task = i;
		}
	}
	for (int i = 0; i < m; i++) {
		if (marked_task == a[i].second.second) {
			a[i].first = false;
		}
	}
	vector <int> people(p, 0);
	for (int i = 0; i < m; i++) {
		if (!a[i].first) people[a[i].second.first] = 1;
	}
	count_task.clear();
	count_task.resize(t);
	for (int i = 0; i < m; i++) {
		if (a[i].first && !people[a[i].second.first]) count_task[a[i].second.second]++;
	}
	for (int i = 0; i < t; i++) {
		if (!count_task[i]) answer.push_back(i);
	}
	int sum = -0;
	for (int i = 0; i < p; i++) {
		sum += (1 - people[i]);
	}
	cout << sum << ' ' << answer.size() << endl;
	for (int i = 0; i < answer.size(); i++) cout << answer[i] + 1 << ' ';
	return 0;
	*/
	string str;
	cin >> str;
	if (str == "1") {
		cout << -1;
		return 0;
	}
	if (str.length() < 6) {
		cout << str << " " << 2;
		return 0;
	}
	if ((str[str.length() - 1] - '0') % 2 == 0) {
		cout << 10 << " " << 2;
		return 0;
	}
	cout << 11 << " " << 2;
	return 0;
}