#include <bits/stdc++.h>

using namespace std;

const int mod = 1e9 + 7;

int add(int a, int b) {
  return a + b - mod * (a + b >= mod);
}

int mul(int a, int b) {
  return int(1ll * a * b % mod);
}

int power(int a, int x) {
  if (x == 0) {
    return 1;
  } else if (x & 1) {
    return mul(power(mul(a, a), x / 2), a);
  } else {
    return power(mul(a, a), x / 2);
  }
}

int divide(int a, int b) {
  return mul(a, power(b, mod - 2));
}

int sub(int a, int b) {
  return a - b + mod * (a < b);
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0), cout.tie(0);

  int n;
  cin >> n;
  if (n < 4) {
    cout << 0;
    return 0;
  } else if (n == 4) {
    cout << 4;
    return 0;
  }
  int ans = mul(n - 4, power(26, n - 3));
  ans = sub(ans, 26);
  int kek = mul(26 * 26, power(26, n - 5) - 1);
  kek = divide(kek, 25);
  ans = sub(ans, kek);
  ans = divide(ans, 25);
  ans = add(ans, mul(4, divide(power(26, n - 3) - 1, 25)));
  cout << ans;

  return 0;
}