import java.io.*;
import java.util.*;

public class I {
    class Reader {
        BufferedReader in;

        Reader() throws IOException {
            in = new BufferedReader(new InputStreamReader(System.in), 10000000);
        }

        StringTokenizer tok = new StringTokenizer("");

        String next() throws IOException {
            if (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    class Writer {
        PrintWriter out;

        Writer() throws IOException {
            out = new PrintWriter(System.out);
        }

        StringBuilder str = new StringBuilder();

        void print(Object o) {
            str.append(o);
        }

        void close() throws IOException {
            out.write(str.toString());
            out.close();
        }
    }

    LinkedList<Integer> ans = new LinkedList<>();


    long p = 107;

    long mod = 1000000007;


    long hash(LinkedList<Integer> list) {
        long hsh = 0;
        for (int a : list) {
            hsh = (hsh * p + a) % mod;
        }
        return hsh;
    }


    void solve() throws IOException {
        Reader in = new Reader();
        Writer out = new Writer();
        int P = in.nextInt();
        int t = in.nextInt();
        int m = in.nextInt();
        LinkedList<Integer> a[] = new LinkedList[t + 1];
        int num = 0;
        for (int i = 1; i < t + 1; i++) {
            a[i] = new LinkedList<>();
        }
        for (int i = 0; i < m; i++) {
            int p0 = in.nextInt();
            int t0 = in.nextInt();
            if (a[t0].size() == 0)
                num++;
            a[t0].add(p0);
        }
        if (num < t) {
            out.print(P + " " + (t - num) + "\n");
            for (int i = 1; i <= t; i++) {
                if (a[i].size() == 0) {
                    out.print(i + " ");
                }
            }
        } else {
            int mn = Integer.MAX_VALUE;
            HashMap<Long, LinkedList<Integer>> map = new HashMap<>();
            for (int i = 1; i < t + 1; i++) {
                mn = Math.min(mn, a[i].size());
            }
            for (int i = 1; i < t + 1; i++) {
                if (a[i].size() == mn) {
                    Collections.sort(a[i]);
                    long has = hash(a[i]);
                    if (!map.containsKey(has)) {
                        map.put(has, new LinkedList<>());
                    }
                    map.get(has).add(i);
                    if (ans.size() < map.get(has).size()) {
                        ans = map.get(has);
                    }
                    //add(a.get(t0), t0);
                }
            }
            out.print((P - mn) + " " + (ans.size()));
            out.print("\n");
            Collections.sort(ans);
            for (int v : ans) {
                out.print(v + " ");
            }
        }
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new I().solve();
    }
}