#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <chrono>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

vector <char> s;

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		string q;
		char w;
		cin >> q >> w;
		if (q[0] == 'A')
			s.push_back(w);
		else {
			if (s.empty())
				return cout << "No", 0;
			char z = s.back();
			s.pop_back();
			if (z != w)
				return cout << "No", 0;
		}
	}
	if (!s.empty())
		return cout << "No", 0;
	cout << "Yes";

	return 0;
}