
#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <chrono>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	ll n;
	cin >> n;
	ll ans = n;
	if (n % 2 == 0 && n > 4)
		ans = n / 2;
	for (ll i = 3; i * i <= n; i++) {
		if (n % i == 0) {
			return cout << i, 0;
		}
	}
	cout << ans;

	return 0;
}