#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

vector<pair<int, int>> bounds = {
        {190, 220},
        {200, 250},
        {10, 20},
        {2, 6},
        {3, 7}
};

void solve() {
    int n; cin >> n;
    vector<vector<int>> A(n, vector<int>(5));
    for (auto &i: A) {
        cin >> i[0] >> i[1] >> i[2] >> i[3] >> i[4];
        vector<int> type(5);
        for (int j = 0; j < 5; ++j) {
            if (i[j] < bounds[j].first) {
                type[j] = 0;
            } else if (i[j] < (bounds[j].first + bounds[j].second) / 2) {
                type[j] = 1;
            } else if (i[j] <= bounds[j].second) {
                type[j] = 2;
            } else {
                type[j] = 3;
            }
        }

        if (count(type.begin(), type.end(), 3) >= 3 && (type[0] == 3 || type[1] == 3)) {
            cout << "0\n";
        } else if ((count(type.begin(), type.end(), 3) >= 3 || (count(type.begin(), type.end(), 3) == 2 && count(type.begin(), type.end(), 2) >= 1)) ||
                (*min_element(type.begin(), type.end()) >= 1 && (count(type.begin(), type.end(), 3) + count(type.begin(), type.end(), 2)) >= 3)) {
            cout << "1\n";
        } else if ((count(type.begin(), type.end(), 3) >= 2 || (count(type.begin(), type.end(), 3) == 1 && count(type.begin(), type.end(), 2) >= 1)) ||
                (count(type.begin(), type.end(), 2) + count(type.begin(), type.end(), 3) >= 3)) {
            cout << "2\n";
        } else {
            cout << "3\n";
        }
    }
}