#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

const int PRIME = 10000;

mt19937 rnd('V' + 'R' + 'I');
int B = (int)1e7;

bool isprime(int x) {
    for (ll i = 2; i * i <= x; ++i) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

vector<int> xs = {5, 7, 11, 13, 17, 19, 23 };

void solve() {
    string n;
    cin >> n;
    //n = "9" + string(1000000, '6') + "11";
    if (n == "1" || n == "3" || n == "2" || n == "5" || n == "7") {
        cout << "-1\n";
        return;
    }
    if (n == "9") {
        cout << "10 3\n";
        return;
    }
    if ((n.back() - '0') % 2 == 0) {
        cout << "10 2\n";
        return;
    }
    if ((n.back() - '0') != 1) {
        cout << (n.back() - '0') * 4 << " " << (n.back() - '0') << "\n";
        return;
    }

    int sum = 0;
    for (int i = 0; i < (int)n.size() - 1; ++i) {
        sum += n[i] - '0';
    }
    if (sum % 2 == 1) {
        cout << "11 2\n";
        return;
    }
    if (sum% 3 != 0) {
        xs.push_back(3);
    }

    while (true) {
        while (!isprime(B)) {
            ++B;
        }
        int  pw = 1;
        for (int &x : xs) {
            int md = 0;
            for (int i = (int)n.size() - 1; i >= 0; --i) {
                md += (n[i] - '0') * pw % x;
                if (md >= x) {
                    md -= x;
                }
                pw *= B;
                pw %= x;
            }
            if (md == 0) {
                cout << B << " " << x << "\n";
                return;
            }
        }
        ++B;
        err("%d\n", B);
    }
}