#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

const int dd = (int)2e5 + 7;

vector<int> G[dd], G1[dd];

void solve() {
    int P, T, M;
    cin >> P >> T >> M;
    for (int i = 0; i < M; ++i) {
        int a, b;
        cin >> a >> b;
        G[--b].push_back(--a);
        G1[b].push_back(a);
    };
    sort(G1, G1 + T, [](auto const &i, auto const &j) {
        if (i.size() != j.size()) {
            return i.size() < j.size();
        }
        return i < j;
    });
    int cnt = 0, mx = -1;
    int ans = -1;
    for (int i = 0; i < T; ++i) {
        if (!i || G1[i] == G1[i - 1]) {
            ++cnt;
        } else {
            if (cnt > mx) {
                mx = cnt;
                ans = i - 1;
            }
            cnt = 1;
        }
    }
    if (cnt > mx) {
        mx = cnt;
        ans = T - 1;
    }
    cout << (P - (int)G1[ans].size()) << " " << mx << "\n";
    for (int i = 0; i < T; ++i) {
        if (G[i] == G1[ans]) {
            cout << i + 1 << " ";
        }
    }
    cout << "\n";
}