n = int(input())


def simplify_param(lowerbound, upperbound, n):
    if n < lowerbound:
        return -1
    if n > upperbound:
        return 2
    mid = (lowerbound + upperbound) // 2
    if lowerbound <= n < mid:
        return 0
    if mid <= n < upperbound:
        return 1
    return None


def count_higher(data):
    return len([i for i in data if i == 2])


def count_lower(data):
    return len([i for i in data if i == -1])


def count_lowerhalf(data):
    return len([i for i in data if i == 0])


def count_upperhalf(data):
    return len([i for i in data if i == 1])


def count_in_range(data):
    return len([i for i in data if i == 1 or i == 0])


def category2(data):
    return (count_higher(data) >= 1 and count_upperhalf(data) >= 1) or count_upperhalf(data) >= 3


def category1(data):
    return (count_higher(data) >= 2 and count_upperhalf(data) >= 1) or (count_in_range(data) >= 5 and count_upperhalf(data) >= 3)


def category0(data):
    h = data[0]
    w = data[1]
    return (count_higher(data) >= 3) and (h == 2 or w == 2)


def qualify(data):
    if category0(data):
        return 0
    if category1(data):
        return 1
    if category2(data):
        return 2
    return 3


athletes = []


for _ in range(n):
    h = simplify_param(190, 220, int(input()))
    w = simplify_param(200, 250, int(input()))
    s = simplify_param(10, 20, int(input()))
    r = simplify_param(2, 6, int(input()))
    p = simplify_param(3, 7, int(input()))
    data = [h, w, s, r, p]
    cat = qualify(data)
    print(cat)
