#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define DEBUG cout << "JOPA";
#define len(x) int(x.size())
#define all(x) x.begin(), x.end()

void fastread(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
const int M = 1e9+7;

ll fs(ll n, ll k){
    if (k==1){
        return n;
    }
    if (k==0){
        return 1;
    }
    if (k%2==0){
        ll d = fs(n, k/2)%M;
        return (d * d)%M;
    }
    else{
        return (fs(n, k-1)*n)%M;
    }
}

ll C1(ll k){
    return (((26*(fs(26, k)-1))%M)*fs(25, M-2))%M;
}

ll C2(ll k, ll s){
    ll sum = 0;
    for (ll i=0;i<k;i++){
        sum += ((i+s)*fs(26, i))%M;
        sum=sum%M;
    }
    return sum;
}

ll R(ll k){
    return (C1(k) + C2(k, 0))%M;
}

const int radix[201] = {11, 12, 13, 15, 17, 18, 19, 21, 23, 26, 29, 30, 31, 34, 37, 39, 41, 42, 43, 45, 47, 50, 53, 56, 59, 60, 61, 64, 67, 69, 71, 72, 73, 76, 79, 81, 83, 86, 89, 93, 97, 99, 101, 102, 103, 105, 107, 108, 109, 111, 113, 120, 127, 129, 131, 134, 137, 138, 139, 144, 149, 150, 151, 154, 157, 160, 163, 165, 167, 170, 173, 176, 179, 180, 181, 186, 191, 192, 193, 195, 197, 198, 199, 205, 211, 217, 223, 225, 227, 228, 229, 231, 233, 236, 239, 240, 241, 246, 251, 254, 257, 260, 263, 266, 269, 270, 271, 274, 277, 279, 281, 282, 283, 288, 293, 300, 307, 309, 311, 312, 313, 315, 317, 324, 331, 334, 337, 342, 347, 348, 349, 351, 353, 356, 359, 363, 367, 370, 373, 376, 379, 381, 383, 386, 389, 393, 397, 399, 401, 405, 409, 414, 419, 420, 421, 426, 431, 432, 433, 436, 439, 441, 443, 446, 449, 453, 457, 459, 461, 462, 463, 465, 467, 473, 479, 483, 487, 489, 491, 495, 499, 501, 503, 506, 509, 515, 521, 522, 523, 532, 541, 544, 547, 552, 557, 560, 563, 566, 569, 570, 571};

int main()
{
    #ifdef HOME
    freopen("input.txt", "rt", stdin);
    #endif // HOME
    fastread();
    string n;
    int k=0;
    cin >>n;
    if (n == "1" || n=="2" || n=="3"||n=="5"||n=="7"){
        cout <<-1;
        return 0;
    }
    if (n=="4" || n=="6" || n=="8"){
        cout <<"10 2";
        return 0;
    }
    if (n == "9"){
        cout <<"10 3";
        return 0;
    }
    if ((n[len(n) - 1] - '0')%2==0){
        cout <<"10 2";
        return 0;
    }
    for (int i=0;i<len(n)-1;i++){
        if ((n[i] - '0')%2!=0)
            k++;
    }
    if (k%2!=0){
        cout <<"11 2";
        return 0;
    }
    int x = (n[len(n) - 1] - '0');
    if (x ==3 || x == 9){
        cout <<"12 3";
        return 0;
    }
    if (x == 5){
        cout <<"15 5";
        return 0;
    }
    if (x == 7){
        cout <<"14 7";
        return 0;
    }
    int i = 0;
    while(i < 201 && clock() < CLOCKS_PER_SEC * 1.92) {
        int f = radix[i++];
        for (int x = 3; x < f; x++) {
            int sum = 0;
            for (int j = 0; j < len(n); j++) {
                sum = sum * f + (n[j] - '0');
                sum %= x;
            }
            if (sum % x == 0) {
                cout << f << ' ' << x;
                return 0;
            }
        }
    }
    cout << -1;
    return 0;
}
