#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define DEBUG cout << "JOPA";
#define len(x) int(x.size())
#define all(x) x.begin(), x.end()

void fastread(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
const int M = 1e9+7;

ll fs(ll n, ll k){
    if (k==1){
        return n;
    }
    if (k==0){
        return 1;
    }
    if (k%2==0){
        ll d = fs(n, k/2)%M;
        return (d * d)%M;
    }
    else{
        return (fs(n, k-1)*n)%M;
    }
}

ll C1(ll k){
    return (((26*(fs(26, k)-1))%M)*fs(25, M-2))%M;
}

ll C2(ll k, ll s){
    ll sum = 0;
    for (ll i=0;i<k;i++){
        sum += ((i+s)*fs(26, i))%M;
        sum=sum%M;
    }
    return sum;
}

ll R(ll k){
    return (C1(k) + C2(k, 0))%M;
}

const int radix[201] = {11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997, 1009, 1013, 1019, 1021, 1031, 1033, 1039, 1049, 1051, 1061, 1063, 1069, 1087, 1091, 1093, 1097, 1103, 1109, 1117, 1123, 1129, 1151, 1153, 1163, 1171, 1181, 1187, 1193, 1201, 1213, 1217, 1223, 1229, 1231, 1237, 1249, 1259};

int main()
{
    #ifdef HOME
    freopen("input.txt", "rt", stdin);
    #endif // HOME
    fastread();
    string n;
    int k=0;
    cin >>n;
    if (n == "1" || n=="2" || n=="3"||n=="5"||n=="7"){
        cout <<-1;
        return 0;
    }
    if (n=="4" || n=="6" || n=="8"){
        cout <<"10 2";
        return 0;
    }
    if (n == "9"){
        cout <<"10 3";
        return 0;
    }
    if ((n[len(n) - 1] - '0')%2==0){
        cout <<"10 2";
        return 0;
    }
    for (int i=0;i<len(n)-1;i++){
        if ((n[i] - '0')%2!=0)
            k++;
    }
    if (k%2!=0){
        cout <<"11 2";
        return 0;
    }
    int x = (n[len(n) - 1] - '0');
    if (x ==3 || x == 9){
        cout <<"12 3";
        return 0;
    }
    if (x == 5){
        cout <<"15 5";
        return 0;
    }
    if (x == 7){
        cout <<"14 7";
        return 0;
    }
    int i = 0;
    while(i < 201 && clock() < CLOCKS_PER_SEC * 1.59) {
        int f = radix[i++];
        for (int x = 3; x < f; x++) {
            int sum = 0;
            for (int j = 0; j < len(n); j++) {
                sum = sum * f + (n[j] - '0');
                sum %= x;
            }
            if (sum % x == 0) {
                cout << f << ' ' << x;
                return 0;
            }
        }
    }
    cout << -1;
    return 0;
}
