#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define F first
#define S second

using namespace std;

pair<int, int> HEIGHT = {190, 220};
pair<int, int> WINGSPAN = {200, 250};
pair<int, int> SCORE = {10, 20};
pair<int, int> NUMBER = {2, 6};
pair<int, int> CHANGES = {3, 7};


struct Player {
    Player(int h, int w, int s, int n, int c) : height(h), wingspan(w), score(s), number(n), changes(c) {}

    int height; // ????
    int wingspan; // ??????
    int score; // ?? ????
    int number; // ?? ????? ????????
    int changes; // ?? ???????
};

bool inside(int x, pair<int, int> a) {
    return x >= a.first && x <= a.second;
}

bool lower(int x, pair<int, int> a) {
    return x < a.first;
}

bool lessHalf(int x, pair<int, int> a) {
    int c = (a.second + a.first) / 2 + (a.second + a.first) % 2;
    return x < c && x >= a.first;
}

bool greaterHalf(int x, pair<int, int> a) {
    int c = (a.second + a.first) / 2 + (a.second + a.first) % 2;
    return x >= c && x <= a.second;
}


bool better(int x, pair<int, int> a) {
    return x > a.second;
}


bool isUnicorn(Player *p) {
    if (better(p->height, HEIGHT) || better(p->wingspan, WINGSPAN)) {
        int res = (int) better(p->changes, CHANGES) +
                  (int) better(p->score, SCORE) +
                  (int) better(p->number, NUMBER) +
                  (int) better(p->height, HEIGHT) +
                  (int) better(p->wingspan, WINGSPAN);
        return res >= 3;
    }
    return false;
}

bool firstCategoryF(Player *p) {
    int f = (int) better(p->changes, CHANGES) +
            (int) better(p->score, SCORE) +
            (int) better(p->number, NUMBER) +
            (int) better(p->height, HEIGHT) +
            (int) better(p->wingspan, WINGSPAN);
    if (f >= 2) {
        if (f >= 3)return true;
        int s = (int) greaterHalf(p->changes, CHANGES) +
                (int) greaterHalf(p->score, SCORE) +
                (int) greaterHalf(p->number, NUMBER) +
                (int) greaterHalf(p->height, HEIGHT) +
                (int) greaterHalf(p->wingspan, WINGSPAN);
        return s >= 1;
    }

    return false;
}

bool firstCategoryS(Player *p) {
    int f = (int) (inside(p->height, HEIGHT) || better(p->height, HEIGHT)) +
            (int) (inside(p->wingspan, WINGSPAN) || better(p->wingspan, WINGSPAN)) +
            (int) (inside(p->score, SCORE) || better(p->score, SCORE)) +
            (int) (inside(p->number, NUMBER) || better(p->number, NUMBER)) +
            (int) (inside(p->changes, CHANGES) || better(p->changes, CHANGES));

    int s = (int) (greaterHalf(p->changes, CHANGES) || better(p->changes, CHANGES)) +
            (int) (greaterHalf(p->score, SCORE) || better(p->score, SCORE)) +
            (int) (greaterHalf(p->number, NUMBER) || better(p->number, NUMBER)) +
            (int) (greaterHalf(p->height, HEIGHT) || better(p->height, HEIGHT)) +
            (int) (greaterHalf(p->wingspan, WINGSPAN) || better(p->wingspan, WINGSPAN));
    return f == 5 && s >= 3;
}

bool secondCategoryF(Player *p) {
    int f = (int) better(p->changes, CHANGES) +
            (int) better(p->score, SCORE) +
            (int) better(p->number, NUMBER) +
            (int) better(p->height, HEIGHT) +
            (int) better(p->wingspan, WINGSPAN);
    int s = (int) (greaterHalf(p->changes, CHANGES) || better(p->changes, CHANGES)) +
            (int) (greaterHalf(p->score, SCORE) || better(p->score, SCORE)) +
            (int) (greaterHalf(p->number, NUMBER) || better(p->number, NUMBER)) +
            (int) (greaterHalf(p->height, HEIGHT) || better(p->height, HEIGHT)) +
            (int) (greaterHalf(p->wingspan, WINGSPAN) || better(p->wingspan, WINGSPAN));
    return f >= 1 && s >= 2;
}

bool secondCategoryS(Player *p) {
    int s = (int) (greaterHalf(p->changes, CHANGES) || better(p->changes, CHANGES)) +
            (int) (greaterHalf(p->score, SCORE) || better(p->score, SCORE)) +
            (int) (greaterHalf(p->number, NUMBER) || better(p->number, NUMBER)) +
            (int) (greaterHalf(p->height, HEIGHT) || better(p->height, HEIGHT)) +
            (int) (greaterHalf(p->wingspan, WINGSPAN) || better(p->wingspan, WINGSPAN));
    return s >= 3;
}

void getAns(Player *p) {
    if (isUnicorn(p))cout << 0 << endl;
    else if (firstCategoryF(p) || firstCategoryS(p))cout << 1 << endl;
    else if (secondCategoryF(p) || secondCategoryS(p))cout << 2 << endl;
    else cout << 3 << endl;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("a.in", "r", stdin);

    int n;
    cin >> n;


    for (int i = 1; i <= n; ++i) {
        int h, w, s, r, p;
        cin >> h >> w >> s >> r >> p;

        Player ppp = Player(h, w, s, r, p);
        getAns(&ppp);
    }


    return 0;
}