#include <iostream>

using namespace std;

int32_t min_h = 190;
int32_t max_h = 220;
int32_t mid_h = (min_h + max_h) / 2;
int32_t min_w = 200;
int32_t max_w = 250;
int32_t mid_w = (min_w + max_w) / 2;
int32_t min_s = 10;
int32_t max_s = 20;
int32_t mid_s = (min_s + max_s) / 2;
int32_t min_r = 2;
int32_t max_r = 6;
int32_t mid_r = (min_r + max_r) / 2;
int32_t min_p = 3;
int32_t max_p = 7;
int32_t mid_p = (min_p + max_p) / 2;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    size_t n;
    cin >> n;

    for (size_t i = 0; i < n; ++i) {
        int32_t h, w, s, r, p;
        cin >> h >> w >> s >> r >> p;

        int c3 = 0;
        if (h > max_h) ++c3;
        if (w > max_w) ++c3;
        if (s > max_s) ++c3;
        if (r > max_r) ++c3;
        if (p > max_p) ++c3;

        if (c3 >= 3 && (h > max_h || w > max_w)) {
            cout << "0\n";
            continue;
        }

        int c2 = 0;
        if (mid_h <= h) ++c2;
        if (mid_w <= w) ++c2;
        if (mid_s <= s) ++c2;
        if (mid_r <= r) ++c2;
        if (mid_p <= p) ++c2;

        int c1 = 0;
        if (min_h <= h) ++c1;
        if (min_w <= w) ++c1;
        if (min_s <= s) ++c1;
        if (min_r <= r) ++c1;
        if (min_p <= p) ++c1;

        if ((c3 >= 2 && c2 >= 1) || (c1 >= 5 && c2 >= 3)) {
            cout << "1\n";
            continue;
        }

        if ((c3 >= 1 && c2 >= 1) || (c2 >= 3)) {
            cout << "2\n";
            continue;
        }

        cout << "3\n";
    }
}