#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>
#include <cmath>
#include <unordered_set>

using namespace std;

#define int long long

const int INF = 1e18 + 9;
const int MOD = 1e9 + 9;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	
	stack<char> st;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		char c;
		cin >> c;
		if (s == "Add") {
			st.push(c);
		}
		else {
			if (!st.empty() && st.top() == c) {
				st.pop();
			}
			else {
				cout << "No";
				return 0;
			}
		}
	}
	if (!st.empty()) {
		cout << "No";
	}
	else {
		cout << "Yes";
	}

	return 0;
}