#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(239);

#define X first
#define x first
#define Y second
#define y second
#define pb push_back
#define ob pop_back
#define mp make_pair
#define eb emplace_back
#define char unsigned char
#define sz(x) ((int)((x).size()))

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<ld> vd;
typedef vector<bool> vb;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef vector<vi> vvi;

template<typename T>
istream& operator>>(istream &in, vector<T> &v)
{
    for (int i = 0; i < sz(v); i++)
        in >> v[i];
    return in;
}

template<typename T, typename S>
istream& operator>>(istream &in, pair<T, S> &v)
{
    in >> v.first >> v.second;
    return in;
}

template<typename T, typename S>
pair<T, S> operator+(const pair<T, S>& a, const pair<T, S>& b)
{
    return mp(a.first + b.first, a.second + b.second);
}

template<typename T, typename S>
pair<T, S> operator-(const pair<T, S>& a, const pair<T, S>& b)
{
    return mp(a.first - b.first, a.second - b.second);
}

struct Node
{
    int way[26];
    vector <int> spis;
};

struct triple
{
    int k, prev, next;
    triple(int a = 0, int b = 0, int c = 0) {k = a, prev = b, next = c;}
    bool operator < (const triple &a) const
    {
        return (k < a.k) || (k == a.k && prev < a.prev) ||
                (k == a.k && prev == a.prev && next < a.next);
    }
};

Node bor[400005];
int sz[400005], deep[400005], parent[400005];
int konec[200005], answer[200005];
int prevs[400005], nexts[400005], zapr[200005];
set <triple> opa;
vector <int> mas[200005];

void dfs(int v)
{
    for (int i = 0; i < 26; i++)
    {
        int u = bor[v].way[i];
        if (u != 0)
        {
            deep[u] = deep[v] + 1;
            dfs(u);
            sz[v] += sz[u];
        }
    }
    for (int i = 0; i < (int) bor[v].spis.size(); i++)
    {
        int u = bor[v].spis[i];
        deep[u] = deep[v] + 1;
        dfs(u);
        sz[v] += sz[u];
    }
    return;
}

void build_tree(int v, int pr, int val)
{
    if (pr == -1)
    {
        for (int i = 0; i < 26; i++)
        {
            int u = bor[v].way[i];
            if (u != 0) build_tree(u, v, sz[v]);
        }
        for (int i = 0; i < (int) bor[v].spis.size(); i++)
        {
            int u = bor[v].spis[i];
            build_tree(u, v, sz[v]);
        }
        return;
    }

    if (sz[v] <= val)
    {
        nexts[pr] = v;
        prevs[v] = pr;
        opa.insert(triple((sz[pr] - sz[v]) / (deep[v] - deep[pr]), pr, v));
    }
    else
    {
        parent[v] = pr;
    }

    for (int i = 0; i < 26; i++)
    {
        int u = bor[v].way[i];
        if (u != 0)
        {
            if (val < sz[v]) build_tree(u, pr, val);
            else build_tree(u, v, sz[v]);
        }
    }
    for (int i = 0; i < (int) bor[v].spis.size(); i++)
    {
        int u = bor[v].spis[i];
        if (val < sz[v]) build_tree(u, pr, val);
        else build_tree(u, v, sz[v]);
    }
    return;
}

int find_parent(int v)
{
    if (v == parent[v]) return v;
    return parent[v] = find_parent(parent[v]);
}

int main()
{
#ifdef ONPC
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, quant = 1;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        string s;
        cin >> s;
        int tek = 1;
        for (int j = 0; j < (int) s.length(); j++)
            if (bor[tek].way[s[j] - 'a'] != 0) tek = bor[tek].way[s[j] - 'a'];
            else
            {
                quant++;
                bor[tek].way[s[j] - 'a'] = quant;
                tek = quant;
            }
        quant++;
        bor[tek].spis.pb(quant);
        tek = quant;
        konec[i] = tek;
        sz[tek]++;
    }
    dfs(1);
    for (int i = 1; i <= quant; i++) parent[i] = i;
    for (int i = 1; i <= quant; i++) prevs[i] = -1, nexts[i] = -1;
    for (int i = 0; i < 26; i++)
        if (bor[1].way[i] != 0)
            build_tree(bor[1].way[i], -1, -1);

    int quer;
    cin >> quer;
    for (int i = 1; i <= quer; i++)
    {
        int k;
        cin >> zapr[i] >> k;
        mas[k].pb(i);
    }
    for (int i = 1; i <= n; i++)
    {
        while (!opa.empty() && (*opa.begin()).k < i)
        {
            triple A = *opa.begin();
            opa.erase(opa.begin());
            int v = A.prev;
            parent[A.next] = A.prev;
            if (nexts[A.next] != -1)
            {
                int u = nexts[A.next];
                nexts[v] = u;
                prevs[u] = v;
                opa.insert(triple((sz[v] - sz[u]) / (deep[u] - deep[v]),
                                   v, u));
            }
            else
            {
                nexts[v] = -1;
            }
        }
        for (int j = 0; j < (int) mas[i].size(); j++)
        {
            int num = mas[i][j];
            int par = find_parent(konec[zapr[num]]);
            answer[num] = (deep[par] - 1) * i + sz[par];
            if (par == konec[zapr[num]]) answer[num] -= sz[par];
        }
    }
    for (int i = 1; i <= quer; i++) cout << answer[i] << '\n';
    return 0;
}

// IMP IS IOI & ISAF27 IS HSE (CHSV)

// HA SOSITE CHMOSHNIKI S TRANSLYAZII
