#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

const int mod = 10e9 + 7;
const int p = 239;




int hashcode(vector<int> &v, int i) {
    if (i == 0)
        return -1;
    if (i == 1) {
        return v[0];
    }
    return ((ll) p*hashcode(v, i - 1) + v[i - 1]) % mod;
}

int main() {

    int p, t, m; cin >> p >> t >> m;

    vector<vector<int>> tasks(t, vector<int>(0));
    vector<pair<int, pair<int, int>>> tasks1(t);

    int peop, task;

    for (int i = 0; i < m; i++) {
        cin >> peop >> task;
        tasks[task - 1].push_back(peop);
    }

//    cout << "\n-----------" << "\n";
//    for (int i = 0; i < tasks.size(); i++) {
//        cout << "\n" << i << ")" << " ";
//        for (int j = 0; j < tasks[i].size(); j++) {
//            cout << tasks[i][j] << " ";
//        }
//    }
//    cout << "\n-----------" << "\n";

    for (int i = 0; i < t; i++) {
        tasks1[i].first = tasks[i].size();
        tasks1[i].second.first = hashcode(tasks[i], tasks[i].size());
        tasks1[i].second.second = i;
    }

    sort(tasks1.begin(), tasks1.end());

//    cout << "\n";
//    for (int i = 0; i < tasks1.size(); i++) {
//        cout << tasks1[i].first << " " << tasks1[i].second.first << "\n";
//    }



    int min_size = tasks1[0].first;
    int h = tasks1[0].second.first;
    int mh = tasks1[0].second.first;
    int i = 0;
    int cnt = 0;
    int max_cnt = 0;
    vector<int> ans;
    while (i < tasks1.size() && tasks1[i].first == min_size) {
        while (i < tasks1.size() && tasks1[i].first == min_size && tasks1[i].second.first == h) {
            i++;
            cnt++;
        }
        if (cnt > max_cnt) {
            max_cnt = cnt;
            mh = h;
        }
        cnt = 0;
        h = tasks1[i].second.first;
    }


    for (int j = 0; j < tasks1.size(); j++) {
        if (tasks1[j].first == min_size && tasks1[j].second.first == mh) {
            ans.push_back(tasks1[j].second.second + 1);
        }
    }

    //cout << "\n-----------\n";
    cout << p - min_size << " " << ans.size() << "\n";
     for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] << " ";
    }


    return 0;
}
