#include <iostream>
#include <vector>
#include <stack>

using namespace std;

#define ll long long
#define ull unsigned ll

#define MOD 1000000

int main()
{
	ull n;
	cin >> n;

	vector <bool> primes(MOD + 2, true);
	for (int i = 2; i * i < MOD + 2; i++)
	{
		if (primes[i] == false)
			continue;

		if (n % i == 0)
		{
			cout << i;
			system("pause");
			return 0;
		}

		for (int j = i * i; j < MOD + 2; j += i)
			primes[j] = false;
	}
	
	cout << n;
	system("pause");
	return 0;
}