#include <iostream>
#include <vector>
#include <stack>

using namespace std;

#define ll long long
#define ull unsigned ll

#define MOD 1000000

int main()
{
	ull n;
	cin >> n;

	if (n % 3 != 0 && n % 4 == 0)
	{
		cout << 4;
		system("pause");
		return 0;
	}

	vector <bool> primes(MOD + 2, true);
	for (ull i = 2; i * i < MOD + 2; i++)
	{
		if (primes[i] == false)
			continue;

		if (n % i == 0 && i != 2)
		{
			cout << i;
			system("pause");
			return 0;
		}

		for (ull j = i * i; j < MOD + 2; j += i)
			primes[j] = false;
	}
	
	cout << n;
	system("pause");
	return 0;
}