#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

#define ll long long
#define ull unsigned ll


struct Sv
{
	int player;
	int task;
	Sv(int a, int b)
	{
		player = a;
		task = b;
	}
};

bool cmp1(Sv A, Sv B)
{
	return A.player < B.player;
}

int main()
{

	int P, M, T;
	cin >> P >> T >> M;
	
	vector<Sv> Adj;
	vector<int> useP(P + 1, 0);
	for (int i = 0; i < M; i++)
	{
		int a, b;
		cin >> a >> b;
		Adj.push_back(Sv(a, b));
		useP[a] = 1;
	}
	sort(Adj.begin(), Adj.end(), cmp1);
	
	int fullP = 0;
	int pl = 0;
	int c = 0;
	for (int i = 0; i < Adj.size(); i++)
	{
		if (Adj[i].player > pl)
		{
			if (c == T)
			{
				fullP++;
				useP[pl] = 0;
			}
			pl = Adj[i].player;
			c = 0;
		}
		c++;
	}
	vector<int> use(T+1);
	for (int i = 0; i < M; i++)
	{
		use[Adj[i].task] = 1;
	}

	c = 0;
	for (int i = 1; i < use.size(); i++)
	{
		if (use[i] == 0)
			c++;
	}
	if (c > 0)
	{
		cout << P- fullP << " " << c << "\n";
		for (int i = 1; i < use.size(); i++)
		{
			if (use[i] == 0)
				cout << i << " ";
		}
	}
	else
	{
		int plMax = 1;
		int count = -1;
		for (int i = 1; i <= P; i++)
		{
			vector<int> used(T+1,0);
			if (useP[i] == 1)
			{
				for (int j = 0; j < M; j++)
				{
					if (Adj[j].player != i)
					{
						used[Adj[j].task] = 1;
					}
				}
			}
			int cnt = 0;
			for (int j = 1; j < used.size(); j++)
			{
				if (used[j] == 0)
					cnt++;
			}
			if (cnt > count)
			{
				plMax = i;
				count = cnt;
			}
		}

		cout << P - fullP - 1 << " " << count << "\n";
		vector<int> useAns(T + 1, 0);
		for (int i = 0; i < M; i++)
		{
			if (Adj[i].player != plMax)
			{
				useAns[Adj[i].task] = 1;
			}
		}
		for (int j = 1; j < useAns.size(); j++)
		{
			if (useAns[j] == 0)
				cout << j << " ";
		}

	}

	//system("pause");
	return 0;
}
/*
3 4 6
1 1
1 2
2 2
2 3
3 3
3 4
*/