#include <iostream>
#include <set>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stack>

using namespace std;

int main() {
#define int long long
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	stack <string> st;
	string ans = "Yes";
	for (int i = 0; i < n; ++i) {
		string op, par;
		cin >> op >> par;
		if (ans == "No") {
			continue;
		}
		if (op == "Vote") {
			if (st.empty()) {
				ans = "No";
				continue;
			}
			if (st.top() == par) {
				st.pop();
			}
			else {
				ans = "No";
				continue;
			}
		}
		else {
			st.push(par);
		}
	}
	if (!st.empty()) {
		ans = "No";
	}
	cout << ans;
	return 0;
}