#include <iostream>
#include <set>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stack>
#include <bitset>
#include <map>

using namespace std;

#define int long long
 
const int md = 1e9 + 7;

int bin_pow(int a, int n) {
	if (n == 0) {
		return 1;
	}

	if (n % 2 == 0) {
		int t = bin_pow(a, n / 2);
		return (t * t) % md;
	}
	else {
		int t = bin_pow(a, n / 2);
		return ((a * t) % md) * t % md;
	}
}

#undef int
int main() {
#define int long long
	int ans = 0;

	int n;
	cin >> n;
	if (n < 4) {
		cout << 0;
		return 0;
	}
	ans += 25 * bin_pow(26, n);
	ans %= md;
	ans *= n;
	ans %= md;



	ans -= bin_pow(26, n);
	while (ans < 0) {
		ans += md;
	}
	ans -= 1300624;
	while (ans < 0) {
		ans += md;
	}

	int z = bin_pow(10985000, md - 2); 
	ans *= z;
	ans %= md;
	cout << ans;
	return 0;
}