#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())
#define ALL(v) v.begin(), v.end()
#define SZ(x) szof(x)
#define TYPEMAX(T) std::numeric_limits<T>::max()
#define TYPEMIN(T) std::numeric_limits<T>::min()

using namespace std;
typedef pair<int, int> pii;
typedef long long ll;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll l, ll r) {
	return ll_distr(tw) % (r - l + 1) + l;
}

template <typename T>
T input() {
	T res; cin >> res; return res;
}

template <typename IT>
void input_seq(IT a, IT b) {
	generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

const int mod = 1000 * 1000 * 1000 + 7;

int mult(int a, int b) {
	return (int64_t(a) * b) % mod;
}

int sub(int a, int b) {
	return (a >= b ? a - b : mod + a - b);
}

int fpow(int a, int n, int r = 1) {
	while (n) {
		if (n % 2)
			r = mult(r, a);
		
		a = mult(a, a);
		n /= 2;
	}
	
	return r;
}

int inv(int a) {
	return fpow(a, mod - 2);
}

int get_sum(int n) {
	int inv25 = inv(25);
	
	int rs = sub(mult(n, fpow(26, n+1)), mult(26, mult(inv25, sub(fpow(26, n), 1))));
	
	return mult(inv25, rs);
}

void solve() {
	int n = input<int>();
	
	if (n <= 3) {
		cout << 0 << "\n";
	} else {
		auto inv26 = inv(26 * 26 * 26 * 26);
		auto ans = mult(inv26, sub(get_sum(n), get_sum(3)));
		cout << ans << "\n";
	}
}

int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(5) << fixed;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cout << setprecision(15) << fixed;
	
	solve();
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "time: " << (end_time - start_time) * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}