#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())
#define ALL(v) v.begin(), v.end()
#define SZ(x) szof(x)
#define TYPEMAX(T) std::numeric_limits<T>::max()
#define TYPEMIN(T) std::numeric_limits<T>::min()

using namespace std;
typedef pair<int, int> pii;
typedef long long ll;
typedef unsigned long long ull;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll l, ll r) {
	return ll_distr(tw) % (r - l + 1) + l;
}

template <typename T>
T input() {
	T res; cin >> res; return res;
}

template <typename IT>
void input_seq(IT a, IT b) {
	generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

void solve() {
	int p, t, m;
	cin >> p >> t >> m;
	vector<vector<int>> graph(t);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		graph[v].push_back(u);
	}
	int best = INF;
	for (int i = 0; i < t; ++i) {
		sort(bend(graph[i]));
		best = min(best, szof(graph[i]));
	}
	map<ull, vector<int>> tasks;
	for (int i = 0; i < t; ++i) {
		if (szof(graph[i]) == best) {
			ull h = 0;
			for (int to : graph[i]) {
				h = h * 1234567 + to;
			}
			tasks[h].push_back(i);
		}
	}
	
	vector<int> const* mem;
	int sz_best = -1;
	
	for (auto& p : tasks) {
		if (sz_best < szof(p.ss)) {
			sz_best = szof(p.ss);
			mem = &p.ss;
		}
	}
	
	cout << p - best << " " << sz_best << "\n";
	
	for (int num : *mem) {
		cout << num + 1 << " ";
	}
	cout << "\n";
}

int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(5) << fixed;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cout << setprecision(15) << fixed;
	
	solve();
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "time: " << (end_time - start_time) * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}