#include <bits/stdc++.h>


#define ll long long
#define ld long double
#define uint unsigned int
#define fi first
#define se second
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) static_cast<int>(a.size())
#define mp(a, b) make_pair(a, b)

constexpr int N = 100000;
constexpr int inf = static_cast<int>(1e9) + 1;
constexpr ll big = static_cast<ll>(1e18) + 1;
constexpr int MOD = static_cast<int>(1e9) + 7;
ld const eps = 1e-9;


using namespace std;

template<typename T>
void print(vector<T> const& s) {
    for (auto x : s)
        cout << x << " ";
    cout << endl;
}

ll binpow(ll a, ll p)
{
    ll res = 1;
    while (p)
    {
        if (p & 1)
        {
            res = res * a % MOD;
        }
        a = a * a % MOD;
        p >>= 1;
    }
    return res;
}

ll rev(ll x)
{
    return binpow(x, MOD - 2);
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int n;
    cin >> n;
    if (n <= 3)
    {
        cout << 0 << endl;
        return 0;
    }
    ll A = binpow(26, n - 3) * n % MOD;
    ll B = (binpow(26, n - 3) + MOD - 1) % MOD * rev(25) % MOD;
    A = (A - B - 3 + MOD + MOD) % MOD;
    A = A * rev(25) % MOD;
    cout << A << endl;
    return 0;
}
