#include <bits/stdc++.h>

#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define debug(x) std::cerr << #x << ": " << (x) << std::endl;

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 0x3f3f3f3f;
const double PI = atan2(0, -1);

vector < vector<int> > arr;
vector < pair<int, int> > bd(5);

bool check0(int x) {
    int high = 0;
    bool kek = false;
    for (int i = 0; i < 5; i++) {
        if (arr[x][i] > bd[i].second) {
            high++;
            if (i == 0 || i == 1)
                kek = true;
        }
    }
    return (kek && (high >= 3));
}

bool check1(int x) {
    int high = 0;
    int up = 0;
    for (int i = 0; i < 5; i++) {
        if (arr[x][i] > bd[i].second) {
            high++;
        } else if (arr[x][i] >= (bd[i].first + (bd[i].second - bd[i].first + 1) / 2)) {
            up++;
        }
    }
    if (high >= 2 && up >= 1 || (high >= 3))
        return true;
    up = 0;
    int norm = 0;
    for (int i = 0; i < 5; i++) {
        if (arr[x][i] >= (bd[i].first + (bd[i].second - bd[i].first + 1) / 2)) {
            up++;
        }
        if (bd[i].first <= arr[x][i])
            norm++;
    }
    if (norm == 5 && up >= 3)
        return true;
    else
        return false;
}

bool check2(int x) {
    int high = 0;
    int up = 0;
    for (int i = 0; i < 5; i++) {
        if (arr[x][i] > bd[i].second) {
            high++;
        } else if (arr[x][i] >= (bd[i].first + (bd[i].second - bd[i].first + 1) / 2)) {
            up++;
        }
    }
    if (high >= 1 && up >= 1 || high >= 2)
        return true;
    up = 0;
    for (int i = 0; i < 5; i++) {
        if (arr[x][i] >= (bd[i].first + (bd[i].second - bd[i].first + 1) / 2)) {
            up++;
        }
    }
    if (up >= 3)
        return true;
    else
        return false;
}

int main(void) {
    fastIO

    bd[0] = make_pair(190, 220);
    bd[1] = make_pair(200, 250);
    bd[2] = make_pair(10, 20);
    bd[3] = make_pair(2, 6);
    bd[4] = make_pair(3, 7);

    int n;
    cin >> n;
    arr.resize(n);

    for (int i = 0; i < n; i++) {
        arr[i].resize(5);
        for (int j = 0; j < 5; j++) {
            cin >> arr[i][j];
        }
    }

    for (int i = 0; i < n; i++) {
        if (check0(i)) {
            cout << 0 << '\n';
            continue;
        }
        if (check1(i)) {
            cout << 1 << '\n';
            continue;
        }
        if (check2(i)) {
            cout << 2 << '\n';
            continue;
        }
        cout << 3 << '\n';
    }

    return 0;
}
