#include <bits/stdc++.h>

#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define debug(x) std::cerr << #x << ": " << (x) << std::endl;

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 0x3f3f3f3f;
const double PI = atan2(0, -1);

const int N = 100100;
const int P = (int)1e6 + 3;
const int MOD1 = 998244353;
const int MOD2 = (int)1e9 + 7;

std::vector<int> tasks[N];
std::vector<int> rev[N];

ll getHash(const std::vector<int>& a) {
    ll hash1 = 0;
    ll hash2 = 0;

    for (auto i : a) {
        hash1 *= P;
        hash1 += (i + 1);
        hash1 %= MOD1;
        hash2 *= P;
        hash2 += (i + 1);
        hash2 %= MOD2;
    }

    return (hash1 << 32) + hash2;
}

int main(void) {
    int p, t, m;
    scanf("%d%d%d", &p, &t, &m);

    for (int i = 0; i < m; ++i) {
        int from, to;
        scanf("%d%d", &from, &to);

        tasks[from - 1].push_back(to - 1);
        rev[to - 1].push_back(from - 1);
    }

    int ans = p;
    for (int i = 0; i < t; ++i) {
        if (rev[i].size() < ans) {
            ans = rev[i].size();
        }
    }

    printf("%d ", p - ans);
    std::unordered_map<ll, std::vector<int>> q;

    for (int i = 0; i < t; ++i) {
        if (rev[i].size() != ans) {
            continue;
        }
        std::sort(rev[i].begin(), rev[i].end());
        q[getHash(rev[i])].push_back(i);
    }

    int needT = 0;
    for (auto& i : q) {
        if (i.second.size() > needT) {
            needT = i.second.size();
        }
    }

    printf("%d\n", needT);

    for (auto& i : q) {
        if (i.second.size() == needT) {
            for (auto j : i.second) {
                printf("%d ", j + 1);
            }
            printf("\n");
            return 0;
        }
    }

    return 0;
}
