#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 mt(736);

const int inf = 1e9 + 7;


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	vector<int> uni = {220, 250, 20, 6, 7},
			bnd = {205, 225, 15, 4, 5},
			ok = {190, 200, 10, 2, 3};

	for (auto &it : bnd)
		it--;
	for (auto &it : ok)
		it--;

	for (int i = 0; i < n; i++)
	{
		static vector<int> arr(5);

		for (auto &it : arr)
			cin >> it;

		int cntuni = 0, cntbnd = 0, cntok = 0, cntbad = 0;

		for (int j = 0; j < 5; j++)
		{
			if (arr[j] > uni[j])
				cntuni++;
			else if (arr[j] > bnd[j])
				cntbnd++;
			else if (arr[j] > ok[j])
				cntok++;
			else
				cntbad++;
		}

		if (cntuni >= 3 && (arr[0] > uni[0] || arr[1] > uni[1]))
			cout << 0 << endl;
		else if (cntuni >= 2 && cntuni + cntbnd >= 3)
			cout << 1 << endl;
		else if (cntuni + cntbnd >= 3 && cntbad == 0)
			cout << 1 << endl;
		else if (cntuni >= 1 && cntuni + cntbnd >= 2)
			cout << 2 << endl;
		else if (cntuni + cntbnd >= 3)
			cout << 2 << endl;
		else
			cout << 3 << endl;
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << clock() / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
