#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <iomanip>
#include <queue>
#include <stack>


using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll p, t, m;
	cin >> p >> t >> m;
	vector <int> cnt(t, 0);
	vector<pair<int, int>> cnt_task(p);
	vector <vector <int> > g(t);
	vector<vector<int>> godless(p);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		cnt[v]++;
		g[v].push_back(u);
		godless[u].push_back(v);
		cnt_task[u].first++;
		cnt_task[u].second = u;
	}
	vector <int> ans;
	for (int i = 0; i < t; ++i) {
		if (cnt[i] == 0) {
			ans.push_back(i);
		}
	}
	if (ans.size() > 0) {
		cout << p << ' ' << ans.size() << endl;
		for (int x : ans)
			cout << x + 1 << ' ';
		return 0;
	}
	int min_task = 1e9, min_id = -1;
	for (int i = 0; i < t; ++i) {
		if (cnt[i] < min_task) {
			min_task = cnt[i];
			min_id = i;
		}
	}
	map<vector<int>, int > mp;
	for (int i = 0; i < p; i++) {
		if (cnt[i] != min_task) continue;
		mp[g[i]]++;
	}
	int maxans = -1;
	vector<int> removed_part;
	for (auto i : mp){
		if (i.second > maxans) {
			maxans = i.second;
		}
	}
	for (auto i : mp) {
		if (i.second == maxans) {
			removed_part = i.first;
			break;
		}
	}
	vector<bool> alive(t, true);
	for (auto i : removed_part) {
		for (auto j : godless[i]) alive[j] = false;
	}
	int sum = 0;
	for (int i = 0; i < t; i++) {
		if (alive[i]) {
			ans.push_back(i);
			sum++;
		}
	}
	cout << p - min_task << ' ' << sum << endl;
	for (int x : ans)
		cout << x + 1 << ' ';
}
