#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <int> v[200005];
int arr[200005];

bool cmp(int a, int b){
    if (v[a].size() > v[b].size()) return false;
    if (v[a].size() < v[b].size()) return true;
    int m = v[a].size();
    for (int i=0;i<m;i++){
        if (v[a][i] == v[b][i]) continue;
        if (v[a][i] > v[b][i]) return false;
        if (v[a][i] < v[b][i]) return true;
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);

    //freopen("test.txt", "r", stdin);
    //freopen("ans.txt", "w", stdout);
    int p, t, m;
    cin >> p >> t >> m;
    while (m--){
        int pp, tt;
        cin >> pp >> tt;
        tt--;
        v[tt].push_back(pp);
    }
    for (int i=0;i<t;i++) sort(v[i].begin(), v[i].end());
    for (int i=0;i<t;i++) arr[i] = i;
    sort(arr, arr+t, cmp);
    /*for (auto e : v){
        for (auto x : e){
            cout << x << ' ';
        }
        cout << '\n';
    }*/
    int mn = v[arr[0]].size();
    int mx = 1, cnt = 1, j = 0, now = 0;
    for (int i=1;i<t;i++){
        if (v[arr[i]].size() > mn) break;
        if (cmp(arr[i], arr[i-1]) && cmp(arr[i-1], arr[i])) cnt++;
        else{
            if (cnt > mx) {mx = cnt;j = now;}
            now = i;
            cnt = 1;
        }
    }

    if (cnt > mx) {mx = cnt;j=now;}

    cout << p - mn << ' ' << mx << '\n';
    vector <int> vv;
    for (int i=0;i<mx;i++){
        vv.push_back(arr[j+i] + 1);
    }
    sort(vv.begin(), vv.end());
    for (auto e : vv) cout << e << ' ';

    return 0;
}


