#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <random>
#include <ctime>
using namespace std;

const long long MOD = 1e9 + 9;
const long long INF = 5e16;

int get_rand() {
    int x = rand() % 30000;
    int y = rand() % 30000;
    return (x << 15) + y;
}

bool prime(long long x) {
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            cout << i << endl;
            return false;
        }
    }
    return true;
}

long long power(long long x, long long n, long long R) {
    long long ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans *= x;
            ans %= R;
        }
        x *= x;
        x %= R;
        n /= 2;
    }
    return ans;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    srand(time(0));
    string s;
    cin >> s;
    if (s.size() == 1) {
        for (int test = 0; test < 50; test++) {
            int got = get_rand();
            long long sum = 0;
            for (int i = 0; i < (int)s.size(); i++) {
                sum = (sum * got + (s[i] - '0')) % MOD;
            }
            for (long long i = 2; i * i <= sum; i++) {
                if (sum % i == 0) {
                    cout << got << " " << i << endl;
                    return 0;
                }
            }
        }
        cout << -1 << endl;
    } else if (s.back() == '1') {
        for (int b = 10; b <= 15; b++) {
            for (int x = 2; x <= 15; x++) {
                long long ans = 0;
                for (int i = 0; i < (int)s.size(); i++) {
                    ans = (ans * b + s[i] - '0');
                    if (ans >= INF) {
                        ans %= x;
                    }
                }
                ans %= x;
                if (ans == 0 && x < b) {
                    cout << b << " " << x << endl;
                    return 0;
                }
            }
        }
    } else {
        if (s.back() == '0') {
            cout << 10 << " " << 2 << endl;
            return 0;
        }
        for (int i = 10;; i++) {
            if (i % (s.back() - '0') == 0) {
                cout << i << " " << s.back() << endl;
                return 0;
            }
        }
    }
    return 0;
}
