#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <random>
#include <ctime>
using namespace std;

const long long MOD = 1e10 + 9;

int get_rand() {
    int x = rand() % 30000;
    int y = rand() % 30000;
    return (x << 15) + y;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    srand(time(0));
    string s;
    cin >> s;
    if (s.size() == 1 || s.back() == '1') {
        for (int test = 0; test < 50; test++) {
            int got = get_rand();
            long long sum = 0;
            for (int i = 0; i < (int)s.size(); i++) {
                sum = (sum * got + (s[i] - '0')) % MOD;
            }
            for (long long i = 2; i * i <= sum; i++) {
                if (sum % i == 0) {
                    cout << got << " " << i << endl;
                    return 0;
                }
            }
        }
        cout << -1 << endl;
    } else {
        if (s.back() == '0') {
            cout << 10 << " " << 2 << endl;
            return 0;
        }
        for (int i = 10;; i++) {
            if (i % (s.back() - '0') == 0) {
                cout << i << " " << s.back() << endl;
                return 0;
            }
        }
    }
    return 0;
}
