#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <functional>
using namespace std;

const long long K = 1e5 + 23;

long long geth(const vector<int> &a) {
    long long ans = 1;
    for (int i = 0; i < (int)a.size(); i++) {
        ans = ans * K + a[i];
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int>> fir(n);
    vector<vector<int>> sec(m);
    for (int i = 0; i < q; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        fir[x].push_back(y);
        sec[y].push_back(x);
    }
    int ans_min = n + m;
    for (int i = 0; i < m; i++) {
        ans_min = min(ans_min, (int)sec[i].size());
    }
    unordered_map<long long, int> was;
    vector<long long> h(m);
    for (int i = 0; i < m; i++) {
        if ((int)sec[i].size() != ans_min) {
            continue;
        }
        sort(sec[i].begin(), sec[i].end());
        was[h[i] = geth(sec[i])]++;
    }
    long long best = 0;
    int ans_max = -1;
    for (auto &x : was) {
        if (x.second > ans_max) {
            ans_max = x.second;
            best = x.first;
        }
    }
    cout << n - ans_min << " " << ans_max << endl;
    for (int i = 0; i < m; i++) {
        if ((int)sec[i].size() != ans_min) {
            continue;
        }
        if (h[i] == best) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;
    return 0;
}

/*
3 4 6
1 1
1 2
2 2
2 3
3 3
3 4
*/
/*
3 5 6
1 1
1 2
2 1
2 3
3 1
3 3
*/
