#include <iostream>
#include <vector>
#include <random>

typedef long long int ll;
using namespace std;

vector<int> a;

bool check(ll d) {
    ll cur = 0;
    for (int i = 0; i < a.size(); i++) {
        cur = (cur * 10) + a[i];
        cur = cur % d;
    }
    return cur % 2;
}

int main() {
#ifdef LOCAL_VAR
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    char x;
    while (cin >> x) {
        a.push_back(int(x - '0'));
    }

    if (a.size() == 1 && a[0] < 4) {
        cout << -1;
        return 0;
    }
    for (ll i = 2; i <= 10000000; i++) {
        if (!check(i)) {
            cout << i << " 2";
            return 0;
        }
    }
}