#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXT = 100005;
vector<int> tasks[MAXT];
vector<pair<vector<int>, int>> parts[MAXT];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int p, t, m;
    cin >> p >> t >> m;
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y;
        tasks[y].push_back(x);
    }
    int mn_sz = MAXT;
    for (int i = 1; i <= t; ++i) {
        sort(tasks[i].begin(), tasks[i].end());
        int sz = tasks[i].size();
        parts[sz].push_back({tasks[i], i});
        mn_sz = min(mn_sz, sz);
    }
    sort(parts[mn_sz].begin(), parts[mn_sz].end());
    int cur = 0;
    int ans = 0;
    int r = 0;
    for (int i = 0; i < parts[mn_sz].size(); ++i) {
        if (i > 0 && parts[mn_sz][i - 1].first == parts[mn_sz][i].first) {
            ++cur;
        } else {
            cur = 1;
        }
        if (cur > ans) {
            ans = cur;
            r = i;
        }
    }
    cout << p - mn_sz << " " << ans << "\n";
    for (int i = r - ans + 1; i <= r; ++i) {
        cout << parts[mn_sz][i].second << " ";
    }
    return 0;
}