#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

const long long m = 1000000007;

long long bin(int a, int b) {
    if (a == 0) {
        return 1;
    }
    if (a % 2 == 1) {
        long long res = bin(a / 2, b);
        return res * res % m * b % m;
    } else {
        long long res = bin(a / 2, b);
        return res * res % m;
    }
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    long long n;
    cin >> n;
    if (n < 4) {
        cout << 0;
        return 0;
    }
    long long res = bin(n - 4, 26);
    long long g = bin(m - 2, 25);
    long long right = (m + (n - 4) * res % m - ((m + res - 1) % m * g % m)) % m * 26L % m * g % m;
    long long left = (m + 26L * res % m - 1) % m * 4 % m * g % m;
    cout << (right + left) % m << endl;

    return 0;
}