#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

#define forn(i,n) for(long long i = 0;i < (n);i++)
#define all(a) (a).begin(),(a).end()

using li = long long;
using vi = vector<li>;
using vpi = vector<pair<li, li>>;
using vvi = vector<vi>;

li M = 1000000007;

li get_hash(vi& a)
{
	li v = 0;
	sort(all(a));
	for (li t : a)
		v = v * M + t;
	return v;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int sum = 0;
	for (char c : s)
		sum += c - '0';
	if (s.size() == 1)
	{
		if (sum == 2 || ((sum % 2) && (sum != 9)))
		{
			cout << -1 << endl;
			return 0;
		}
		if (sum == 9)
		{
			cout << "10 3" << endl;
			return 0;
		}
		cout << "10 2" << endl;
		return 0;
	}
	if (sum == 1)
	{
		cout << "10 2" << endl;
		return 0;
	}
	cout << sum+1 << " " << sum << endl;
}