#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

#define forn(i,n) for(long long i = 0;i < (n);i++)
#define all(a) (a).begin(),(a).end()

using li = long long;
using vi = vector<li>;
using vpi = vector<pair<li, li>>;
using vvi = vector<vi>;

li M = 1000000007;

li pw(li a, li e)
{
	if (e < 2)
		return (e ? a : 1);
	return pw(a * a % M, e / 2) * (e % 2 ? a : 1) % M;
}

vvi mul(vvi a, vvi b)
{
	li n = a.size();
	li m = a[0].size();
	li k = b[0].size();
	vvi res(n, vi(k, 0));
	forn(i, n) forn(j, m) forn(l, k)
	{
		res[i][l] += a[i][j] * b[j][l];
		res[i][l] %= M;
	}
	return res;
}

vvi getI(li n)
{
	vvi res(n, vi(n, 0));
	forn(i, n)
		res[i][i] = 1;
	return res;
}

vvi pw(vvi a, li e)
{
	if (e < 2)
		return (e ? a : getI(a.size()));
	return mul(pw(mul(a,a), e / 2) , (e % 2 ? a : getI(a.size())));
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	li n;
	cin >> n;
	if (n < 4)
	{
		cout << 0 << endl;
		return 0;
	}
	/*li b = (pw(26, n - 3) + M - 1) % M;
	b = (b * pw(25, M - 2)) % M;
	b = (b * 3) % M;

	vvi m(6,vi(6,0));
	m[0][0] = m[0][1] = m[1][5] = 1;
	m[1][1] = 26;
	m[5][5] = 26;
	m[2][1] = m[3][2] = m[4][3] =
	vvi v = { {0},{1},{0},{0},{0},{26} };
	auto res = mul(pw(m, n - 3),v);
	cout << (res[0][0] + b) % M << endl;*/

	vvi m(3, vi(3, 0));
	m[0][0] = m[0][1] = 1;
	m[1][1] = m[1][2] = 26;
	m[2][2] = 26;
	vvi v = { {0},{4},{1} };
	auto res = mul(pw(m, n - 3), v);
	cout << res[0][0] << endl;
}