#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

int main(){
    int p, t, m;
    cin >> p >> t >> m;
    vector<set<int>> s(t);
    vector<vector<int>> gr(p);
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--; b--;
        gr[a].push_back(b);
        s[b].insert(a);
    }
    map<set<int>, int> cnt;
    for (int i = 0; i < t; i++){
        cnt[s[i]]++;
    }
    int ans = 0;
    for (int i = 1; i < t; i++){
        if (s[i].size() < s[ans].size() || (s[i].size() == s[ans].size() && cnt[s[i]] > cnt[s[ans]])){
            ans = i;
        }
    }
    cout << p - s[ans].size() << ' ' << cnt[s[ans]] << endl;
    for (int i = 0; i < t; i++){
        if (s[i] == s[ans]){
            cout << i + 1 << ' ';
        }
    }
    return 0;
}