﻿#include <iostream>
#include <set>
#include <cmath>

using namespace std;

set <long long> factorization(int p) {
	int i(2), e = sqrt(p + .0) + 1;
	set <long long> d;

	while (i < e) {
		if (p % i == 0) {
			d.insert(i);
			p /= i;
		}
		else
			i++;

	}

	if (p != 1)
		d.insert(p);

	return d;
}

int main() {
	// ...
	long long n, m;
	cin >> n;

	if ((n & (n - 1)) == 0) {
		cout << 4;
		return 0;
	}
	
	set <long long> ans = factorization(n);
	
	if (*(ans.begin()) > 2)
		cout << *(ans.begin());
	else
		cout << n;
}
