﻿#include <iostream>
#include <set>
#include <cmath>

using namespace std;

set <long long> factorization(int p) {
	int i(2), e = sqrt(p + .0) + 100;
	set <long long> d;

	while (i < e) {
		if (p % i == 0) {
			d.insert(i);
			p /= i;
		}
		else
			i++;

	}

	if (p != 1)
		d.insert(p);

	return d;
}

int main() {
	// ...
	long long n, m;
	cin >> n;

	if ((n & (n - 1)) == 0) {
		cout << 4;

		return 0;
	}

	if (n % 3 && n % 4 == 0) {
		cout << 4;

		return 0;
	}


	set <long long> ans = factorization(n);

	//for (auto i : ans)
	//	cout << i << " ";
	//cout << endl;

	auto it = ans.begin();
	while (it != ans.end() && *it == 2) {
		it++;
	}

	if (it != ans.end())
		cout << *it;
	else
		cout << n;
}
