﻿#include <iostream>
#include <set>
#include <cmath>

using namespace std;
using bint = unsigned long long;

set <bint> factorization(bint p) {
	int i(2), e = sqrt(p + .0) + 1;
	set <bint> d;

	while (i < e) {
		if (p % i == 0) {
			if (i != 2)
				d.insert(i);
			p /= i;
		}
		else
			i++;

	}

	if (p != 1)
		d.insert(p);

	return d;
}

int main() {
	// ...
	bint n;
	cin >> n;

	auto ans = factorization(n);

	//for (auto i : ans)
	//	cout << i << " ";
	//cout << endl;

	if (n%3 && n%4 == 0)
		cout << 4;
	else if (*(ans.begin()) == n)
		cout << n;
	else 
		cout << *(ans.begin());
}
