#pragma GCC optimize("O3") 
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx") 
#define __USE_MINGW_ANSI_STDIO 0
#include<bits/stdc++.h>                               
using namespace std;
 
#define dbg(x) cerr << #x << " == " << x << "\n";
#define PI acos(-1)
#define pb push_back
#define fi first
#define se second
#define TASK ""
#define sz(a) (int)(a).size()
#define all(c) (c).begin(), (c).end()
#define TIMESTAMP fprintf(stderr, "Execution time: %.3lf s.\n", (double)clock()/CLOCKS_PER_SEC)
 
string to_string(string s) {
    return '"' + s + '"';
}
 
string to_string(const char* s) {
    return to_string((string) s);
}
 
template <typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}
 
template <typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}
 
void debug_out() { cerr << endl; }
 
template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}
 
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif
 
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair <int, int> pii;
typedef vector <vi> vvi;
typedef vector <pii> vpii;
typedef vector <string> vs;
	
const int MAXN = 1e5 + 9;
const int MOD = (int)(1e9 + 7);
const int LOG2MAXN = 17;
const int INF = 1e9;
const ld eps = 1e-9;
 
int di[] = {0, 1, 0, -1};
int dj[] = {1, 0, -1, 0};
char ddir[] = {'R', 'U', 'L', 'D'};
 
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 32;
int p[N][5];
int edL[5];
int edR[5];

int getRank(int i) 
{
	int cntH = 0;     

	bool h[5];
	for (int j = 0; j < 5; j++)
	{
		h[j] = p[i][j] > edR[j];
		cntH += h[j];
	}

	int cntHH = 0;
	bool allExpected = true;
	for (int j = 0; j < 5; j++)
	{           
		cntHH += p[i][j] >= (edL[j] + edR[j]) * 0.5 - 1e-7;
		allExpected &= edL[j] <= p[i][j];
	}

	if (cntH >= 3 && (h[0] || h[1]))
		return 0;

	if ((cntH >= 2 && cntHH >= 3) || (allExpected && cntHH >= 3))
		return 1;
	
	if ((cntH >= 1 && cntHH >= 2) || (cntHH >= 3))
		return 2;
		
    return 3;
}

void input() {
	edL[0] = 190; edR[0] = 220;
	edL[1] = 200; edR[1] = 250;
	edL[2] = 10; edR[2] = 20;
	edL[3] = 2; edR[3] = 6;
	edL[4] = 3; edR[4] = 7;

	int n; cin >> n;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 5; j++)
			cin >> p[i][j];
		cout << getRank(i) << "\n";
	}


}
 
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif	
	input();
#ifdef LOCAL
	TIMESTAMP;
#endif	
	return 0;
}