#pragma GCC optimize("O3") 
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx") 
#define __USE_MINGW_ANSI_STDIO 0
#include<bits/stdc++.h>                               
using namespace std;
 
#define dbg(x) cerr << #x << " == " << x << "\n";
#define PI acos(-1)
#define pb push_back
#define fi first
#define se second
#define TASK ""
#define sz(a) (int)(a).size()
#define all(c) (c).begin(), (c).end()
#define TIMESTAMP fprintf(stderr, "Execution time: %.3lf s.\n", (double)clock()/CLOCKS_PER_SEC)
 
string to_string(string s) {
    return '"' + s + '"';
}
 
string to_string(const char* s) {
    return to_string((string) s);
}
 
template <typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}
 
template <typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}
 
void debug_out() { cerr << endl; }
 
template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}
 
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif
 
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair <int, int> pii;
typedef vector <vi> vvi;
typedef vector <pii> vpii;
typedef vector <string> vs;
	
const int MAXN = 1e5 + 9;
const int MOD = (int)(1e9 + 7);
const int LOG2MAXN = 17;
const int INF = 1e9;
const ld eps = 1e-9;
 
int di[] = {0, 1, 0, -1};
int dj[] = {1, 0, -1, 0};
char ddir[] = {'R', 'U', 'L', 'D'};
 
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
 
void solve() {
		
}
 

void input() {                                      
	vector<int> p;
	for (int i = 2; i <= 1000; i++) {
		bool prime = true;
		for (int j = 2; j * j <= i; j++) {
			if (i % j == 0) {
				prime = false;
				break;
			}
		}
		if (prime) {
			p.push_back(i);
		}
	}

	p.resize(20);

    string s; cin >> s;
    
    int sInt = 1000000000;
    if (s.size() < 9) {
		sInt = stoi(s);
    }

   	for (int base : p) {
		if (base < 10) continue;

	    for (int d : p) {
    		if (d >= sInt) continue;
            
            int cur = 0;
            int curBase = 1;
            for (int i = (int) s.size() - 1; i >= 0; i--) {
            	cur += (s[i] - '0') * curBase;
            	cur %= d;

            	curBase *= base;
            	curBase %= d;
            } 

            if (cur % d == 0) {
            	cout << base << " " << d << endl;
            	return;
            }
    	}
    }

    cout << -1 << endl;
}
 
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif	
	input();
	solve();
#ifdef LOCAL
	TIMESTAMP;
#endif	
	return 0;
}