#include <bits/stdc++.h>
using namespace std;


struct fastio{
	fastio(){
		ios::sync_with_stdio(0);
		cin.tie(0);

		cout << setprecision(12);
		cout << fixed;

		cerr << setprecision(6);
		cerr << fixed;
	}
}______________;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << x << endl;
#define ddebug(x, y) cerr << #x << ", " << #y << " = " << x << ", " << y << endl;
#else
#define debug(x);
#define ddebug(x, y);
#endif

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define sq(a) ((a) * (a))
#define sz(a) ((int)a.size())
#define FOR(i, a, b) for(int i = (int)(a); i < (int)(b); i++)
#define FORD(i, a, b) for(int i = (int)(a); i > (int)(b); i--)

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <ll> vl;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int MAX = 2e6 + 10;
const ld eps = 1e-8;
const ll INF = 1e9 + 10;
const ll mod = 1e9 + 7;

int st[5];

int check_stat(int param, int val){
	switch(param){
		case 0:
			if(val < 190) return 0;
			else if(val < 205) return 1;
			else if(val <= 220) return 2;
			else return 3;
			break;
		case 1:
			if(val < 200) return 0;
			else if(val < 225) return 1;
			else if(val <= 250) return 2;
			else return 3;
			break;
		case 2:
			if(val < 10) return 0;
			else if(val < 15) return 1;
			else if(val <= 20) return 2;
			else return 3;
			break;
		case 3:
			if(val < 2) return 0;
			else if(val < 4) return 1;
			else if(val <= 6) return 2;
			else return 3;
			break;
		case 4:
			if(val < 3) return 0;
			else if(val < 5) return 1;
			else if(val <= 7) return 2;
			else return 3;
		default:
			assert(false);
	}
}

bool check_zero(){
	int cnt = 0;
	FOR(i, 0, 5)
		if(check_stat(i, st[i]) >= 3) cnt++;
	if(cnt < 3)
		return false;
	else 
		return check_stat(0, st[0]) >= 3 || check_stat(1, st[1]) >= 3;
}

bool check_first(){
	int cnt;
	cnt = 0;
	FOR(i, 0, 5)
		if(check_stat(i, st[i]) >= 3) cnt++;
	if(cnt < 2) goto next_check_1;
	cnt = 0;
	FOR(i, 0, 5)
		if(check_stat(i, st[i]) >= 2) cnt++;
	if(cnt < 3) goto next_check_1;
	return true;
next_check_1:
	FOR(i, 0, 5)
		if(!check_stat(i, st[i]))
			return false;
	cnt = 0;     
	FOR(i, 0, 5)
		if(check_stat(i, st[i]) >= 2) cnt++;
	return cnt >= 3;		
}


bool check_second(){
	int cnt;
	cnt = 0;
	FOR(i, 0, 5)
		if(check_stat(i, st[i]) >= 3) cnt++;
	if(!cnt)
		goto next_check_2;
	cnt = 0;
	FOR(i, 0, 5)
		if(check_stat(i, st[i]) >= 2) cnt++;
	if(cnt < 2) goto next_check_2;
	return true;
next_check_2:
	cnt = 0;
	FOR(i, 0, 5)
		if(check_stat(i, st[i]) >= 2) cnt++;
	return cnt >= 3;
}

void solve(){
	int n;
	cin >> n;
	FOR(____2, 0, n){                
		FOR(i, 0, 5) cin >> st[i];
		if(check_zero()) cout << 0 << endl;
		else if(check_first()) cout << 1 << endl;
		else if(check_second()) cout << 2 << endl;
		else cout << 3 << endl;

	}
}

int main(){
    clock_t beg = clock();
    solve();
    clock_t end = clock();
    ld elapsed_time = (ld)(end - beg) / CLOCKS_PER_SEC;
    debug(elapsed_time);
	return 0;
}