#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <map>

#define ll long long 
#define F first
#define S second
#define pb push_back
using namespace std;


ll fac(ll a) {
	ll res = 1;
	for (int i = 1; i <= a; ++i)
		res *= i;
	return res;
}

ll C(ll n, ll k) {
	return fac(n) / (fac(k) * fac(n - k));
}

ll bin_pow(ll a, ll b) {
	int res = 1;
	while (b) {
		if (b & 1) {
			res *= a;
			b -= 1;
		}
		else {
			res *= res;
			b /= 2;
		}
	}
	return res;
}

int main() {
	const ll MOD = pow(10, 9) + 7;
	cin.sync_with_stdio(0);
	ll n;
	cin >> n;
	ll N = n;
	if (N <= 3) {
		cout << 0 << endl;
		return 0;
	}
	cout << (C(n,n-4) * bin_pow(26, N - 4) % MOD) + (N-3) * 2 % MOD;
	return 0;

		
}














/*
int main() {
	cin.sync_with_stdio(0);
	ll n;
	cin >> n;
	if (n <= 1000'000'000) {
		if (n == 1) cout << -1 << endl;
		else if (n == 2) cout << "2 2" << endl;
		else if (n == 3) cout << "3 2" << endl;
		else if (n & 0x1) cout << n - 2 << " 2" << endl;
		else cout << "10 2" << endl;
		return 0;
	}
	system("pause");
} */