#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <functional>
#include <numeric>
#include <limits>
#include <cstdio>

using namespace std;
using ll = long long;

void solve() {
	ll p, t, m;
	cin >> p >> t >> m;
	vector<vector<ll>> g(t);
	for (int i = 0; i < m; ++i) {
		ll v, to;
		cin >> v >> to;
		--v, --to;
		g[to].push_back(v);
	}
	vector<ll> ans;
	for (int i = 0; i < t; ++i) {
		sort(g[i].begin(), g[i].end());
		if (g[i].size() == 0) {
			ans.push_back(i);
		}
	}
	if (ans.size() != 0) {
		cout << p << ' ' << ans.size() << '\n';
		for (auto x : ans) cout << x + 1 << ' ';
		return;
	}
	ll cnt = p + 1;
	ll ii = -1;
	for (int i = 0; i < t; ++i) {
		if (g[i].size() < cnt) {
			cnt = g[i].size();
			ii = i;
		}
	}
	map<vector<ll>, vector<ll>> gg;
	for (int i = 0; i < t; ++i) {
		if (g[i].size() == cnt) {
			gg[g[i]].push_back(i);
		}
	}
	ll kol = 0;
	for (auto to : gg) {
		if (to.second.size() > kol) {
			kol = to.second.size();
			ii = to.second[0];
		}
	}
	cout << p - cnt << ' ' << kol << '\n';
	for (auto x : g[ii]) cout << x + 1 << ' ';
}

int main() {
	//(void)freopen("input.txt", "r", stdin);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios::sync_with_stdio(false);
	solve();
	return 0;
}