import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class DividerFinder {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        String input = in.next();

        if (input.length() == 1) {
            int a = Integer.parseInt(input);
            ArrayList<Integer> good = new ArrayList<>(Arrays.asList(4, 6, 8));
            if (good.contains(a)) {
                System.out.println(10 + " " + 2);
            } else {
                if (a == 9) {
                    System.out.println(10 + " " + 3);
                } else {
                    System.out.println(-1);
                }
            }
            return;
        }

        ArrayList<Integer> numsInInput = new ArrayList<>();
        int max = 1;

        for (int i = input.length() - 1; i >= 0; i--) {
            int dig = Integer.parseInt(String.valueOf(input.charAt(i)));
            numsInInput.add(dig);
            if (dig > max) {
                max = dig;
            }
        }

        long modSum;
        ArrayList<Long> sums = new ArrayList<>();

        int ansB = 0;
        long ansX = 0;

        for (int base = max + 1; base <=1000000000; base++) {
            sums.clear();
            modSum = 0;
            for (int i = 0; i < numsInInput.size(); i++) {
                sums.add(numsInInput.get(i) * (long)Math.pow(base, i));
            }
            for (long i = 2; i < Math.ceil(Math.sqrt(sums.get(sums.size() - 1))) + 1; i++) {
                for (Long sum: sums) {
                    modSum += sum % i;
                }

                if (modSum % i == 0) {
                    ansB = base;
                    ansX = i;
                    break;
                }
            }

            if (ansB != 0) {
                break;
            }
        }

        if (ansB == 0) {
            System.out.println(-1);
        } else {
            System.out.println(ansB + " " + ansX);
        }
    }
}
