def h1(h):
    if h < 190:
        return 1
    elif h < 205:
        return 10
    elif h <= 220:
        return 100
    else:
        return 1000

def w1(h):
    if h < 200:
        return 1
    elif h < 225:
        return 10
    elif h <= 250:
        return 100
    else:
        return 1000

def s1(h):
    if h < 10:
        return 1
    elif h < 15:
        return 10
    elif h <= 20:
        return 100
    else:
        return 1000


def r1(h):
    if h < 2:
        return 1
    elif h < 4:
        return 10
    elif h <= 6:
        return 100
    else:
        return 1000


def p1(h):
    if h < 3:
        return 1
    elif h < 5:
        return 10
    elif h <= 7:
        return 100
    else:
        return 1000


def unicorn_check(h, w):
    return w1(w) >= 1000 or h1(h) >= 1000

def rank(h, w, s, r, p):
    return h1(h) + w1(w) + s1(s) + r1(r) + p1(p)


def all_more_than_minimum(h, w, s, r, p):
    return h >= 190 and w >= 200 and s >= 10 and r >= 2 and p >= 3

def unicorn(h, w, s, r, p):
    rating = rank(h, w, s, r, p)
    return unicorn_check(h, w) and rating >= 3000


def first_category(h, w, s, r, p):
    rating = rank(h, w, s, r, p)
    if all_more_than_minimum(h, w, s, r, p) and rating >= 300:
        return True
    elif rating >= 2100:
        return True
    else:
        return False


def second_category(h, w, s, r, p):
    rating = rank(h, w, s, r, p)
    return rating >= 300


def category(h, w, s, r, p):
    if unicorn(h, w, s, r, p):
        return 0
    elif first_category(h, w, s, r, p):
        return 1
    elif second_category(h, w, s, r, p):
        return 2
    else:
        return 3


n = int(input())
for i in range(n):
    print(category(int(input()), int(input()), int(input()), int(input()), int(input())))

