def h1(h):
    if h < 190:
        return 1
    elif h < 205:
        return 10
    elif h <= 220:
        return 100
    else:
        return 1000

def w1(w):
    if w < 200:
        return 1
    elif w < 225:
        return 10
    elif w <= 250:
        return 100
    else:
        return 1000

def s1(s):
    if s < 10:
        return 1
    elif s < 15:
        return 10
    elif s <= 20:
        return 100
    else:
        return 1000


def r1(r):
    if r < 2:
        return 1
    elif r < 4:
        return 10
    elif r <= 6:
        return 100
    else:
        return 1000


def p1(p):
    if p < 3:
        return 1
    elif p < 5:
        return 10
    elif p <= 7:
        return 100
    else:
        return 1000


def unicorn_check(h, w):
    return h > 220 or w > 250

def rank(h, w, s, r, p):
    return h1(h) + w1(w) + s1(s) + r1(r) + p1(p)


def all_more_than_minimum(h, w, s, r, p):
    return h >= 190 and w >= 200 and s >= 10 and r >= 2 and p >= 3

def unicorn(h, w, s, r, p):
    rating = rank(h, w, s, r, p)
    return unicorn_check(h, w) and rating >= 3000


def first_category(h, w, s, r, p):
    rating = rank(h, w, s, r, p)
    if rating >= 2100:
        return True
    elif all_more_than_minimum(h, w, s, r, p) and rating % 1000 >= 300:
        return True
    else:
        return False


def second_category(h, w, s, r, p):
    rating = rank(h, w, s, r, p)
    return rating % 1000 >= 300 or rating > 1100


def category(h, w, s, r, p):
    if unicorn(h, w, s, r, p):
        return 0
    elif first_category(h, w, s, r, p):
        return 1
    elif second_category(h, w, s, r, p):
        return 2
    else:
        return 3


n = int(input())
for i in range(n):
    print(category(int(input()), int(input()), int(input()), int(input()), int(input())))

