import java.util.Scanner;
import java.util.Stack;

public class Application {

    public static void main(String[] args){
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        Stack stack = new Stack();

        boolean isValidCommands = true;

        for(int i = 0; i <= n; i++){
            String commandLine = sc.nextLine();
            String[] commandArr = commandLine.split(" ");

            if(commandArr[0].equalsIgnoreCase("Add")){
                stack.add(commandArr);
            }else if(commandArr[0].equalsIgnoreCase("Vote")){

                try{
                    String[] fCommand = (String[])stack.lastElement();
                    if(fCommand[1].equalsIgnoreCase(commandArr[1])){
                        stack.pop();
                    }else{
                        isValidCommands = false;
                    }
                }catch (Exception ex){
                    isValidCommands = false;
                    break;
                }

            }
        }

        if(isValidCommands) {System.out.println("Yes");}
        else System.out.println("No");
    }

}

