#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    long long n, m;
    cin >> n;
    m = n;
    vector<long long> divs;
    for (long long x = 2; x * x <= n; x++) {
        while (m % x == 0) {
            divs.push_back(x);
            m /= x;
        }
    }
    if (m > 1) {
        divs.push_back(m);
    }
    if (divs[0] != 2) {
        cout << divs[0];
    } else {
        if (divs.size() > 1) {
            int count = 1;
            int min_div = -1;
            for (int i = 1; i < divs.size(); i++) {
                if (divs[i] != 2) {
                    min_div = divs[i];
                    break;
                } else {
                  count++;
                }
            }
            if (count == 1) {
                cout << min_div;
            } else {
                if (min_div == -1) {
                    cout << 4;
                } else {
                    cout << min(min_div, 4);
                }
            }
        } else {
            cout << divs[0];
        }
    }

    return 0;
}
