#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <ctime>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    string s;
    cin >> s;


    if (s.size() > 1) {
        int c = (s[s.size() - 1] - '0');
        if (c % 2 == 0) {
            return cout << "10 2", 0;
        }
        if (c != 1) {
            return cout << c * 4 << " " << c, 0;
        }

        int cnt = 0;
        for (char x : s) {
            if ((x - '0') % 2) cnt++;
        }
        if (cnt % 2 == 0) {
            return cout << "11 2", 0;
        }
    }

    vector<int> d;

    for (int i = 2; i < 1000; i++) {
        bool flag = true;
        for (int j = 2; j * j <= i; j++) {
            if (i % j == 0) {
                flag = false;
                break;
            }
        }
        if (flag) {
            d.push_back(i);
        }
    }
    for (int i : {16, 64, 128, 131072}) {
        for (int x : d) {
            if (clock() > 1500) {
                return cout << "-1", 0;
            }
            int sum = 0;
            int flag = 0;
            for (int j = 0; j < s.size(); j++) {
                flag = min(flag + (sum * i + (s[j] - '0')) / x, 10);
                sum = (sum * i + (s[j] - '0')) % x;
            }
            if (sum == 0 && flag > 1) {
                cout << i << " " << x;
                return 0;
            }
        }
    }
    cout << -1;
    return 0;
}
