#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

long long INF = 1000000007;
long long OBR = 280000002;

long long deg(long long a, int n) {
    long long res = 1;
    while (n > 0) {
        if (n % 2 == 0) {
            a = (a * a) % INF;
            n /= 2;
        } else {
            n--;
            res = (res * a) % INF;
        }
    }
    return res;
}

int main()
{
    int n;
    cin >> n;
    if (n <= 3) {
        cout << 0;
    } else {
        long long ans = 0, x;
        ans = (4LL * ((deg(26, n - 3) - 1 + INF) * OBR) % INF) % INF;

        x = (deg(26, n - 4) - 1 + INF) * OBR % INF;
        x = deg(26, n - 4) * (n - 4) - x;
        x = (x % INF + INF) % INF;
        x = x * OBR % INF;
        x = x * 26LL % INF;

        cout << (ans + x) % INF;
    }
    return 0;
}
