import java.io.BufferedReader;
import java.io.InputStreamReader;

public class Solution4 {

    public static void main(String[] args) {
        int n;
        int h;
        int w;
        int s;
        int r;
        int p;
        InputStreamReader streamReader = new InputStreamReader(System.in);
        try (BufferedReader reader = new BufferedReader(streamReader)) {
            n = Integer.parseInt(reader.readLine());
            for (int i = 0; i < n; i++) {
                h = Integer.parseInt(reader.readLine());
                w = Integer.parseInt(reader.readLine());
                s = Integer.parseInt(reader.readLine());
                r = Integer.parseInt(reader.readLine());
                p = Integer.parseInt(reader.readLine());
                System.out.println(getCategory(h, w, s, r, p));
            }
        } catch (Exception ex) {

        }
    }

    private static int getCategory(int h, int w, int s, int r, int p) {
        int higher = 0;
        int secondPart = 0;
        int wanted = 0;
        if (h >= 220) {
            higher += 16;
            wanted += 16;
            secondPart += 16;
        } else if (h >= 205) {
            secondPart += 16;
            wanted += 16;
        } else if (h >= 190) {
            wanted += 16;
        }
        if (w >= 250) {
            higher += 8;
            secondPart += 8;
            wanted += 8;
        } else if (w >= 225) {
            secondPart += 8;
            wanted += 8;
        } else if (w >= 200) {
            wanted += 8;
        }
        if (s >= 20) {
            higher += 4;
            wanted += 4;
            secondPart += 4;
        } else if (s >= 15) {
            secondPart += 4;
            wanted += 4;
        } else if (s >= 10) {
            wanted += 4;
        }
        if (r >= 6) {
            higher += 2;
            secondPart += 2;
            wanted += 2;
        } else if (r >= 4) {
            secondPart += 2;
            wanted += 2;
        } else if (r >= 2) {
            wanted += 2;
        }
        if (p >= 7) {
            higher += 1;
            secondPart += 1;
            wanted += 1;
        } else if (p >= 5) {
            secondPart += 1;
            wanted += 1;
        } else if (p >= 3) {
            wanted += 1;
        }

        if (higher >= 11) {
            return 0;
        } else if ((higher >= 3 && secondPart >= 1) || (wanted == 31 && secondPart >= 7)) {
            return 1;
        } else if ((higher >= 1 && secondPart >= 1) || (secondPart >= 7)) {
            return 2;
        }
        return 3;
    }
}
