import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Stack;

public class Solution5 {

    public static void main(String[] args) {

        Stack<Character> stack = new Stack<>();
        InputStreamReader streamReader = new InputStreamReader(System.in);
        try (BufferedReader reader = new BufferedReader(streamReader)) {
            String line;
            boolean isCorrect = true;
            int n = Integer.parseInt(reader.readLine());
            for (int i = 0; i < n; i++) {
                line = reader.readLine();
                if (line.contains("Add")) {
                    stack.push(line.charAt(4));
                } else if (line.contains("Vote")) {
                    if (line.charAt(5) != stack.peek()) {
                        isCorrect = false;
                        break;
                    }
                    stack.pop();
                }
            }
            System.out.println(isCorrect ? "Yes" : "No");
        } catch (Exception ex) {
            System.out.println("No");
        }
    }
}
