#include <iostream>
#include <vector>
#include <string>
using namespace std;

const unsigned int mod = 1000000007;
 
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

	unsigned long long fu[] = { 0, 967199662, 411707796, 835923526, 718969735, 934347380, 790571458, 529370105, 777703770, 309656010 };

	unsigned long long ST[] = { 1, 123567687, 163647158, 656633046, 134014220, 74590351, 81069438, 869926972, 36489723, 638818051 };
	
	unsigned long long n;
	cin >> n;
	if (n < 4) {
		cout << 0 << endl;
		return 0;
	}

	unsigned long long ans = 0;

	for (unsigned long long i = 9; i >= 0; --i) {
		unsigned long long start = i * 100000000;
		if (n >= start) {
			unsigned long long ans = fu[i];
			unsigned long long st = ST[i];
			if (start == 0) start = 4;
			for (unsigned long long j = start; j <= n; ++j) {
				ans = (ans + st * j) % mod;
				st = (26 * st) % mod;
			}

			cout << ans << endl;
			return 0;
		}
	}
}


