import java.lang.IllegalArgumentException

fun readLn() = readLine()!!
fun readInt() = readLn().toInt()
fun readInts() = readLn().split(' ').map { it.toInt() }
fun Boolean.toInt() = if (this) 1 else 0

fun valCat(bg: Int, nd: Int, x: Int): Int {
    if (x < bg)
        return 1
    val mid = (bg + nd) / 2
    if (x < mid)
        return 2
    if (x < nd)
        return 3
    return 4
}

fun solve(h: Int, w: Int, s: Int, r: Int, p: Int): Int {
    val hCat = valCat(190, 221, h)
    val wCat = valCat(200, 251, w)
    val sCat = valCat(10, 21, s)
    val rCat = valCat(2, 7, r)
    val pCat = valCat(3, 8, p)
    fun cnt(x: Int) =
        (hCat >= x).toInt() +
        (wCat >= x).toInt() +
        (sCat >= x).toInt() +
        (rCat >= x).toInt() +
        (pCat >= x).toInt()
    val cntIn = cnt(2)
    val cntUp = cnt(3)
    val cntUn = cnt(4)

    // is Unicorn
    if ((hCat >= 4 || wCat >= 4) && cntUn >= 3)
        return 0
    if ((cntUn >= 2 && cntUp >= 3) || (cntIn == 5 && cntUp >= 3))
        return 1
    if ((cntUn >= 1 && cntUp >= 2) || cntUp >= 3)
        return 2
    return 3
}

fun main() {
    val n = readInt()

    repeat(n) {
        val h = readInt()
        val w = readInt()
        val s = readInt()
        val r = readInt()
        val p = readInt()
        println(solve(h, w, s, r, p))
    }
}