fun readLn() = readLine()!!
fun readInt() = readLn().toInt()
fun readInts() = readLn().split(' ').map { it.toInt() }
fun Boolean.toInt() = if (this) 1 else 0

fun main() {
    val (p, t, m) = readInts()

    val p2t = Array(p) { mutableListOf<Int>() }
    val t2p = Array(t) { mutableListOf<Int>() }
    repeat(m) {
        val (pp, tt) = readInts().map { x -> x - 1 }
        p2t[pp].add(tt)
        t2p[tt].add(pp)
    }

    val optimalSize = t2p.asSequence().map { it.size }.min()!!
    val optimalPs = (0 until t)
        .filter { t2p[it].size == optimalSize }
        .groupBy { t2p[it] }
        .maxBy { (k, v) -> v.size }!!.value

    println("${p - optimalSize} ${optimalPs.size}")
    println(optimalPs.map { it+1 }.joinToString(" "))
}