#include <iostream>
#define ull long

using namespace std;

bool isPrime (ull p)
{
    if (p%2 == 0)
        return false;
    for (int i = 3; i*i < p; i+=2)
        if (p%i == 0)
            return false;
    return true;
}

ull minfactor (ull p)
{
    for (int i = 3; i < p; ++i)
        if (p%i == 0)
            return i;

    return p;
}

int main(){

    ull N, res = 3, l;
    cin >> N;

    if (isPrime(N))
    {
        res = N;
    }
    else
    {
        l = minfactor(N); // > 2
        if (l > 3 && N % 4 == 0)
            res = 4;
        else
            res = l;
    }

    cout << res;

    return 0;
}
