
def h_engine(h):
    l = 190
    r = 220
    mid = int((r + l) / 2)
    if h > r: return 3
    if h >= mid: return 2
    if h >= l: return 1
    return 0

def w_engine(w):
    l = 200
    r = 250
    h = w
    mid = int((r + l) / 2)
    if h > r: return 3
    if h >= mid: return 2
    if h >= l: return 1
    return 0


def s_engine(s):
    l = 10
    r = 20
    h = s
    mid = int((r + l) / 2)
    if h > r: return 3
    if h >= mid: return 2
    if h >= l: return 1
    return 0

def r_engine(rr):
    l = 2
    r = 6
    h = rr
    mid = int((r + l) / 2)
    if h > r: return 3
    if h >= mid: return 2
    if h >= l: return 1
    return 0

def p_engine(p):
    l = 3
    r = 7
    h = p
    mid = int((r + l) / 2)
    if h > r: return 3
    if h >= mid: return 2
    if h >= l: return 1
    return 0

# вычисляет количество элементов среди a, b, c, d равных key
def count4(a, b, c, d, key):
    q = 0
    if a == key: q += 1
    if b == key: q += 1
    if c == key: q += 1
    if d == key: q += 1
    return q

def count5(a, b, c, d, e, key):
    q = 0
    if e == key: q += 1
    q += count4(a, b, c, d, key)
    return q

def count4_more(a, b, c, d, key):
    q = 0
    if a >= key: q += 1
    if b >= key: q += 1
    if c >= key: q += 1
    if d >= key: q += 1
    return q

def count5_more(a, b, c, d, e, key):
    q = 0
    if e >= key: q += 1
    q += count4_more(a, b, c, d, key)
    return q

def category_0(propertyes):
    h, w, s, r, p = propertyes
    heng = h_engine(h)
    weng = w_engine(w)
    seng = s_engine(s)
    reng = r_engine(r)
    peng = p_engine(p)
    if  heng == 3 and count4(weng, seng, reng, peng, 3) >= 2: return True
    elif weng == 3 and count4(heng, seng, reng, peng, 3) >= 2: return True
    return False


def category_1(propertyes):
    h, w, s, r, p = propertyes
    heng = h_engine(h)
    weng = w_engine(w)
    seng = s_engine(s)
    reng = r_engine(r)
    peng = p_engine(p)
    if count5(heng, weng, seng, reng, peng, 3) >= 3 or (count5(heng, weng, seng, reng, peng, 3) == 2 and count5(heng, weng, seng, reng, peng, 2) >= 1): return True
    if count5_more(heng, weng, seng, reng, peng, 1) == 5 and  count5_more(heng, weng, seng, reng, peng, 2) >= 3: return True
    return False

def category_2(propertyes):
    h, w, s, r, p = propertyes
    heng = h_engine(h)
    weng = w_engine(w)
    seng = s_engine(s)
    reng = r_engine(r)
    peng = p_engine(p)
    if count5_more(heng, weng, seng, reng, peng, 3) >= 1 and count5_more(heng, weng, seng, reng, peng, 2) >= 2: return True
    if count5_more(heng, weng, seng, reng, peng, 2) >= 3: return True
    return False

def category_3(propertyes):
    return True

def main():
    n = int(input())
    use = [-1 for i in range(n)]
    Players = []
    for i in range(n):
        s = []
        for j in range(5):
            s.append(int(input()))
        Players.append(tuple(s))

    for i in range(n):
        if category_0(Players[i]):
           use[i] = 0

    for i in range(n):
        if use[i] == -1 and category_1(Players[i]):
           use[i] = 1

    for i in range(n):
        if use[i] == -1 and category_2(Players[i]):
           use[i] = 2

    for i in range(n):
        if use[i] == -1 and category_3(Players[i]):
           use[i] = 3

    for x in use:
        print(x)

main()