#include <iostream>

using namespace std;

struct player
{
    int height;
    int wingspan;
    int midScore;
    int midUp;
    int midPer;
    int upperMiddleExpected;
    int upperExpected;
    int expected;
};

int check(player tmp, int i)
{
    if (i == 1)
    {
        if (tmp.height > 220)
            return 0;
        else if (tmp.height >= 205)
            return 1;
        else if (tmp.height > 190)
            return 2;
        else return 3;
        
    } else if (i == 2)
    {
        
        if (tmp.wingspan > 250)
            return 0;
        else if (tmp.wingspan >= 225)
            return 1;
        else if (tmp.wingspan > 200)
            return 2;
        else return 3;
        
    } else if (i == 3)
    {
        
        if (tmp.midScore > 20)
            return 0;
        else if (tmp.midScore >= 15)
            return 1;
        else if (tmp.midScore > 10)
            return 2;
        else return 3;
        
    } else if (i == 4)
    {
        
        if (tmp.midUp > 6)
            return 0;
        else if (tmp.midUp >= 4)
            return 1;
        else if (tmp.midUp > 2)
            return 2;
        else return 3;
        
    } else if (i == 5)
    {
        
        if (tmp.midPer > 7)
            return 0;
        else if (tmp.midPer >= 5)
            return 1;
        else if (tmp.midPer > 3)
            return 2;
        else return 3;
    }
    
}

void count(player &pl)
{
    for (int i = 1; i < 6; ++i)
    {
        if (check(pl, i) == 0)
        {
            pl.expected++;
            pl.upperMiddleExpected++;
            pl.upperExpected++;
        }
        
        if (check(pl, i) == 1)
            pl.upperMiddleExpected++;
        
        if (check(pl, i) == 2)
            pl.expected++;
    }
        
}

int getCateg(player pl)
{
    if (pl.upperExpected >= 3 && (check(pl, 1) == 0 || check(pl, 2) == 0))
        return 0;
    if ((pl.upperExpected >= 2 && pl.upperMiddleExpected >= 1) || (pl.expected == 5 && pl.upperMiddleExpected >= 3))
        return 1;
    if ((pl.upperExpected >= 1 && pl.upperMiddleExpected >= 1) || (pl.upperMiddleExpected >= 3))
        return 2;
    return 3;
}

int main()
{
    int N;
    cin >> N;
    player *players = new player[N];
    for (int i = 0; i < N; ++i)
    {
        cin >> players[i].height;
        cin >> players[i].wingspan;
        cin >> players[i].midScore;
        cin >> players[i].midUp;
        cin >> players[i].midPer;
    }
    
    for (int i = 0; i < N; ++i)
    {
        count(players[i]);
        cout << getCateg(players[i]) << endl;
    }
    
    return 0;
}

