#include <iostream>

using namespace std;
/*
 3
230
190
16
7
9
205
225
15
5
2
210
210
30
9
9
 */
const int h_l = 190;
const int h_m = 205;
const int h_h = 220;

const int w_l = 200;
const int w_m = 225;
const int w_h = 250;

const int s_l = 10;
const int s_m = 15;
const int s_h = 20;

const int r_l = 2;
const int r_m = 4;
const int r_h = 6;

const int p_l = 3;
const int p_m = 5;
const int p_h = 7;

int in_up(int h, int w, int s, int r, int p) {
    return (h > h_h) + (w > w_h) + (s > s_h) + (r > r_h) + (p > p_h);
}

int in_mid(int h, int w, int s, int r, int p) {
    return (h >= h_m) + (w >= w_m) + (s >= s_m) + (r >= r_m) + (p >= p_m);
}

int in_low(int h, int w, int s, int r, int p) {
    return (h >= h_l) + (w >= w_l) + (s >= s_l) + (r >= r_l) + (p >= p_l);
}
int in_in(int h, int w, int s, int r, int p) {
    int result = 0;
    result += (h_l <= h && h <= h_h);
    result += (w_l <= w && w <= w_h);
    result += (s_l <= s && s <= s_h);
    result += (r_l <= r && r <= r_h);
    result += (p_l <= p && p <= p_h);
    return result;
}

bool check_0(int h, int w, int s, int r, int p) {
    return (in_up(h, w, s, r, p) == 3 && (h > h_h || w > w_h));
}

bool check_1(int h, int w, int s, int r, int p) {
    return ((in_up(h, w, s, r, p) == 2 && in_mid(h, w, s, r, p) == 3) || (in_low(h, w, s, r, p) == 5 && in_mid(h, w, s, r, p) >= 3));
}

bool check_2(int h, int w, int s, int r, int p) {
    return ((in_up(h, w, s, r, p) == 1 && in_mid(h, w, s, r, p) == 2) || (in_mid(h, w, s, r, p) >= 3));
}

int main() {
    size_t N;
    std::cin >> N;

    for (size_t i = 0; i < N; ++i) {
        int h, w, s, r, p;
        std::cin >> h >> w >> s >> r >> p;

        if (check_0(h, w, s, r, p)) {
            cout << 0 << endl;
        } else if (check_1(h, w, s, r, p)) {
            cout << 1 << endl;
        } else if (check_2(h, w, s, r, p)) {
            cout << 2 << endl;
        } else {
            cout << 3 << endl;
        }
    }

    return 0;
}
