#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cmath>
#include <stack>
#include <bitset>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define forn(i,n) for(int i=0;i<n;i++)
#define fornr(i,n) for(int i=n-1;i>=0;i--)
#define forab(i,a,b) for(int i=a;i<b;i++)
#define pb push_back
#define all(v) v.begin(),v.end()
#define sz(v) int(v.size())
#define first fst
#define second snd
#define make_pair mp

typedef double dbl;
typedef unsigned long long ull;
typedef long long ll;
typedef vector<int> vi;

const int N = int(1e5) + 100;

int deg[N];
vi adj[N];

map<vi, vi> withAdj;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int p, t, m;
    cin >> p >> t >> m;
    forn(i, m) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        deg[u]++;
        adj[u].pb(v);
    }
    int best = N;
    forn(i, t) {
        best = min(deg[i], best);
    }
    cout << p - best << " ";
    int bestCnt = 0;
    vi *bestV = NULL;
    forn(i, t) {
        if (deg[i] == best) {
            sort(all(adj[i]));
            withAdj[adj[i]].pb(i + 1);
            if (sz(withAdj[adj[i]]) > bestCnt) {
                bestCnt = sz(withAdj[adj[i]]);
                bestV = &withAdj[adj[i]];
            }
        }
    }
    cout << bestCnt << '\n';
    for (int x : *bestV) {
        cout << x << " ";
    }
    cout << '\n';
    return 0;
}