#include <iostream>
#include <string>
#include <vector>
#include <deque>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;

    if (n < 4) {
        cout << 0;
        return 0;
    }

    vector<ll> vans(8);
    vans[4] = 4;
    for (int i = 5; i < 8; i++) {
        vans[i] = i*pow(26,i-4) + vans[i-1];
    }

    ll mod = 1e9 + 7;
    ll ans = 1;
    while (n > 8) {
        ans *= vans[4];
        ans %= mod;
        n -= 4;
    }
    ans *= vans[n];
    ans %= mod;

    cout << ans;

    return 0;
}