import java.io.*
import java.util.*

fun solve() {
    var n = readLong()
    var sq = Math.sqrt(n.toDouble()).toLong() + 10
    for (i in 3..Math.min(n, sq)) {
        if (n % i == 0L) {
            out.println(i)
            return
        }
    }
    if (n % 2 == 0L)
        out.println(n / 2)
    else
        out.println(n)
}

fun main() {
    solve()
    out.close()
}

var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)
var tok = StringTokenizer(" ")

fun readString(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine())
    }
    return tok.nextToken()
}

fun readInt() = readString().toInt()
fun readLong() = readString().toLong()