import java.io.*
import java.util.*

fun solve() {
    var n = readString().toCharArray()
    var x = n.last().toInt() - '0'.toInt()
    if (n.size == 1) {
        when (x) {
            1, 2, 3, 5, 7 -> {
                out.println(-1)
            }
            else -> {
                out.println("10 ${if (x % 2 == 0) 2 else 3}")
            }
        }
        return
    }
    var sum = 0L
    for (c in n) {
        sum += c.toInt() - '0'.toInt()
    }
    var b = sum + 1
    out.println("$b $sum")
}

fun main() {
    solve()
    out.close()
}

var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)
var tok = StringTokenizer(" ")

fun readString(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = readString().toInt()
fun readLong() = readString().toLong()