import java.io.*
import java.util.*

var mod = 1_000_000_007

fun solve() {
    var n = readInt()
    var pow = 1
    if (n < 4) {
        out.println(0)
        return
    }
    var sum = 0L
    for (k in 4..n) {
        var now = k * pow % mod
        sum = (sum + now) % mod
        pow = pow * 26 % mod
    }
    out.println(sum)
}

fun main() {
    solve()
    out.close()
}

var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)
var tok = StringTokenizer(" ")

fun readString(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = readString().toInt()
fun readLong() = readString().toLong()