import java.io.*
import java.math.BigInteger
import java.util.*

var mod = 1_000_000_007.toBigInteger()

fun solve() {
    var n = readInt().toBigInteger()
    var a = "26".toBigInteger()
    a = a.modPow(n, mod)
    var c = (-1 + (3 * 26 * 26 + 2 * 26 + 1) * 25 * 25).toBigInteger()
    var s = (a * (n * 25.toBigInteger() - 1.toBigInteger()) - c) * 508680659.toBigInteger()
    s = s.mod(mod)
    out.println(s)
}

fun main() {
    solve()
    out.close()
}

var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)
var tok = StringTokenizer(" ")

fun readString(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = readString().toInt()
fun readLong() = readString().toLong()