#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
using namespace std;
typedef long long ll;
//
//int sum(vector<int>& v) {
//    int s = 0;
//    for (int elem : v) {
//        s += elem;
//    }
//
//    return s;
//}
//
//void test() {
//
//}
//
//const int maxN[23];
//int f[maxN];
//int f(int x) {
//    return x & -x;
//}
//int get(int i) {
//    int sum = 0;
//    for(;i > 0; i -= f(x)) {
//        sum += f[i];
//    }
//    return sum;
//}

//struct cht {
//    vector<int>
//};

const int maxA = 26;
const int maxN = 2e5 + 10;

struct node {
    int go[maxA];
    int go_cnt[maxA];
    int down;
    int down_depth;
    bool term;
    int sz;
};


node t[maxN];
int t_last = 2;
int root = 1;
const int NONE = 0;

void add(string s) {
    int v = root;
    for(int i = 0; i < s.size(); i++) {
        t[v].sz++;
        int c = s[i] - 'a';
        if(t[v].go[c] == NONE) {
            t[v].go[c] = t_last++;
        }
        v = t[v].go[c];
    }
    t[v].term = true;
    t[v].sz++;
}

void calc_down(int v) {
    int down_cnt = 0;
    int ch = -1;
    for(int i = 0; i < maxA; i++) {
        if(t[v].go[i] != NONE) {
            calc_down(t[v].go[i]);
            ch = i;
            down_cnt++;
        }
    }
    if(t[v].term) {
        t[v].down = v, t[v].down_depth = 0;
    }
    else {
        if (down_cnt == 0)
            t[v].down = v, t[v].down_depth = 0;
        if (down_cnt == 1)
            t[v].down = t[t[v].go[ch]].down, t[v].down_depth = 1 + t[t[v].go[ch]].down_depth;
        if (down_cnt > 1)
            t[v].down = v, t[v].down_depth = 0;
    }
    return;
}

void compress(int v) {
    for(int i = 0; i < maxA; i++) {
        if(t[v].go[i] == NONE) {
            continue;
        }
        t[v].go_cnt[i] = 1 + t[t[v].go[i]].down_depth;
        t[v].go[i] = t[t[v].go[i]].down;
        compress(t[v].go[i]);
    }
}

string words[maxN];

int solve(int k, string s) {
    int v = root;
    int ans = 0;
    int credit = 0;
    credit += k * t[v].go_cnt[s[0]-'a'];
    int i = t[v].go_cnt[s[0] - 'a'];
    v = t[v].go[s[0] - 'a'];
    for(; i < s.size();) {
        int c = s[i] - 'a';
        int other_cnt = t[v].sz - t[t[v].go[c]].sz;
        if(other_cnt >= credit) {
            ans += credit;
            //cerr << credit << endl;
            credit = 0;
        } else {
            ans += other_cnt;
            //cerr << other_cnt << endl;
            credit -= other_cnt;
        }
        int add_i = t[v].go_cnt[c];
        i += add_i;
        credit += k * t[v].go_cnt[c];
        v = t[v].go[c];
    }
    //cerr << min(credit, t[v].sz) << endl;
    ans += min(credit, t[v].sz);
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> words[i];
        add(words[i]);
    }
    calc_down(root);
    compress(root);
    int q;
    cin >> q;
    for(int i = 0; i < q; i++) {
        int w, k;
        cin >> w >> k;
        cout << solve(k, words[w - 1]) << "\n";
    }
    return 0;
}







/*int main() {
    #ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    #endif // _DEBUG
    int a;
    cin >> a;
    std::cout << "Hello, World!" << a << std::endl;
    auto x = 44;
    return 0;
}*/

