#include <bits/stdc++.h>

using namespace std;

struct graph {
    vector<vector <int>> leftVector;
    vector<vector <int>> rightVector;

    graph(int left, int right): leftVector(left), rightVector(right) {
    }

    void addEdge(int left, int right) {
        left--;
        right--;
        leftVector[left].push_back(right);
        rightVector[right].push_back(left);
    }

    int getCntTask() {
        int mincnt = leftVector.size();
        for (int i = 0; i < rightVector.size(); i++) {
            mincnt = min(mincnt, (int)rightVector[i].size());
        }
        return mincnt;
    }

    void getAns() {
        map<vector<int>, vector<int>> ansMap;
        int revAns = getCntTask();

        for (int i = 0; i < rightVector.size(); i++) {
            if (rightVector[i].size() == revAns) {
                vector <int> tmp(revAns);
                for (int j = 0; j < rightVector[i].size(); j++) {
                    tmp[j] = rightVector[i][j];
                }

                if (ansMap.count(tmp) == 0) {
                    vector <int> x(1, i);
                    ansMap[tmp] = x;
                } else {
                    ansMap[tmp].push_back(i);
                }
            }
        }

        vector <int> ans;
        for (auto x: ansMap) {
            if (ans.size() < x.second.size()) {
                ans = x.second;
            }
        }

        cout << (leftVector.size() - revAns) << ' ' << ans.size() << endl;
        for (auto x: ans) {
            cout << x + 1 << ' ';
        }
    }
};


int main() {
    int P, T, M;
    cin >> P >> T >> M;
    graph gr(P, T);
    for (int i = 0; i < M; i++) {
        int left, right;
        cin >> left >> right;
        gr.addEdge(left, right);
    }
    gr.getAns();

    return 0;
}
