#include <bits/stdc++.h>

using namespace std;

int64_t getHashByVector(vector <int> &v) {
    int64_t h = 1;
    for (int i = 0; i < v.size(); i++) {
        h *= 100003;
        h += v[i];
    }
    return h;
}

struct graph {
    vector<vector <int>> leftVector;
    vector<vector <int>> rightVector;

    graph(int left, int right): leftVector(left), rightVector(right) {
    }

    void addEdge(int left, int right) {
        left--;
        right--;
        leftVector[left].push_back(right);
        rightVector[right].push_back(left);
    }

    int getCntTask() {
        int mincnt = leftVector.size();
        for (int i = 0; i < rightVector.size(); i++) {
            mincnt = min(mincnt, (int)rightVector[i].size());
        }
        return mincnt;
    }

    void doSort() {
        for (int i = 0; i < rightVector.size(); i++) {
            sort(rightVector[i].begin(), rightVector[i].end());
        }
    }

    void getAns() {
        doSort();
        unordered_map<int64_t, vector<int>> ansMap;
        int revAns = getCntTask();
        if ((leftVector.size() - revAns) == 0){
            cout << "0 0";
            exit(0);
        }

        for (int i = 0; i < rightVector.size(); i++) {
            if (rightVector[i].size() == revAns) {
                int64_t h = getHashByVector(rightVector[i]);
                if (ansMap.count(h) == 0) {
                    vector <int> x(1, i);
                    ansMap[h] = x;
                } else {
                    ansMap[h].push_back(i);
                }
            }
        }

        vector <int> ans;
        for (auto x: ansMap) {
            if (ans.size() < x.second.size()) {
                ans = x.second;
            }
        }
        cout << (leftVector.size() - revAns) << ' ' << ans.size() << endl;
        for (auto x: ans) {
            cout << x + 1 << ' ';
        }
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int P, T, M;
    cin >> P >> T >> M;
    graph gr(P, T);
    for (int i = 0; i < M; i++) {
        int left, right;
        cin >> left >> right;
        gr.addEdge(left, right);
    }
    gr.getAns();

    return 0;
}
