#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <set>
#include <string>
#include <deque>
#include <stack>
#include <queue>

#define MP make_pair
#define PB push_back
#define F first
#define S second
#define EPS 1e-7
#define MOD 1000000007

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long double ld;

struct player {
    int h = 0;
    int w = 0;
    int s = 0;
    int r = 0;
    int p = 0;
};

int cnt_more(player el) {
    int cnt = 0;
    if (el.h > 220)
        cnt++;
    if (el.w > 250)
        cnt++;
    if (el.s > 20)
        cnt++;
    if (el.r > 6)
        cnt++;
    if (el.p > 7)
        cnt++;
}


int cnt_up(player el) {
    int cnt = 0;
    if (el.h > (220 + 190) / 2)
        cnt++;
    if (el.w > 450 / 2)
        cnt++;
    if (el.s > 30 / 2)
        cnt++;
    if (el.r > 4)
        cnt++;
    if (el.p > 5)
        cnt++;
}

int cnt_lo(player el) {
    int cnt = 0;
    if (el.h >= 190)
        cnt++;
    if (el.w >= 200)
        cnt++;
    if (el.s >= 10)
        cnt++;
    if (el.r >= 2)
        cnt++;
    if (el.p >= 3)
        cnt++;
}



int category(player el) {
    if (cnt_more(el) >= 3 && (el.h > 220 || el.w > 250))
        return 0;
    if ((cnt_more(el) >= 2 && cnt_up(el) > 2) || (cnt_up(el) >= 3 || cnt_lo(el) == 5))
        return 1;
    if ((cnt_more(el) >= 1 && cnt_up(el) > 1) || (cnt_up(el) >= 3))
        return 2;
    return 3;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<player> arr(n);
    for (auto &el: arr)
        cin >> el.h >> el.w >> el.s >> el.r >> el.p;
    for (auto &el: arr)
        cout << category(el) << '\n';
    return 0;
}

/*
3
230
190
16
7
9
205
225
15
5
2
210
210
30
9
9
 */