#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <stack>
#include <queue>
#include <wtypes.h>

using namespace std;
using ll=long long;



int main() {
	ios::sync_with_stdio(0);
	int p, m, t; cin >> p >> t >> m;
	vector<vector<int>> g(t);
	while (m--) {
		int a, b; cin >> a >> b;
		a--; b--;
		g[b].push_back(a);
	}
	for (auto& x : g) sort(x.begin(), x.end());
	map<vector<int>, int> mp;
	
	int sz = 1e9;
	for (auto x : g) sz = min(sz, (int)x.size());
	for (auto x : g)
		if (x.size() == sz)
			mp[x]++;

	int kek = (*mp.begin()).second;
	vector<int> best = (*mp.begin()).first;
	int r = 0;
	for (auto x : mp)
		if (x.second > kek)
			kek = max(x.second, kek), best = x.first;

	cout << p - sz << " " << kek<< endl;
	for (int i = 0; i < t; i++) {
		if (g[i].size() == sz && g[i] == best)
			cout << i + 1 << " ";
	}
	cout << endl; 

}