#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <stack>
#include <queue>
#include <wtypes.h>

using namespace std;
using ll=long long;
int N = 2e7;
vector<int> ch(N);
int num = 1;

vector<vector<int>> g(N, vector<int>(26,-1));
vector<int> countt(N, 0);
vector<int> deg(N, 0);
vector<string>  word(N,"");
vector<int> endd(N);
vector<int> parent(N, -1);



void dfs(int u) {
	for (auto v : g[u]) {
		if (v != -1) {
			parent[v] = u;
			dfs(v);
			countt[u] += countt[v];
			
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		word[i] = s;
		int u = 0;
		int j = 0;
		while (j < s.size()) {
			if (g[u][s[j]-'a'] == -1)
			{
				g[u][s[j]-'a'] = num;
				num++;
			}
			u = g[u][s[j]-'a'];
			
			j++;
		}
		endd[i] = u;
		countt[u]++;

	}
	dfs(0);
	int t;
	cin >> t;
	vector<int> ans(t);
	vector<vector<pair<int,int>>> kek(N);
	for (int i = 0; i < t; i++) {
		int w, k;
		cin >> w >> k;
		--w;
		kek[w].push_back({ k,i });
	}
	for (int i = 0; i < n; i++) {
		int u = endd[i];
		vector<int> r = { countt[u] };
		while (u != 0) {
			int newu = parent[u];
			int h = countt[newu] - countt[u];
			r.push_back(h);
			u = newu;
		}
		reverse(r.begin(), r.end());
		vector<int> pref(r.size() + 1);
		pref[0] = 0;
		for (int j = 0; j < r.size(); j++) {
			pref[j + 1] = pref[j] + r[j];
		}
		for (auto p : kek[i]) {
			int t = 1;
			int k = p.first;
			int j = 1;
			int curans = 0;
			int cursum = 0;
			while (cursum< pref[r.size()]) {
				t++;
				int newj = lower_bound(pref.begin(), pref.end(), k+cursum) - pref.begin();
				if (newj < r.size() + 1) {
					curans += k;
					if (t == newj)
						cursum = pref[newj];
					else
						cursum += k;
				}
				else {
					curans +=min(pref[r.size()] - cursum,k);
					cursum = pref[r.size()];

				}
				j = newj;
				
			}
			ans[p.second] = curans;
		}
	}
	for (auto a : ans) cout << a << '\n';
}