#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int q;
    cin >> q;
    stack<char> s;
    bool ok = true;
    while (q--) {
        string x;
        cin >> x;
        char c;
        cin >> c;
        if (x[0] == 'A') {
            s.push(c);
        } else {
            if (s.empty() || s.top() != c) {
                ok = false;
            } else {
                s.pop();
            }
        }
    }
    ok = ok & s.empty();
    if (ok) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }

    return 0;
}