#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;

const int N = 1e6 + 5;

int n1, n2, m;
vector<int> g[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    cin >> n1 >> n2 >> m;

    for (int u, v, i = 0; i < m; i++) {
        cin >> u >> v;
        g[v].push_back(u);
    }

    int res = 0;

    for (int i = 1; i <= n2; i++) {
        sort(g[i].begin(), g[i].end());
        res = max(res, n1 - (int) g[i].size());
    }

    cout << res << " ";

    vector<int> p(n2);
    for (int i = 0; i < n2; i++) {
        p[i] = i + 1;
    }

    sort(p.begin(), p.end(), [&](int i, int j) {
        return g[i] < g[j];
    });

    vector<int> tasks;

    for (int i = 0; i < n2; i++) {
        int j = i;
        while (j < n2 && g[ p[i] ] == g[ p[j] ]) j++;
        j--;
        int cnt = j - i + 1;
        if (cnt > (int) tasks.size() && n1 - (int) g[p[i]].size() == res) {
            tasks.clear();
            for (int q = i; q <= j; q++) {
                tasks.push_back(p[q]);
            }
        }
        i = j;
    }

    sort(tasks.begin(), tasks.end());

    cout << (int) tasks.size() << "\n";

    for (int x : tasks) {
        cout << x << " ";
    }

    cout << "\n";

    return 0;
}