#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

template <typename T> smin(T &a, const T&b) { a = (a < b ? a : b); }
template <typename T> smax(T &a, const T&b) { a = (a > b ? a : b); }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

int solve();

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
ordered_set q;

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef HOME
        freopen("in", "r", stdin);
      freopen("out", "w", stdout);
    #endif
    solve();
    return 0;
}

struct point
{
    int a, b, c, d;
    bool arms, h;
};

vector<point> v;

void update(point &cur, int x, int l, int r)
{
    cur.a++;
    if (x >= l)
        cur.b++;
    if (x >= (r - l + 1) / 2)
        cur.c++;
    if (x > r)
        cur.d++;
    return;

}

bool first(point a)
{
    if (!a.arms && !a.h)
        return 0;
    return a.d >= 3;
}

bool second(point a)
{
    if (a.d >= 2 && a.c >= 3)
        return 1;
    if (a.b == 5 && a.c >= 3)
        return 1;
    return 0;
}

bool third(point a)
{
    if (a.d >= 1 && a.c >= 2)
        return 1;
    if (a.c >= 3)
        return 1;
    return 0;
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int h, w, s, r, p;
        cin >> h >> w >> s >> r >> p;
        point cur = {0, 0, 0, 0, 0, 0};
        if (h > 220)
            cur.h = 1;
        if (w > 250)
            cur.arms = 1;
        update(cur, h, 190, 220);
        update(cur, w, 200, 250);
        update(cur, s, 10, 20);
        update(cur, r, 2, 6);
        update(cur, p, 3, 7);
        v.push_back(cur);
    }
    for (int i = 0; i < n; i++)
    {
        if (first(v[i]))
        {
            cout << 0 << endl;
            continue;
        }
        if (second(v[i]))
        {
            cout << 1 << endl;
            continue;
        }
        if (third(v[i]))
        {
            cout << 2 << endl;
            continue;
        }
        cout << 3 << endl;
    }
    return 0;
}
