#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds; //gp_hash_table<int,int> table;

template <typename T> smin(T &a, const T&b) { a = (a < b ? a : b); }
template <typename T> smax(T &a, const T&b) { a = (a > b ? a : b); }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

int solve();

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
ordered_set q;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef HOME
        freopen("in", "r", stdin);
      freopen("out", "w", stdout);
    #endif
    solve();
    return 0;
}

int n;
vector <vector <int > > a;
vector <bool > used;

void dfs(int v)
{
    used[v] = 1;
    for (int i = 0; i < a[v].size(); i++)
        if (!used[a[v][i]])
            dfs(a[v][i]);
}

int solve()
{
    ll n;
    cin >> n;
    for (ll i = 3; i * i <= n; i++)
    {
        if (n % i == 0)
            return cout << i, 0;
    }
    if (n / 2 != 2 && n % 2 == 0)
        return cout << n / 2, 0;
    cout << n;
    return 0;
}
