#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds; //gp_hash_table<int,int> table;

template <typename T> smin(T &a, const T&b) { a = (a < b ? a : b); }
template <typename T> smax(T &a, const T&b) { a = (a > b ? a : b); }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

int solve();

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
ordered_set q;

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef HOME
        freopen("in", "r", stdin);
      freopen("out", "w", stdout);
    #endif
    solve();
    return 0;
}

#define pii pair<ll, ll>
#define X first
#define Y second
#define mp make_pair
#define pb push_back
#define ld long double

struct line
{
    ll a, b, c;
};

vector<pii> v;
vector<line> up, down;
vector<ll> L, R;
pii p1, p2;

bool cmp(line x, line y)
{
    return x.a * y.b > y.a * x.b;
}

bool cmp_down(line x, line y)
{
    return x.a * y.b < y.a * x.b;
}

ll get_y(ll x, line cur)
{
    return ceil((ld)(-cur.c - cur.a * x) / (ld)(cur.b));
}

ll get_y_down(ll x, line cur)
{
    return floor((ld)(-cur.c - cur.a * x) / (ld)(cur.b));
}


void get_sol_up(vector<line> &up, vector<ll> &ans)
{
    ans.resize(p2.X + 1);
    sort(up.begin(), up.end(), cmp);
    int cur = 0;
    for (ll i = p1.X; i <= p2.X; i++)
    {
        while (cur + 1 < (int)up.size() && get_y(i, up[cur]) < get_y(i, up[cur + 1]))
            cur++;
        ans[i] = get_y(i, up[cur]);
    }
    return;
}

void get_sol_down(vector<line> &down, vector<ll> &ans)
{
    ans.resize(p2.X + 1);
    sort(down.begin(), down.end(), cmp_down);
  //  for (int i = 0; i < down.size(); i++)
//        cout <<Down[i].a << ' ' <<
    int cur = 0;
    for (ll i = p1.X; i <= p2.X; i++)
    {
        while (cur + 1 < (int)down.size() && get_y_down(i, down[cur]) > get_y_down(i, down[cur + 1]))
            cur++;
        ans[i] = get_y_down(i, down[cur]);
    }
    return;
}

const ll INF = (ll)1e9;

int solve()
{
    p1 = mp(0, 0);
    int n;
    cin >> p2.X >> p2.Y >> n;
    v.resize(n);
    for (int i = 0; i < n; i++)
        cin >> v[i].X >> v[i].Y;
    for (int i = 0; i < n; i++)
    {
        line cur;
        cur.a = 2 * (v[0].X - v[i].X);
        cur.b = 2 * (v[0].Y - v[i].Y);
        cur.c = v[i].X * v[i].X + v[i].Y * v[i].Y - v[0].X * v[0].X - v[0].Y * v[0].Y;
        if (cur.a == 0 && cur.b == 0)
        {
            if (cur.c < 0)
            {
                cout << 0 << endl;
                return 0;
            }
            continue;
        }
        if (cur.a == 0)
        {
            if (cur.b > 0)
            {
                p1.Y = max(p1.Y, (ll)ceil((ld)(-cur.c) / (ld)(cur.b)));
            }
            else
            {
                p2.Y = min(p2.Y, -cur.c / cur.b);
            }
            continue;
        }
        if (cur.b == 0)
        {
            if (cur.a > 0)
            {
                p1.X = max(p1.X, (ll)ceil((ld)(-cur.c) / (ld)(cur.a)));
            }
            else
            {
                p2.X = min(p2.X, -cur.c / cur.a);
            }
            continue;
        }
        if (cur.b > 0)
            up.pb(cur);
        else
            down.pb(cur);
    }
    L.resize(p2.X + 1);
    R.resize(p2.X + 1);
    for (int i = 0; i <= p2.X; i++)
    {
        L[i] = -INF;
        R[i] = INF;
    }
    if (!up.empty())
        get_sol_up(up, L);
    if (!down.empty())
        get_sol_down(down, R);
    ll ans = 0;
    for (int i = p1.X; i <= p2.X; i++)
    {
        ll tl = max(p1.Y, L[i]);
        ll tr = min(p2.Y, R[i]);
        //cout << i << ' ' << tl << ' ' << tr << '\n';
        if (tr < tl)
            continue;
        ans += tr - tl + 1;
    }
    cout << ans << endl;
    return 0;
}
