#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <deque>
#include <algorithm>

#define sz size()
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define fori(i, s, n) for (int i = (s); (i) < (n); ++(i))

typedef long long LL;

using namespace std;

LL M = 1000000007;

LL msum(LL a, LL b) {
    return (a + b) % M;
}

LL mmpl(LL a, LL b) {
    return (a * b) % M;
}

LL msub(LL a, LL b) {
    return (a - b + M) % M;
}

LL mbin_pow(LL x, LL e) {
    LL res = 1;
    while (e) {
        if (e % 2 == 1) {
            res = mmpl(res, x);
        }
        x =mmpl(x, x);
        e /= 2;
    }
    return res;
}

LL mrev(LL x) {
    return mbin_pow(x, M - 2);
}

LL mdiv(LL a, LL b) {
    return mmpl(a, mrev(b));
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
    LL n;
    cin >> n;
    if (n < 4) {
        cout << 0;
        return 0;
    }
    LL c = 26;
    LL d1 = mmpl((n + 1), mmpl(c - 1, mbin_pow(c, n)));
    LL d2 = msub(mbin_pow(c, n + 1), 1);
    LL d = msub(d1, d2);
    d = mdiv(d, (mmpl(c - 1, c - 1)));
    LL ans = msub(d, 1);
    ans = msub(ans, mmpl(2, c));
    ans = msub(ans, mmpl(3, mmpl(c, c)));
    ans = mdiv(ans, mbin_pow(c, 3));
    cout << ans;
	return 0;
}