#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <deque>
#include <algorithm>

#define sz size()
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define fori(i, s, n) for (int i = (s); (i) < (n); ++(i))

typedef long long LL;

using namespace std;

vector <int> t[100003];

LL sum(LL a, LL b, LL M) {
    return (a + b) % M;
}

LL mpl(LL a, LL b, LL M) {
    return (a * b) % M;
}

LL Ms[5] = {1000000007, 1000000009, 1, 1, 1};

LL poly[5][100003];

void prec(LL x) {
    fori(i, 0, 5) {
        poly[i][0] = 1;
    }
    fori(i, 0, 5) {
        fori(j, 1, 100003) {
            poly[i][j] = mpl(poly[i][j - 1], x, Ms[i]);
        }
    }
}

vector<LL> thash(int ti) {
    vector <LL> res(5);
    fori(i, 0, t[ti].sz) {
        LL num = t[ti][i];
        fori(j, 0, 5) {
            res[j] = sum(res[j], poly[j][num], Ms[j]);
        }
    }
    return res;
}

int comp(vector <LL>& a, vector<LL>& b) {
    fori(i, 0, 5) {
        if (a[i] != b[i]) {
            return 0;
        }
    }
    return 1;
}

map <vector<LL>, int> goods;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
    prec(2);
    int pn, tn, m;
    cin >> pn >> tn >> m;
    fori(i, 0, m) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        t[b].pb(a);
    }
    int min_deg = pn;
    fori(i, 0, tn) {
        if (t[i].sz <= min_deg) {
            min_deg = t[i].sz;
        }
    }
    fori(i, 0, tn) {
        if (t[i].sz == min_deg) {
            goods[thash(i)] += 1;
        }
    }
    int max_tasks = 0;
    vector <LL> prt;
    for (auto it = goods.begin(); it != goods.end(); ++it) {
        if (it->sc >= max_tasks) {
            max_tasks = it->sc;
            prt = it->fs;
        }
    }
    vector <int> ans;
    fori(i, 0, tn) {
        if (thash(i) == prt) {
            ans.pb(i + 1);
        }
    }
    cout << pn - min_deg << " " << ans.sz << endl;
    fori(i, 0, ans.sz) {
        cout << ans[i] << " ";
    }
	return 0;
}