#include <bits/stdc++.h>

#define ll long long
#define kek lol

using namespace std;

const int maxN = 200005;
const int BUBEN = 1000;
const int SIGMA = 26;

int go[maxN][SIGMA];
int term[maxN];
int sumv[maxN];
int CNT = 0;
int sv[maxN];
vector<pair<int, int>> vertK[maxN];
int ans[maxN];

int newVert() {
    for (int c = 0; c < SIGMA; c++) {
        go[CNT][c] = -1;
    }
    return CNT++;
}

void addStr(int ind, const string& s) {
    int cur = 0;
    for (int i = 0; i < s.size(); i++) {
        if (go[cur][s[i] - 'a'] == -1) {
            go[cur][s[i] - 'a'] = newVert();
        }
        sumv[cur]++;
        cur = go[cur][s[i] - 'a'];
    }
    term[cur]++;
    sumv[cur]++;
    sv[ind] = cur;
}

int process(vector<int>& arr, int k) {
    int x = 0, cnt = 0;
    /*cout << "Proccess" << endl;
    for (int a : arr) {
        cout << a << " ";
    }
    cout << endl;*/
    for (int i = 0; i < arr.size(); i++) {
        while (arr[i] > 0) {
            if (cnt == i + 1) {
                x = 0;
                break;
            }

            int oldx = x;
            x = min(k, x + arr[i]);
            arr[i] -= (x - oldx);
            if (x == k) {
                x = 0;
                cnt++;
            }
        }
    }
    //cout << cnt << " " << x << endl;
    return k * cnt + x;
}

pair<int, int> dp[maxN];

int arr[maxN];
ll pref[maxN];
void solve(int v, int len) {
    for (int c = 0; c < SIGMA; c++) {
        if (go[v][c] == -1) continue;
        int u = go[v][c];

        arr[len - 1] -= sumv[u];
        pref[len] -= sumv[u];
        arr[len] = sumv[u];
        pref[len + 1] = pref[len] + arr[len];

        vector<pair<int, int>> dp_old(BUBEN + 10);
        for (int k = 1; k <= BUBEN; k++) {
            dp_old[k] = dp[k];
            int x = dp[k].first, cnt = dp[k].second;

            if (cnt == len) {
                int y = sumv[u];
                x = y - (k - min(k, x - y));
                if (x >= k) {
                    cnt++;
                }
            }
            dp[k].first = x;
            dp[k].second = cnt;
        }
        solve(go[v][c], len + 1);
        for (int k = 1; k <= BUBEN; k++) {
            dp[k] = dp_old[k];
        }
        arr[len - 1] += sumv[u];
        pref[len] += sumv[u];
    }

    /*cout << v << " " << len << ":  " << endl;
    cout << dp[1].first << " " << dp[1].second << endl;
    for (int i = 0; i <= len; i++) cout << arr[i] << " ";
    cout << endl;*/
    for (auto p : vertK[v]) {
        int k = p.first;
        if (k <= BUBEN) {
            if (dp[k].second == len) {
                dp[k].first = 0;
            }
            ans[p.second] = k * dp[k].second + dp[k].first;
            continue;
        }
        vector<int> carr;
        if (BUBEN < len) {
            int sum = pref[len] - pref[BUBEN];
            carr.resize(BUBEN + 1);
            carr[BUBEN] = sum;
        }
        else {
            carr.resize(len);
        }
        for (int i = 0; i < min(BUBEN, len); i++) carr[i] = arr[i];
        /*for (int c : carr) cout << c << " ";
        cout << endl;*/

        ans[p.second] = process(carr, k);
    }
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);

    newVert();

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        addStr(i, s);
    }

    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int j, k;
        cin >> j >> k;
        j--;
        vertK[sv[j]].push_back({k, i});
    }

    for (int c = 0; c < SIGMA; c++) {
        if (go[0][c] == -1) continue;

        arr[0] = sumv[go[0][c]];
        //cout << arr[0] << endl;
        pref[1] = arr[0];

        for (int k = 1; k <= BUBEN; k++) {
            dp[k].first = arr[0];
            if (dp[k].first >= k) {
                dp[k].second = 1;
            }
        }
        solve(go[0][c], 1);
    }

    //cout << "---------------------" << endl;
    for (int i = 0; i < q; i++) {
        cout << ans[i] << endl;
    }


    return 0;
}
