#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

/**
ll gcd(ll a, ll b) {
	return (b ? gcd(b, a % b) : a);
}

template <typename T>
T sqr(T a) {
	return a * a;
}

class point {
public:
	ld x, y;

	ld dist(point a, point b) {
		return sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
	}
};

//
vector<int> t, tADD, a;

void build(int v, int vl, int vr) {
	if (vl == vr) {
		t[v] = a[vl];
		return;
	}
	int vm = (vl + vr) / 2;
	build(2 * v, vl, vm);
	build(2 * v + 1, vm + 1, vr);
	t[v] = t[2 * v] + t[2 * v + 1];
}

int sum(int v, int vl, int vr, int l, int r) {
	if ((vr < l) || (r < vl)) {
		return 0;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return t[v];
		}
		else {
			int vm = (vl + vr) / 2;
			return sum(2 * v, vl, vm, l, r) + sum(2 * v + 1, vm + 1, vr, l, r);
		}
	}
}

void modify(int v, int vl, int vr, int l, int r, int x) {
	if ((vr < l) || (r < vl)) {
		return;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return;
		}
		else {
			int vm = (vl + vr) / 2;
			return;
		}
	}
}

//
*/

int main() {
	ll n;
	cin >> n;
	
	for (ll i = 3; i * i + 10 <= n; i++) {
		if (n % i == 0) {
			cout << i;
			return 0;
		}
	}
	if (n % 2 == 0 && n > 4) {
		cout << n / 2;
		return 0;
	}
	cout << n;
	/*
	vector <int> a(n + 1, 0);
	int x;
	for (int i = 0; i < n; i++) {
		cin >> x;
		if (x <= n) a[x] = 1;
	}
	int sum = 0;
	for (int i = 1; i <= n; i++) {
		sum += a[x];
	}
	cout << sum;*/
	return 0;
}