#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <chrono>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int n;
	cin >> n;

	vector<int> a(n);

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	sort(a.begin(), a.end());

	int res = 0;
	int lpos = 1;
	int canUse = n;

	for (int i = 0; i < n; i++) {
		if (a[i] < lpos || a[i] - lpos > canUse - 1)
			continue;
		else
		{
			canUse -= a[i] - lpos + 1;
			res++;
			lpos = a[i] + 1;
		}
	}

	cout << res;

	return 0;
}