#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <chrono>
#include <map>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll rem = 1e9 + 7;

ll mpow(ll base, ll exp) {
	ll ans = 1;
	for (; exp > 0; exp >>= 1) {
		if (exp & 1) (ans *= base) %= rem;
		(base *= base) %= rem;
	}
	return ans;
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int n;
	cin >> n;

	if (n < 4) cout << 0;
	else {
		int t = n - 4;
		ll x = (mpow(26, t + 1) + rem - 26) % rem;
		(x *= mpow(25, rem - 2)) %= rem;
		ll s = mpow(26, t + 1) * (t + 4) - 4;
		s = (s - x + rem) % rem;
		(s *= mpow(25, rem - 2)) %= rem;
		cout << s;
	}

	return 0;
}