//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <stack>
#include <unordered_map>
#include <algorithm>

using namespace std;

const int maxm = 1e5;
int f[maxm + 1];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    int n = s.size();
    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        d[i] = s[i] - '0';
    }

    if (n == 1) {
        if (d[0] == 1 || d[0] == 2 || d[0] == 3 || d[0] == 5 || d[0] == 7) {
            cout << -1;
            return 0;
        }
        if (d[0] % 2 == 0) {
            cout << 10 << " " << 2 << endl;
        } else {
            cout << 10 << " " << 3 << endl;
        }
        return 0;
    }

    vector<int> primes;
    for (long long i = 2; i <= maxm; i++) {
        if (!f[i]) {
            primes.push_back(i);
            for (long long j = i * i; j <= maxm; j += i) {
                f[j] = 1;
            }
        }
    }
    
    //cerr << "kek" << endl;

    for (int D: primes) {
        for (int j = 1; j <= D; j++) {
            long long sum = 0;
            for (int i = 0; i < n; i++) {
                sum = (sum * j + d[i]) % D;
            }
            if (sum == 0) {
                cout << ((10 + D - 1) / D) * D + j << " " << D << endl;
                return 0;
            }
        }
    }
    return 0;
}