//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <stack>
#include <unordered_map>

using namespace std;

const int MAXN = 1e5 + 7;

int cnt[MAXN];

vector<int> g[200000];

const int P = 13, mod = 1e9 + 7, mod2 = 1e9 + 9;

int binpow(int a, int b) {
    int res = 1;
    for (; b; b >>= 1) {
        if (b & 1) {
            res = (res * 1ll * a) % mod;
        }
        a = (a * 1ll * a) % mod;
    }
    return res;
}

int hh(vector<int> &a)
{
    int res = 0;
    for(auto i : a)
        res = (res + binpow(P, i)) % mod2;
    return res;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p, t, m, u, v;
    cin >> p >> t >> m;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        g[v].push_back(u);
        cnt[v]++;
    }
    int cntZero = 0;
    for (int i = 1; i <= t; ++i) {
        cntZero += (cnt[i] == 0);
    }
    if (cntZero) {
        cout << p << ' ' << cntZero << '\n';
        for (int i = 1; i <= t; ++i) {
            if (cnt[i] == 0)
                cout << i << ' ';
        }
    } else {
        int ans1 = p, minCnt = 1;
        for (int i = 2; i <= t; ++i) {
            if (cnt[i] < cnt[minCnt]) {
                minCnt = i;
            }
        }
        unordered_map<int, int> map_cnt;
        vector<int> hsh(t + 100);
        for(int i = 1; i <= t; i++)
            if(cnt[i] == cnt[minCnt]) {
                int q = hh(g[i]);
                map_cnt[q]++;
                hsh[i] = q;
            }
        int cnt_m = 1e9 + 100;
        for(auto i : map_cnt)
            if(i.second > map_cnt[cnt_m])
                cnt_m = i.first;

        cout << ans1 - cnt[minCnt] << ' ' << map_cnt[cnt_m] << endl;
//        cout << minCnt;
        for(int i = 1; i <= t; i++)
            if(hsh[i] == cnt_m)
                cout << i << ' ';
    }
    return 0;
}