#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

const int mod = (int)1e9 + 7;
typedef vector<vector<int>> matr;

matr mul(matr A, matr B) {
    matr C = matr(3, vector<int>(3, 0));
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            for (int k = 0; k < 3; ++k) {
                C[i][j] += 1ll * A[i][k] * B[k][j] % mod;
                if (C[i][j] >= mod) {
                    C[i][j] -= mod;
                }
            }
        }
    }
    return C;
}

matr bp(matr A, int p) {
    if (p == 1) {
        return A;
    }
    matr cur = bp(A, p / 2);
    if (p & 1) {
        return mul(mul(cur, cur), A);
    }
    return mul(cur, cur);
}

void solve() {
    int n; cin >> n;
    if (n < 4) {
        cout << 0;
        return;
    }

    matr A = {
            {1, 0, 0},
            {0, 26, 26},
            {1, 0, 26}
    };
    A = bp(A, n - 3);
    cout << (A[1][0] + 4ll * A[2][0]) % mod << "\n";
}