fun readTokens() = readLine()?.split(' ')
fun readLongs() = readTokens()?.map { it.toLong() }

fun hhh(v: Long, range: LongRange) = v > range.endInclusive
fun hh(v: Long, range: LongRange) = v >= range.start + (range.endInclusive - range.start + 1) / 2
fun h(v: Long, range: LongRange) = v in range || hhh(v, range)

fun main() {
    val H = 190L..220L
    val W = 200L..250L
    val S = 10L..20L
    val R = 2L..6L
    val P = 3L..7L

    val (n) = readLongs()!!

    for (i in 0 until n) {
        val (h, w, s, r, p) = listOf(readLongs()!!, readLongs()!!, readLongs()!!, readLongs()!!, readLongs()!!).flatten()

        val ll = listOf(Pair(h, H), Pair(w, W), Pair(s, S), Pair(r, R), Pair(p, P))

        if (ll.count { hhh(it.first, it.second) } >= 3 && (hhh(h, H) || hhh(w, W))) {
            println(0)
        } else if (
            ll.count { hhh(it.first, it.second) } >= 2 && ll.count { hh(it.first, it.second) } >= 3
            || ll.count { h(it.first, it.second) } == ll.count() && ll.count { hh(it.first, it.second) } >= 3
        ) {
            println(1)
        } else if (
            ll.count { hhh(it.first, it.second) } >= 1 && ll.count { hh(it.first, it.second) } >= 2
            || ll.count { hh(it.first, it.second) } >= 3
        ) {
            println(2)
        } else {
            println(3)
        }
    }
}