#include <iostream>
#include <vector>
#include <map>
#include <set>
using namespace std;

using ll = long long;

ll hashh(const set<int>& s) {
    //const ll M = 1000000007;

    ll r = 0;

    for (int v : s) {
        r = r * 29 + v;
    }

    return r;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int p, t, m;
    map<int, set<int>> v;
    cin >> p >> t >> m;
    for (int i = 1; i <= t; i++) {
        v[i].size();
    }
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        v[y].insert(x);
    }
    int min = 1e9;
    for (const auto& i : v) {
        if (i.second.size() < min) {
            min = i.second.size();
        }
    }
    map<int, ll> mm;
    for (const auto& i : v) {
        if (i.second.size() == min) {
            mm[i.first] = hashh(i.second);
        }
    }
    map<ll, int> m3;
    ll maxTasks = 0, hash2;
    ll bestHash = mm.begin()->second;
    for (const auto &i : mm) {
        hash2 = i.second;
        m3[hash2]++;
        if(m3[hash2] > maxTasks) {
            maxTasks = m3[hash2];
            bestHash = hash2;
        }
    }


    cout << p - min << " "<< maxTasks << endl;
    for(const auto &i : mm) {
        if(i.second == bestHash) cout <<  i.first << " ";
    }
    return 0;
}