#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<set<uint32_t>> a;
vector<set<uint32_t>> b;
vector<int> task;
vector<int32_t> deg;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int32_t p, t, m;
    cin >> p >> t >> m;
    deg.resize(t, 0);
    a.resize(t);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        deg[v]++;
        a[v].insert(u);
    }
    int min_deg = 1000000;
    for (int i = 0; i < t; i++) {
        if (a[i].size() < min_deg) {
            min_deg = a[i].size();
        }
    }
    for (int i = 0; i < t; i++) {
        if (a[i].size() == min_deg) {
            b.push_back(a[i]);
            task.push_back(i);
        }
    }
    sort(b.begin(), b.end());
    int ans = 0;
    int num = 0;
    int i = 0;
    while (i < b.size()) {
        int j = i;
        while (j < b.size() && b[j] == b[i]) {
            j++;
        }
        if (ans < j - i) {
            ans = j - i;
            num = i;
        }
        i++;
    }
    cout << p - b[num].size() << " " << ans << '\n';
    for (int i = num; i < num + ans; i++) {
        cout << task[i] + 1 << " ";
    }
}