#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<set<uint32_t>> a;
vector<pair<set<uint32_t>, int>> b;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int32_t p, t, m;
    cin >> p >> t >> m;
    a.resize(t);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        a[v].insert(u);
    }
    int min_deg = 1000000;
    for (int i = 0; i < t; i++) {
        if (a[i].size() < min_deg) {
            min_deg = a[i].size();
        }
    }
    for (int i = 0; i < t; i++) {
        if (a[i].size() == min_deg) {
            b.emplace_back(a[i], i);
        }
    }
    sort(b.begin(), b.end());
    int ans = 0;
    int num = 0;
    int i = 0;
    while (i < b.size()) {
        int j = i;
        while (j < b.size() && b[j].first == b[i].first) {
            j++;
        }
        if (ans < j - i) {
            ans = j - i;
            num = i;
        }
        i = j;
    }
    cout << p - b[num].first.size() << " " << ans << '\n';
    for (int i = num; i < num + ans; i++) {
        cout << b[i].second + 1 << " ";
    }
}