#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>
#include <cmath>
#include <unordered_set>

using namespace std;

#define int long long

const int INF = 1e18 + 9;
const int MOD = 1e9 + 9;

vector<vector<int>> cnt;

void height(int x, int i) {
	if (x < 190) {
		cnt[i][0] = 1;
	}
	else if (x < 205) {
		cnt[i][0] = 2;
	}
	else if (x <= 220) {
		cnt[i][0] = 3;
	}
	else{
		cnt[i][0] = 4;
	}
}

void raz(int x, int i) {
	if (x < 200) {
		cnt[i][1] = 1;
	}
	else if (x < 225) {
		cnt[i][1] = 2;
	}
	else if (x <= 250) {
		cnt[i][1] = 3;
	}
	else {
		cnt[i][1] = 4;
	}
}

void point(int x, int i) {
	if (x < 10) {
		cnt[i][2] = 1;
	}
	else if (x < 15) {
		cnt[i][2] = 2;
	}
	else if (x <= 20) {
		cnt[i][2] = 3;
	}
	else {
		cnt[i][2] = 4;
	}
}

void podbor(int x, int i) {
	if (x < 2) {
		cnt[i][3] = 1;
	}
	else if (x < 4) {
		cnt[i][3] = 2;
	}
	else if (x <= 6) {
		cnt[i][3] = 3;
	}
	else {
		cnt[i][3] = 4;
	}
}

void pere(int x, int i) {
	if (x < 3) {
		cnt[i][4] = 1;
	}
	else if (x < 5) {
		cnt[i][4] = 2;
	}
	else if (x <= 7) {
		cnt[i][4] = 3;
	}
	else {
		cnt[i][4] = 4;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	cnt.resize(n, vector<int>(5));

	for (int i = 0; i < n; i++) {
		int a, b, c, d, e;
		cin >> a >> b >> c >> d >> e;
		height(a, i);
		raz(b, i);
		point(c, i);
		podbor(d, i);
		pere(e, i);
		if (cnt[i][0] == 4 || cnt[i][1] == 4) {
			int c = 0;
			for (int j = 0; j < 5; j++) {
				if (cnt[i][j] == 4)
					c++;
			}
			if (c >= 3) {
				cout << "0\n";
				continue;
			}
		}
		int cnt4 = 0;
		int cnt3 = 0;
		int cnt2 = 0;
		for (int j = 0; j < 5; j++) {
			if (cnt[i][j] == 4)
				cnt4++;
			else if (cnt[i][j] == 3)
				cnt3++;
			if (cnt[i][j] >= 2) {
				cnt2++;
			}
		}
		if ((cnt4 >= 2 && cnt3 + (cnt4 - 2) >= 1) || (cnt3 + cnt4 >= 3 && cnt2 == 5)) {
			cout << "1\n";
			continue;
		}
		if ((cnt4 >= 1 && cnt3 + (cnt4 - 1) >= 1) || (cnt3 + cnt4 >= 3)) {
			cout << "2\n";
			continue;
		}
		cout << "3\n";
	}
	

	return 0;
}