#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>
#include <cmath>
#include <unordered_set>

using namespace std;

#define int long long

const int INF = 1e18 + 9;
const int MOD = 1e9 + 9;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int p, t, m;
	cin >> p >> t >> m;
	vector<vector<int>> a(t);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		v--;
		a[v].push_back(u);
	}

	int ans = 0;
	for (int i = 0; i < t; i++) {
		ans = max(ans, p - a[i].size());
	}

	cout << ans << ' ';

	unordered_map<string, vector<int>> dict;
	int maxi = 0;
	string tt;
	for (int i = 0; i < t; i++){
		string s;
		if (ans == p - a[i].size()) {
			for (int j = 0; j < a[i].size(); j++) {
				s += to_string(a[i][j]) + ' ';
			}
			dict[s].push_back(i + 1);
			if (dict[s].size() > maxi) {
				maxi = dict[s].size();
				tt = s;
			}
		}
	}

	cout << maxi << '\n';
	for (int i = 0; i < dict[tt].size(); i++)
		cout << dict[tt][i] << ' ';

	return 0;
}