
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(239);


#define pb push_back
#define ob pop_back
#define mp make_pair
#define eb emplace_back
#define char unsigned char
#define sz(x) ((int)((x).size()))

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<ld> vd;
typedef vector<bool> vb;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef vector<vi> vvi;

template<typename T>
istream& operator>>(istream &in, vector<T> &v)
{
    for (int i = 0; i < sz(v); i++)
        in >> v[i];
    return in;
}

template<typename T, typename S>
istream& operator>>(istream &in, pair<T, S> &v)
{
    in >> v.first >> v.second;
    return in;
}

template<typename T, typename S>
pair<T, S> operator+(const pair<T, S>& a, const pair<T, S>& b)
{
    return mp(a.first + b.first, a.second + b.second);
}

template<typename T, typename S>
pair<T, S> operator-(const pair<T, S>& a, const pair<T, S>& b)
{
    return mp(a.first - b.first, a.second - b.second);
}

const int N = 1005;

string s[N];

const int T = 4;

pair<int, int> go[T][N][N];

int dx[] = {0, -1, 0, 1};
int dy[] = {-1, 0, 1, 0};

int comp[N][N];

void dfs(int x, int y, int col)
{
    comp[x][y] = col;
     for (int dir = 0; dir < 4; dir++)
     {
         int i = x + dx[dir], j = y + dy[dir];
         if (!comp[i][j] && s[i][j] == '.')
            dfs(i, j, col);
     }
}

const int M = N * N;

vector<int> g[M];
vector<pair<pair<int, int>, int> > from[M];

int used[N][N];

int curkek = 0;

int pr[N][N];

char dira[] = {'L', 'U', 'R', 'D'};

string gogo(int x, int y, int xx, int yy)
{
    curkek++;
    used[x][y] = curkek;
    queue<pair<int, int>> q;
    q.push({x, y});
    while (curkek != used[xx][yy] && sz(q))
    {
        int x = q.front().first, y = q.front().second;
        q.pop();
        for (int i = 0; i < 4; i++)
        {
            int nx = x + dx[i], ny = y + dy[i];
            if (s[nx][ny] == '.' && used[nx][ny] != curkek)
            {
                used[nx][ny] = curkek;
                pr[nx][ny] = (i + 2) % 4;
                q.push({nx, ny});
            }
        }
    }
    string ans = "";
    while (xx != x || yy != y)
    {
        ans.push_back(dira[(pr[xx][yy] + 2) % 4]);
        ans.push_back('M');
        int xxx = xx + dx[pr[xx][yy]], yyy = yy + dy[pr[xx][yy]];
        xx = xxx;
        yy = yyy;
    }
    //reverse(ans.begin(), ans.end());
    return ans;
}

int main()
{
#ifdef ONPC
    freopen("int.txt", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    int sx, sy, tx, ty;
    cin >> sx >> sy >> tx >> ty;
    sx--;
    sy--;
    tx--;
    ty--;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (s[i][j] != 'W')
            {
                for (int k = 0; k < 2; k++)
                {
                    int x = i + dx[k], y = j + dy[k];
                    if (s[x][y] == 'W')
                    {
                        go[k][i][j] = {i, j};
                    }
                    else
                        go[k][i][j] = go[k][x][y];
                }
            }
    for (int i = n - 1; i >= 0; i--)
        for (int j = m - 1; j >= 0; j--)
            if (s[i][j] != 'W')
            {
                for (int k = 2; k < 4; k++)
                {
                    int x = i + dx[k], y = j + dy[k];
                    if (s[x][y] == 'W')
                    {
                        go[k][i][j] = {i, j};
                    }
                    else
                        go[k][i][j] = go[k][x][y];
                }
            }
    int cur = 1;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (comp[i][j] == 0 && s[i][j] == '.')
                dfs(i, j, cur++);
    vector<int> good(cur, 0);
    vector<pair<int, int> > pos(cur);
    vector<int> dir(cur, 0);
    for (int i = 0; i < n; i++)
        for (int j = 0;  j < m; j++)
            if (s[i][j] == '.')
            {
                for (int k = 0; k < 4; k++)
                    if (s[i + dx[k]][j + dy[k]] == 'W')
                    {
                        good[comp[i][j]] = 1;
                        pos[comp[i][j]] = {i, j};
                        dir[comp[i][j]] = k;
                    }
            }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (s[i][j] == '.' && good[comp[i][j]])
            {
                for (int k = 0; k < 4; k++)
                {
                    int gox = go[k][i][j].first, goy = go[k][i][j].second;
                    if (s[gox][goy] == '.')
                    {
                        g[comp[i][j]].push_back(comp[gox][goy]);
                        from[comp[i][j]].push_back({{i, j}, k});
                    }
                }
            }
    queue<int> q;
    q.push(comp[sx][sy]);
    const int INF = 1e9 + 7;
    vector<int> d(cur, INF), p(cur, 0), e(cur, 0);

    d[comp[sx][sy]] = 0;
    while (sz(q) && d[comp[tx][ty]] == INF)
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); i++)
        {
            int u = g[v][i];
            if (d[u] > d[v] + 1)
            {
                d[u] = d[v] + 1;
                p[u] = v;
                e[u] = i;
                q.push(u);
            }
        }
    }
    if (d[comp[tx][ty]] == INF)
    {
        cout << "-1 -1\n";
        return 0;
    }
    /*else if (d[comp[tx][ty]] == 0)
        cout << "0\n";
    else
        cout << d[comp[tx][ty]] + 1 << endl;*/
    int aaaa = d[comp[tx][ty]];
    string ans = "";
    while (comp[sx][sy] != comp[tx][ty])
    {
        int fromc = p[comp[tx][ty]];
        int ed = e[comp[tx][ty]];
        auto keke = from[fromc][ed];
        int fx = keke.first.first, fy = keke.first.second;
        int dr = keke.second;
        int ourx = go[dr][fx][fy].first, oury = go[dr][fx][fy].second;
        string kek = gogo(ourx, oury, tx, ty);
        for (int i = 0; i < sz(kek); i++)
            ans.push_back(kek[i]);
        int xx = pos[fromc].first, yy = pos[fromc].second;
        int dirr = dir[fromc];
        bool ok = 1;
        if (fromc != comp[sx][sy])
        {
            ok = 0;
            int lastc = p[fromc];
            int edd = e[fromc];
            auto lol = from[lastc][edd];
            int xxx = lol.first.first;
            int yyy = lol.first.second;
            dirr = lol.second;//(lol.second + 2) % 4;
            xx = go[dirr][xxx][yyy].first;
            yy = go[dirr][xxx][yyy].second;
            //dirr = (lol.second + 2) % 4;
        }
        ans.push_back(dira[dirr]);
        ans.push_back('M');
        if (ok)
        {
            ans.push_back(dira[dirr]);
            ans.push_back('P');
        }
        //cout << fx + 1 << ' ' << fy + 1 << ' ' << xx + 1 << ' ' << yy + 1 << endl;
        kek = gogo(fx, fy, xx, yy);
        for (int i = 0; i < sz(kek); i++)
            ans.push_back(kek[i]);
        ans.push_back(dira[dr]);
        ans.push_back('P');
        tx = fx;
        ty = fy;
    }
    auto kek = gogo(sx, sy, tx, ty);
    for (int i = 0; i < sz(kek); i++)
            ans.push_back(kek[i]);
    int cnt = 0;
    for (int i = 0; i < sz(ans); i++)
        if (ans[i] == 'M')
            cnt++;
    cout << sz(ans) / 2 - cnt << ' ' << cnt << endl;
    reverse(ans.begin(), ans.end());
    int aa = 0;
    for (int i = 0; i < ans.size(); i++)
        if (ans[i] == 'P')
        {

            if (aa == 1 || (aa > 0 && aa % 2 == 0))
                ans[i] = 'O';
            else
                ans[i] = 'B';
            aa++;
        }
    for (int i = 0; i < sz(ans); i += 2)
        cout << ans[i] << ans[i + 1] << '\n';
    return 0;
}

// IMP IS IOI & ISAF27 IS HSE (CHSV)

// HA SOSITE CHMOSHNIKI S TRANSLYAZII
