
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(239);


#define pb push_back
#define ob pop_back
#define mp make_pair
#define eb emplace_back
#define char unsigned char
#define sz(x) ((int)((x).size()))

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<ld> vd;
typedef vector<bool> vb;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef vector<vi> vvi;

template<typename T>
istream& operator>>(istream &in, vector<T> &v)
{
    for (int i = 0; i < sz(v); i++)
        in >> v[i];
    return in;
}

template<typename T, typename S>
istream& operator>>(istream &in, pair<T, S> &v)
{
    in >> v.first >> v.second;
    return in;
}

template<typename T, typename S>
pair<T, S> operator+(const pair<T, S>& a, const pair<T, S>& b)
{
    return mp(a.first + b.first, a.second + b.second);
}

template<typename T, typename S>
pair<T, S> operator-(const pair<T, S>& a, const pair<T, S>& b)
{
    return mp(a.first - b.first, a.second - b.second);
}

struct Point
{
    ll x, y;

    Point(ll x, ll y) : x(x), y(y) {}


};

struct Line
{
    ll a, b, c;
    Line(ll a, ll b, ll c): a(a), b(b), c(c) {}
    ll operator()(Point p)
    {
        return a * p.x + b * p.y + c;
    }
};


Line serper(Point a, Point b)
{
    return Line(2 * (b.x - a.x), 2 * (b.y - a.y), a.y * a.y - b.y * b.y + a.x * a.x - b.x * b.x);
}

bool cmp(Line l, Line k)
{
    return l.a * k.b > l.b * k.a;
}

bool eq(Line l, Line k)
{
    return l.a * k.b == l.b * k.a;
}

pair<ll, ll> pod(Line l, ll x)
{
    return make_pair(l.a * x + l.c, -l.b);
}

pair<ll, ll> per(Line l, Line k)
{
    ll A = (l.c * k.b - k.c * l.b);
    ll B = (k.a * l.b - k.b * l.a);
    if (B < 0)
    {
        A = -A;
        B = -B;
    }
    return {A, B};
}

vector<ll> f(vector<Line> ls, ll w)
{
    vector<ll> ans(w + 1, 0);
    sort(ls.begin(), ls.end(), cmp);
    //cout << "LINES \n";
    //for (int i = 0; i < ls.size(); i++)
    //    cout << ls[i].a << ' ' << ls[i].b << ' ' << ls[i].c << endl;
    vector<Line> bst;
    //cout << "per 0 1 " << per(ls[0], ls[1]).first << ' ' << per(ls[0], ls[1]).second << endl;
    //cout << "per 1 2 " << per(ls[1], ls[2]).first << ' ' << per(ls[1], ls[2]).second << endl;
    //cout << "per 0 2 " << per(ls[0], ls[2]).first << ' ' << per(ls[0], ls[2]).second << endl;
    for (Line l : ls)
    {
        while (sz(bst) >= 2)
        {
            if (eq(bst.back(), l))
                break;
            auto a = per(l, bst.back());
            auto b = per(l, bst[sz(bst) - 2]);
            ld AA = (ld)a.first / (ld)a.second;
            ld BB = (ld)b.first / (ld)b.second;
            ld CC = AA - BB;
            if (abs(CC) >= 1e-3)
            {
                if (AA > BB)
                    break;
            }
            else
            {
                ll xx =  a.first * b.second - a.second * b.first;
                if (xx > 0)
                    break;
            }
            bst.pop_back();
        }
        if (sz(bst) && eq(bst.back(), l))
        {
            if (bst.back().c * l.b < l.c * bst.back().b)
            {
                bst.pop_back();
                bst.push_back(l);
            }
        }
        else
        {
            bst.push_back(l);
        }
    }
    /*cout << "BST \n";
    for (int i = 0; i < bst.size(); i++)
        cout << bst[i].a << ' ' << bst[i].b << ' ' << bst[i].c << endl;
    cout << "\n";*/
    for (int x = 0; x <= w; x++)
    {
        int l = -1, r = sz(bst) - 1;
        while (r - l > 1)
        {
            int mid = (r + l) / 2;
            pair<ll, ll> f = pod(bst[mid], x), s = pod(bst[mid + 1], x);
            if (f.first * s.second >= f.second * s.first)
                r = mid;
            else
                l = mid;
        }
        pair<ll, ll> t = pod(bst[r], x);
        ll A = t.first, B = t.second;
        A = A + B - 1;
        A -= (A % B + B) % B;
        A /= B;
        ans[x] = A;
        //cout << x << ' ' << r << ' ' << ans[x] << endl;
    }
    return ans;
}

int main()
{
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int w, h, n;
    cin >> w >> h >> n;
    vector<Point> p;
    for (int i = 0; i < n; i++)
    {
        ll x, y;
        cin >> x >> y;
        p.push_back(Point(x, y));
    }
    vector<Line> l;
    for (int i = 1; i < n; i++)
        l.push_back(serper(p[0], p[i]));
    vector<Line> vert, down, up;
    for (int i = 0; i < sz(l); i++)
    {
        if (l[i].b == 0)
            vert.push_back(l[i]);
        else if (l[i].b < 0)
            down.push_back(l[i]);
        else
            up.push_back(l[i]);
    }
    down.push_back(Line(0, -1, 0));
    up.push_back(Line(0, 1, -h));
    ll L = 0, R = w;
    for (int i = 0; i < sz(vert); i++)
    {
        if (l[i].a < 0)
        {
            ll t = (l[i].c - 1) / (-l[i].a) + 1;
            L = max(L, t);
        }
        else
        {
            ll t = (-l[i].c) / l[i].a;
            R = min(R, t);
        }
    }
    /*cout << "DOWN \n";
    for (int i = 0; i < down.size(); i++)
        cout << down[i].a << ' ' << down[i].b << ' ' << down[i].c << endl;
    cout << "UP \n";
    for (int i = 0; i < up.size(); i++)
        cout << up[i].a << ' ' << up[i].b << ' ' << up[i].c << endl;*/
    for (int i = 0; i < sz(up); i++)
        up[i].b = -up[i].b;
    //f(down, 3);
    //return 0;
    vector<ll> d = f(down, w), u = f(up, w);
    for (int i = 0; i < sz(u); i++)
        u[i] = -u[i];
    ll ans = 0;
    for (int i = L; i <= R; i++)
    {
        //cout << "Vertical line " << i << ": d = " << d[i] << ", u = " << u[i] << '\n';
        ans += max(0LL, u[i] - d[i] + 1);
    }
    cout << ans << endl;
    return 0;
}

// IMP IS IOI & ISAF27 IS HSE (CHSV)

// HA SOSITE CHMOSHNIKI S TRANSLYAZII
