#include <algorithm>
#include <iostream>
#include <cstdio>
#include <string>
#include <bitset>
#include <vector>
//#include <random>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	vector<pair<int, int>> ab;
	ab.push_back({ 190,220 });
	ab.push_back({ 200,250 });
	ab.push_back({ 10,20 });
	ab.push_back({ 2,6 });
	ab.push_back({ 3,7 });

	int n; cin >> n;
	for (int i = 0; i < n; i++) {
		vector<int> ds(5);
		for (int j = 0; j < 5; j++) {
			int P; cin >> P;
			if (P > ab[j].second) {
				ds[j] = 4;
			}
			else if (P >= (ab[j].first + ab[j].second) / 2) {
				ds[j] = 3;
			}
			else if (P >= ab[j].first) {
				ds[j] = 2;
			}
			else {
				ds[j] = 1;
			}
		}

		//
		int cnt_4 = 0;
		int cnt_3 = 0;
		int cnt_2 = 0;
		int cnt_1 = 0;
		for (int j = 0; j < 5; j++) {
			if (ds[j] == 4) {
				cnt_4++;
			}
			if (ds[j] == 3) {
				cnt_3++;
			}
			if (ds[j] == 2) {
				cnt_2++;
			}
			if (ds[j] == 1) {
				cnt_1++;
			}
		}
		//

		//--------------------------------------------------------------------------------------------
		if ((ds[0] == 4 || ds[1] == 4) && (cnt_4 >= 3)) {
			cout << "0\n";
			continue;
		}
		//--------------------------------------------------------------------------------------------

		if (cnt_4 >= 3 || (cnt_4 == 2 && cnt_3 >= 1)) {
			cout << "1\n";
			continue;
		}

		if (cnt_1 == 0 && (cnt_3 + cnt_4 >= 3)) {
			cout << "1\n";
			continue;
		}
		//--------------------------------------------------------------------------------------------

		if (cnt_4 >= 2 || (cnt_4 == 1 && cnt_3 >= 1)) {
			cout << "2\n";
			continue;
		}
		if (cnt_3 + cnt_4 >= 3) {
			cout << "2\n";
			continue;
		}

		//--------------------------------------------------------------------------------------------
		cout << "3\n";
	}

	return 0;
}
/*
3
230
190
16
7
9

205
225
15
5
2

210
210
30
9
9

*/