#include <algorithm>
#include <iostream>
#include <cstdio>
#include <string>
#include <bitset>
#include <vector>
//#include <random>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll MOD = 1e9 + 7;

ll bin_pow(ll x, ll y) {
	if (y == 0) {
		return 1;
	}
	ll z = bin_pow(x, y >> 1);
	if (y & 1) {
		return z * z % MOD * x % MOD;
	}
	else {
		return z * z % MOD;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	if (n <= 3) {
		cout << 0;
		return 0;
	}
	if (n <= 4) {
		cout << 4;
		return 0;
	}
	
	ll ans;
	ans = ((26*26 *(bin_pow(26,n-5)-1)%MOD)*bin_pow(25,MOD-2)) % MOD + (bin_pow(26,n-4) * 5) % MOD;
	
	cout << (ans + 4) % MOD;
	return 0;

}
