#include <iostream>
#include <vector>
#include <algorithm>

#define forx(x, n) for(int x = 0; x < n; x++)
#define fori(n) forx(i, n)
#define ll long long

using namespace std;

struct player {
	int h, w, s, r, p;
};

int catH(player h) {
	if (h.h < 190)
		return 0;
	if (h.h < 205)
		return 1;
	if (h.h < 220)
		return 2;
	return 3;
}

int catW(player h) {
	if (h.w < 200)
		return 0;
	if (h.w < 225)
		return 1;
	if (h.w < 250)
		return 2;
	return 3;
}

int catS(player h) {
	if (h.s < 10)
		return 0;
	if (h.s < 15)
		return 1;
	if (h.s < 20)
		return 2;
	return 3;
}

int catR(player h) {
	if (h.r < 2)
		return 0;
	if (h.r < 4)
		return 1;
	if (h.r < 6)
		return 2;
	return 3;
}

int catP(player h) {
	if (h.p < 3)
		return 0;
	if (h.p < 5)
		return 1;
	if (h.p < 7)
		return 2;
	return 3;
}

int cat3(player tom) {
	int cnt = 0;
	cnt += (catH(tom) == 3);
	cnt += (catW(tom) == 3);
	cnt += (catS(tom) == 3);
	cnt += (catR(tom) == 3);
	cnt += (catP(tom) == 3);
	return cnt;
}

int cat2(player tom) {
	int cnt = 0;
	cnt += (catH(tom) >= 2);
	cnt += (catW(tom) >= 2);
	cnt += (catS(tom) >= 2);
	cnt += (catR(tom) >= 2);
	cnt += (catP(tom) >= 2);
	return cnt;
}

int cat1(player tom) {
	int cnt = 0;
	cnt += (catH(tom) >= 1);
	cnt += (catW(tom) >= 1);
	cnt += (catS(tom) >= 1);
	cnt += (catR(tom) >= 1);
	cnt += (catP(tom) >= 1);
	return cnt;
}

bool is0(player tom) {
	if (catH(tom) == 3 || catW(tom) == 3) {
		return cat3(tom) >= 3;
	}
	return false;
}

bool is1(player tom) {
	return (cat2(tom) >= 3 && cat3(tom) >= 2 ||
		cat1(tom) == 5 && cat2(tom) >= 3);
}

bool is2(player tom) {
	return (cat2(tom) >= 2 && cat3(tom) >= 1 ||
		cat2(tom) >= 3);
}

int cat(player tom) {
	if (is0(tom))
		return 0;
	if (is1(tom))
		return 1;
	if (is2(tom))
		return 2;
	return 3;
}

int main() 
{
	int n;
	cin >> n;
	vector<player> v(n);
	fori(n) 
		cin >> v[i].h >> v[i].w >> v[i].s >> v[i].r >> v[i].p;
	
	fori(n) 
		cout << cat(v[i]) << endl;

	return 0;
}

/*
3
230
190
16
7
9
205
225
15
5
2
210
210
30
9
9



*/

/*

3 5 6
1 1
1 2
2 1
2 3
3 1
3 3

*/