#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

#define forx(x, n) for(int x = 0; x < n; x++)
#define fori(n) forx(i, n)
#define ll long long
#define ull unsigned ll
#define MOD 1000000007

using namespace std;

ull gcd(ull a, ull b)
{
	if (a == 0 || b == 0)
		return 1;

	if (a == 1 || b == 1)
		return 1;

	if (a > b)
	{
		if (a & b == 0)
			return b;
		return gcd(b, a & b);
	}
	else
	{
		if (b % a == 0)
			return a;
		return gcd(a, b % a);
	}
}

ull binpow(ull a, ull b)
{
	if (b == 0)
		return 1;

	if (b == 1)
		return a;

	if (b % 2)
		return (a * binpow((a * a) % MOD, b / 2)) % MOD;

	return binpow((a * a) % MOD, b / 2);
}

int lastDigit(string& s, int base) {
	ull left = 0;
	ull ptr = 0;
	ull len = s.size();

	while (ptr < len) {
		left *= 10;
		left += (s[ptr] - '0');
		if (left >= base)
			left = left % base;
		ptr++;
	}
	return left;
}

int main()
{
	string s;
	cin >> s;

	if (s == "1" || s == "3" || s == "5" || s == "7") {
		cout << -1;
		return 0;
	}

	if (s == "9") {
		cout << "10 3";
		return 0;
	}

	if ((s[s.size() - 1] - '0') % 2 == 0) {
		cout << "10 2";
		return 0;
	}



	/*
	if (s.size() == 1) {
		cout << s << " " << 2;
		return 0;
	}
	*/

	int b, x;
	b = 9;
	x = 2;

	while (b >= 3) {
		if (lastDigit(s, b) % x == 0)
			break;
		b -= 2;
	}
	cout << b << " " << x;

	/*
	ull n;
	cin >> n;

	if (n <= 3)
	{
		cout << 0;
		return 0;
	}

	if (n == 4)
	{
		cout << 4;
		return 0;
	}

	ull ans = 0;


	ans = (ans + (n - 3) * 26) % MOD;
	ans = (ans + (binpow(26, n - 4) * 3) % MOD);

	cout << ans;
	system("pause");
	*/

	return 0;
}