#include <iostream>
#include <set>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stack>
#include <bitset>
#include <map>

using namespace std;

#define int long long

int const md = (int)1e9 + 7;
int p =(int) 1e5 + 13;

int hasher(set<int>&s) {
	int res = 0;
	int pp = 1;
	for (int a : s) {
		res += a * pp;
		res %= md;
		pp *= p;
		p %= md;
	}

	return res;
}

#undef int
int main() {

#define int long long
	ios_base::sync_with_stdio(false);
	int c, t, m;
	cin >> c >> t >> m;
	int MAX_T = 100000 + 1;
	vector < set <int> >a (100001);
	vector <int> h(MAX_T, -1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		a[v].insert(u);
	}
	for (int i = 1; i <= t; ++i) {
		h[i] = hasher(a[i]);
	}

	int mn = (int)1e9;
	for (int i = 1; i <= t; ++i) {
		mn = min(mn, (int)a[i].size());
	}

	map <int, int> cnt;
	for (int i = 1; i <= t; ++i) {
		if (a[i].size() == mn) {
			cnt[h[i]]++;
		}
	}
	int mx_t = -1;
	int mx_h = -1;
	for (auto pr : cnt) {
		if (pr.second > mx_t) {
			mx_t = pr.second;
			mx_h = pr.first;
		}
	}

	int ind = -1;
	vector <int> ans_t;
	for (int i = 1; i <= t; ++i) {
		if (mx_h == h[i]) {
			ans_t.push_back(i);
			ind = i;
		}
	}
	cout << c - a[ind].size() << " " << mx_t << "\n";
	for (int i = 0; i < mx_t; ++i) {
		cout << ans_t[i] << " ";
	}
	return 0;
}