#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())
#define ALL(v) v.begin(), v.end()
#define SZ(x) szof(x)
#define TYPEMAX(T) std::numeric_limits<T>::max()
#define TYPEMIN(T) std::numeric_limits<T>::min()

using namespace std;
typedef pair<int, int> pii;
typedef long long ll;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll l, ll r) {
	return ll_distr(tw) % (r - l + 1) + l;
}

template <typename T>
T input() {
	T res; cin >> res; return res;
}

template <typename IT>
void input_seq(IT a, IT b) {
	generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

const int max_n = (1 << 18);

struct line_t {
	int64_t k;
	int64_t b;
	
	int64_t eval(int64_t x) {
		return k * x + b;
	}
};

const line_t kek = line_t {TYPEMIN(int64_t), TYPEMIN(int64_t)};

line_t tree[2 * max_n];

#define log log_kudah

vector<pair<int64_t*, int64_t>> log;

void undo(int tm) {
	while (SZ(log) > tm) {
		*(log.back().first) = log.back().second;
		log.pop_back();
	}
}

void ass(int64_t& x, int64_t v) {
	log.emplace_back(&x, x);
	x = v;
}

int64_t get_min(int x) {
	int64_t res = TYPEMAX(int64_t);
	
	for (int p = max_n + x; p != 0; p = p / 2)
		if (tree[p].k != TYPEMIN(int64_t))
			res = min(res, tree[p].eval(x));
		
	return res;
}

void add_line(int no, int nl, int nr, line_t lin) {
	if (tree[no].k == TYPEMIN(int64_t)) {
		ass(tree[no].k, lin.k);
		ass(tree[no].b, lin.b);

	} else {
		int m = nl + (nr - nl) / 2;
		
		if (tree[no].eval(m) > lin.eval(m)) {
			auto vl = tree[no];
			ass(tree[no].k, lin.k);
			ass(tree[no].b, lin.b);
			lin = vl;
		}
		
		if (nr - nl == 1)
			return;
		
		if (lin.k > tree[no].k) {
			add_line(2 * no, nl, m, lin);
		} else {
			add_line(2 * no + 1, m, nr, lin);
		}
	}
}

struct node_t {
	node_t() {
		std::fill(go, go + 26, nullptr);
	}
	
	std::forward_list<pair<int, int>> list;
	node_t* go[26];
	int sz = 0;
};

void solve() {
	for (int i = 0; i < 2 * max_n; ++i)
		tree[i] = kek;
	
	node_t* root = new node_t();
	
	int n = input<int>();
	vector<node_t*> where(n);
	for (int i = 0; i < n; ++i) {
		string s = input<string>();
		
		node_t* cur = root;
		cur->sz += 1;
		
		for (char ch: s) {
			if (cur->go[ch - 'a'] == nullptr)
				cur->go[ch - 'a'] = new node_t();
			
			cur = cur->go[ch - 'a'];
			cur->sz += 1;
		}
		
		where[i] = cur;
	}	
		
	int q = input<int>();
	vector<int> ans(q);
	
	for (int i = 0; i != q; ++i) {
		int x, y;
		cin >> x >> y;
		
		auto& lst = where[x - 1]->list;
		lst.insert_after(lst.before_begin(), make_pair(y, i));
	}
	
	std::function<void(node_t*, int)> dfs = [&](node_t* v, int dep) {
		auto the_size = SZ(log);
		if (dep) {
			//cerr << "add " << dep - 1 << " " << v->sz << "\n";
			add_line(1, 0, max_n, line_t {dep - 1, v->sz});
		}
		
		for (auto quer: v->list)
			ans[quer.second] = min(dep * (int64_t)quer.first,
			get_min(quer.first));
		
		for (int i = 0; i < 26; ++i)
			if (v->go[i])
				dfs(v->go[i], dep + 1);
			
		undo(the_size);
		cerr << "undo\n";
	};
	
	dfs(root, 0);
	
	for (int i = 0; i < q; ++i)
		cout << ans[i] << "\n";
}

int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(5) << fixed;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cout << setprecision(15) << fixed;
	
	solve();
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "time: " << (end_time - start_time) * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}