#include <bits/stdc++.h>


#define ll long long
#define ld long double
#define uint unsigned int
#define fi first
#define se second
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) static_cast<int>(a.size())
#define mp(a, b) make_pair(a, b)

constexpr int N = 100000;
constexpr int inf = static_cast<int>(1e9) + 1;
constexpr ll big = static_cast<ll>(1e18) + 1;
constexpr int MOD = static_cast<int>(1e9) + 7;
ld const eps = 1e-9;


using namespace std;

template<typename T>
void print(vector<T> const& s) {
    for (auto x : s)
        cout << x << " ";
    cout << endl;
}

vector<pair<int, int>> p = {
    {190, 220}, {200, 250}, {10, 20}, {2, 6}, {3, 7}
};

bool isUnicorn(vector<int> v){
    if (v[0] <= p[0].second && v[1] <= p[1].second)
        return false;
    int cntMore = 0;
    for (int i = 0; i < 5; i++)
        if (v[i] > p[i].second)
            cntMore++;
    return cntMore >= 3;
}

bool upper(int i, int val){
    return p[i].second - val <= val - p[i].first;
}

bool lower(int i, int val){
    return p[i].second - val > val - p[i].first;
}

bool low(int i, int val){
    return val >= p[i].first;
}

bool isOne(vector<int> v){
    int cntMore = 0;
    for (int i = 0; i < 5; i++)
        if (v[i] > p[i].second)
            cntMore++;
    //cout << cntMore << endl;
    if (cntMore >= 3) {
        for (int i = 0; i < 5; i++)
            if (upper(i, v[i]) && v[i] <= p[i].second)
                return true;
        if (cntMore == 3)
            return true;
    }
    int cnt = 0;
    for (int i = 0; i < 5; i++){
        if (low(i, v[i]))
            return false;
        if (!lower(i, v[i])){
            cnt++;
        }
    }
    return cnt >= 3;
}

bool isTwo(vector<int> v){
    int cntMore = 0;
    for (int i = 0; i < 5; i++)
        if (v[i] > p[i].second)
            cntMore++;
    if (cntMore >= 1) {
        for (int i = 0; i < 5; i++)
            if (upper(i, v[i]) && v[i] <= p[i].second)
                return true;
        if (cntMore == 2)
            return true;
    }
    int cnt = 0;
    for (int i = 0; i < 5; i++){
        if (upper(i, v[i])){
            cnt++;
        }
    }
    return cnt >= 3;
}


int main()
{
    freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        vector<int> v(5);
        for (int i = 0; i < 5; i++)
            cin >> v[i];
        if (isUnicorn(v)) {
            cout << 0 << '\n';
            continue;
        }
        //cout << "HERE" << endl;
        if (isOne(v)) {
            cout << 1 << "\n";
            continue;
        }
        if (isTwo(v))
            cout << 2 << '\n';
        else
            cout << 3 << '\n';
    }
    return 0;
}
