#include <bits/stdc++.h>


#define ll long long
#define ld long double
#define uint unsigned int
#define fi first
#define se second
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) static_cast<int>(a.size())
#define mp(a, b) make_pair(a, b)

constexpr int N = 200000;
constexpr int inf = static_cast<int>(1e9) + 1;
constexpr ll big = static_cast<ll>(1e18) + 1;
constexpr int MOD = static_cast<int>(1e9) + 7;
ld const eps = 1e-9;

using namespace std;

int go[N + 1][26];
int sum[N + 1];
int nv = 0;
string a[N];

void add_str(string &s)
{
    int cur = 0;
    sum[cur]++;
    for (char c : s)
    {
        c -= 'a';
        if (go[cur][c] == -1)
        {
            rep(i, 0, 26)
            {
                go[nv][i] = -1;
            }
            go[cur][c] = nv++;
        }
        cur = go[cur][c];
        sum[cur]++;
    }
}

int endDO;

//int ttt = 0;
//int used[(N + 1) * 4];
int cnt_v;
bool flag[(N + 1) * 4];
int sett[(N + 1) * 4];
int add[(N + 1) * 4];
int minval[(N + 1) * 4];

/*void settDefault(int u)
{
    used[u] = ttt;
    flag[u] = false;
    add[u] = 0;
}*/

void push(int u, int l, int r)
{
    assert(r - l > 1);
    //assert(u * 2 + 1 - (cnt_v - 1) < endDO);
    //assert(u * 2 + 2 - (cnt_v - 1) < endDO);
    if (flag[u])
    {
        flag[u * 2 + 1] = flag[u * 2 + 2] = true;
        sett[u * 2 + 1] = sett[u * 2 + 2] = sett[u];
        add[u * 2 + 1] = add[u * 2 + 2] = 0;
        minval[u * 2 + 1] = sett[u] - ((l + r) / 2 - 1);
        minval[u * 2 + 2] = sett[u] - (r - 1);
    }
    add[u * 2 + 1] += add[u];
    add[u * 2 + 2] += add[u];
    minval[u * 2 + 1] += add[u] * ((l + r) / 2 - 1);
    minval[u * 2 + 2] += add[u] * (r - 1);
    flag[u] = false;
    add[u] = 0;
}

void updatesett(int x, int lx, int rx, int l, int r, int s)
{
    if (lx >= r || l >= rx)
        return;
    else if (lx >= l && rx <= r)
    {
        flag[x] = true;
        sett[x] = s;
        add[x] = 0;
        minval[x] = s - (r - 1);
    }
    else
    {
        push(x, lx, rx);
        updatesett(x * 2 + 1, lx, (lx + rx) / 2, l, r, s);
        updatesett(x * 2 + 2, (lx + rx) / 2, rx, l, r, s);
        minval[x] = minval[x * 2 + 2];
    }
}

void updateAdd(int x, int lx, int rx, int l, int r, int v)
{
    if (lx >= r || l >= rx)
        return;
    else if (lx >= l && rx <= r)
    {
        add[x] += v;
        minval[x] += v * (r - 1);
    }
    else
    {
        push(x, lx, rx);
        updateAdd(x * 2 + 1, lx, (lx + rx) / 2, l, r, v);
        updateAdd(x * 2 + 2, (lx + rx) / 2, rx, l, r, v);
        minval[x] = minval[x * 2 + 2];
    }
}

void init(int n, int v)
{
    cnt_v = 1;
    while (cnt_v < n)
    {
        cnt_v <<= 1;
    }
    updatesett(0, 0, cnt_v, 0, cnt_v, v);
}

int findPos(int x, int lx, int rx, int l, int r, int b)
{
    if (lx >= r || l >= rx)
    {
        return lx - 1;
    }
    else if (lx >= l && rx <= r)
    {
        if (rx - lx == 1)
        {
            if (minval[x] >= b)
                return lx;
            else
                return lx - 1;
        }
        else
        {
            push(x, lx, rx);
            if (minval[x * 2 + 1] < b)
                return findPos(x * 2 + 1, lx, (lx + rx) / 2, l, r, b);
            else
                return findPos(x * 2 + 2, (lx + rx) / 2, rx, l, r, b);
        }
    }
    else
    {
        int val = findPos(x * 2 + 2, (lx + rx) / 2, rx, l, r, b);
        if (val >= (lx + rx) / 2)
        {
            return val;
        }
        else
        {
            return findPos(x * 2 + 1, lx, (lx + rx) / 2, l, r, b);
        }
    }
}

int get(int x, int lx, int rx, int p)
{
    if (rx - lx == 1)
    {
        return minval[x] + lx;
    }
    push(x, lx, rx);
    if (p < (lx + rx) / 2)
    {
        return get(x * 2 + 1, lx, (lx + rx) / 2, p);
    }
    else
    {
        return get(x * 2 + 2, (lx + rx) / 2, rx, p);
    }
}

vector<int> prefs;
map<int, int> mapa;

void solve(string &s, vector<pair<int, int> > &Ks)
{
    endDO = cnt_v;
    prefs.clear();
    mapa.clear();
    int cur = 0;
    int ppp = sz(Ks) - 1;
    for (int i = 0; i < sz(s); i++)
    {
        cur = go[cur][s[i] - 'a'];
        int B = 0;
        if (i + 1 < sz(s))
            B = sum[go[cur][s[i + 1] - 'a']];
        int pos = findPos(0, 0, cnt_v, 0, endDO, B);
        int pos1 = findPos(0, 0, cnt_v, 0, endDO, 0);

        if (pos1 + 1 < endDO)
        {
            while (ppp >= 0 && Ks[ppp].fi >= pos1 + 1)
            {
                mapa[Ks[ppp].fi] = get(0, 0, cnt_v, Ks[ppp].fi);
                ppp--;
            }
        }

        prefs.push_back(pos1);
        assert(endDO >= pos1 + 1);
        assert(pos1 >= pos);
        endDO = pos1 + 1;
        updatesett(0, 0, cnt_v, 0, pos + 1, B);
        updateAdd(0, 0, cnt_v, pos + 1, pos1 + 1, -1);
    }
    sort(prefs.begin(), prefs.end());
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    rep(i, 0, 26)
    {
        go[nv][i] = -1;
    }
    nv++;
    int n;
    cin >> n;
    rep(i, 0, n)
    {
        cin >> a[i];
        add_str(a[i]);
    }
    int q;
    cin >> q;
    vector<pair<int, int> > Ks[n];
    rep(i, 0, q)
    {
        int w, K;
        cin >> w >> K; w--;
        Ks[w].push_back({K, i});
    }
    int ans[q];
    rep(i, 0, n)
    {
        if (sz(Ks[i]) == 0)
            continue;
        sort(Ks[i].begin(), Ks[i].end());
        init(n + 1, sum[go[0][a[i][0] - 'a']]);
        solve(a[i], Ks[i]);
        for (auto it : Ks[i])
        {
            int K = it.fi;
            int res = K * (prefs.end() - lower_bound(prefs.begin(), prefs.end(), K));
            if (K >= endDO)
            {
                //res += get(0, 0, cnt_v, K);
                res += mapa[K];
            }
            ans[it.se] = res;
        }
    }
    vector<int> goodans = {6, 7, 5, 5, 7, 4};
    rep(i, 0, q)
    {
        cout << ans[i] << "\n";
        if (n == 7 && q == 6)
            assert(false);
        if (n == 7 && q == 6)
            assert(ans[i] == goodans[i]);
    }
    return 0;
}
