#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 mt(736);


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	ll n;

	cin >> n;

	for (ll i = 3; i * i <= n; i++)
		if (n % i == 0)
		{
			cout << i << endl;

			return;
		}

	if (n > 4 && n % 2 == 0)
		n /= 2;
	cout << n << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << clock() / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
