#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 mt(736);

const int inf = 1e9 + 7;

int div(vector<int> arr, int p)
{
	while (arr.size() > p)
	{
		arr[arr.size() - p] += arr.back();
		arr.pop_back();
	}

	for (auto &it : arr)
		it %= p;

	for (int k = 1; k < p; k++)
	{
		int mult = 1;

		ll sum = 0;

		for (auto it : arr)
		{
			sum += mult * it;
			sum %= p;

			mult *= k;
			mult %= p;
		}

		if (sum == 0)
			return p + k;
	}

	return -1;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	string str;

	cin >> str;

	auto least_div = [](int n) {
		for (int i = 2; i * i <= n; i++)
			if (n % i == 0)
				return i;

		return n;
	};

	if (str.size() == 1)
	{
		int n = stoi(str);

		if (least_div(n) != n)
		{
			cout << "10 " << least_div(n) << endl;

			return;
		}

		cout << -1 << endl;

		return;
	}
	if (str.back() == '0')
	{
		cout << "10 2" << endl;

		return;
	}

	reverse(str.begin(), str.end());

	vector<int> c;
	c.reserve(str.size());

	for (auto it : str)
		c.push_back(it - '0');

	int tmp;

	for (int p = 3e3; clock() < 1.5 * CLOCKS_PER_SEC; p++)
		if (least_div(p) == p && (tmp = div(c, p)) != -1)
		{
			cout << tmp << ' ' << p << endl;

			return;
		}

	cout << -1 << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << clock() / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
