#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 mt(736);

const int inf = 1e9 + 7;

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int p, t, e;

	cin >> p >> t >> e;
	vector<vector<int>> g(t);

	for (int i = 0; i < e; i++)
	{
		int y, x;
		cin >> y >> x;
		--x, --y;

		g[x].push_back(y);
	}

	mt19937_64 rng (736);
	vector<ll> val(p);
	for (ll &x : val)
		x = rng() % (1LL << 60);

	ll total = 0;
	for (ll &x : val)
		total ^= x;

	vector<int> cnt(t);
	vector<ll> res_val(t, total);

	for (int i = 0; i < t; i++)
	{
		cnt[i] = p - int(g[i].size());
		for (int j : g[i])
			res_val[i] ^= val[j];
	}

	const int best = *max_element(cnt.begin(), cnt.end());

	map<ll, vector<int>> where;
	for (int i = 0; i < t; i++)
	{
		if (cnt[i] == best)
			where[res_val[i]].push_back(i);
	}

	vector<int> prob;
	assert(!where.empty());

	for (auto pr : where)
	{
		if (pr.second.size() > prob.size())
			prob = pr.second;
	}

	cout << best << ' ' << int(prob.size()) << endl;
	for (int i = 0; i < int(prob.size()); i++)
		cout << prob[i] + 1 << " \n"[i + 1 == int(prob.size())];
	cout.flush();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << clock() / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
