#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <iomanip>
#include <queue>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	stack<char> S;
	bool ok = true;
	for (int i = 0; i < n; i++) {
		string str; char p;
		cin >> str;
		cin >> p;
		if (!ok) continue;
		if (str[0] == 'A') S.push(p);
		else {
			if (S.empty()) {
				ok = false;
				continue;
			}
			if (S.top() == p) S.pop();
			else ok = false;
		}
	}
	if (!S.empty()) ok = false;
	cout << (ok ? "Yes" : "No");
}
