#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <iomanip>
#include <queue>
#include <stack>


using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll MOD = ll(1e9) + 7;

ll binpow(ll a, ll p) {
	if (p == 1)
		return a;
	if (p % 2 == 1) {
		return (a * binpow(a, p - 1)) % MOD;
	}
	ll b = binpow(a, p / 2);
	return (b * b) % MOD;
}

ll del(ll a, ll b) {
	return a * binpow(b, MOD - 2) % MOD;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	if (n <= 3) {
		cout << 0;
		return 0;
	}
	else {
		cout << (n * del((binpow(26, n - 3) + MOD - 1) % MOD, 25) - n + 4 + MOD) % MOD;
	}
}
