#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <iomanip>
#include <queue>
#include <stack>


using namespace std;

typedef long long ll;
typedef unsigned long long ull;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll p, t, m;
	cin >> p >> t >> m;
	vector <int> cnt(t, 0);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		cnt[v]++;
	}
	vector <int> ans;
	for (int i = 0; i < t; ++i) {
		if (cnt[i] == 0) {
			ans.push_back(i);
		}
	}
	if (ans.size() > 0) {
		cout << p << ' ' << ans.size() << endl;
		for (int x : ans)
			cout << x + 1 << ' ';
		return 0;
	}
	int min_task = 1e9, min_id = -1;
	for (int i = 0; i < t; ++i)
		if (cnt[i] < min_task) {
			min_task = cnt[i];
			min_id = i;
		}
	cout << p - cnt[min_id] << ' ' << 1 << endl;
	cout << min_id + 1;
}
