#include <iostream>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <cstring>

using namespace std;

long long mod = 1e9 + 7;

long long pow(long long x, long long n){
    if (n == 0) return 1LL;
    long long xx = pow(x, n/2);
    return (n%2 ? ((xx*xx)%mod)*x : xx*xx)%mod;
}

long long f(long long n){
    return ((((pow(26LL, n+1LL) - 1LL)%mod + mod)%mod)*pow(25LL, mod-2LL))%mod;
}

long long mid(long long n){
    return (((pow(26LL,n-4))%mod)*n)%mod;
}

long long ans(long long n){
    if (n<4)return 0;
    if (n==4)return 4;
    if (n==5) return 134;
    if (n==6) return 134+6*26*26;
    if (n==7) return ans(6)+7*26*26*26;
    if (n%2) return (ans(n-1)+mid(n))%mod;
    return ((ans(n/2)+mid(n/2+1)+mid(n/2+2)+mid(n/2+3))%mod+(((f(n/2-4)*pow(26LL,n/2))%mod)*(n/2))%mod+(ans(n/2)*pow(26LL,n/2))%mod)%mod;
}

int main()
{
    ios_base::sync_with_stdio(false);

    long long n;
    cin>>n;
    cout<<ans(n);
    return 0;
}

