#include <iostream>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <cstring>
#include <algorithm>

using namespace std;

long long mod = 1e9 + 7;

bool cmp(vector <int> v1, vector <int> v2){
    if (v1.size() > v2.size()) return false;
    if (v1.size() < v2.size()) return true;
    int m = v1.size();
    for (int i=0;i<m;i++){
        if (v1[i] == v2[i]) continue;
        if (v1[i] > v2[i]) return false;
        if (v1[i] < v2[i]) return true;
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);

    int p, t, m;
    cin >> p >> t >> m;
    vector <int> v[t], cnst[t];
    while (m--){
        int pp, tt;
        cin >> pp >> tt;
        tt--;
        v[tt].push_back(pp);
        cnst[tt].push_back(pp);
    }
    for (int i=0;i<t;i++) sort(v[i].begin(), v[i].end());
    for (int i=0;i<t;i++) sort(cnst[i].begin(), cnst[i].end());
    sort(v, v+t, cmp);
    /*for (auto e : v){
        for (auto x : e){
            cout << x << ' ';
        }
        cout << '\n';
    }*/
    int mn = v[0].size();
    int mx = 1, cnt = 1, j = 0, now = 0;
    for (int i=1;i<t;i++){
        if (v[i].size() > mn) break;
        if (cmp(v[i], v[i-1]) && cmp(v[i-1], v[i])) cnt++;
        else{
            if (cnt > mx) {mx = cnt;j=now;}
            now = i;
            cnt = 1;
        }
    }

    cout << p - mn << ' ' << mx << '\n';
    for (int i=0;i<t;i++){
        if (cmp(v[j], cnst[i]) && cmp(cnst[i], v[j])) cout << i+1 << ' ';
    }

    return 0;
}


