#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll const mod = 1e9 + 7;

ll calc_tupa(int i) {
    ll res = 0;
    for (int j = 4; j <= i; j++) {
        ll st = 1;
        for (int q = 0; q < j - 4; q++) st = st * 26 % mod;
      //  res += pow(26, j - 4) * j;
        res += st * j % mod;
        res %= mod;
    }
    return res;
}

struct matrix {
    int n, m;
    vector <vector <ll>> a;
    matrix(){}
    matrix(int n, int m, vector <vector <ll>> const& val) : n(n), m(m), a(val) {}
    matrix operator * (matrix const& o) const{
        vector <vector <ll>> data;
        assert(m == o.n);
        data.assign(n, vector<ll>(o.m, 0));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < o.m; j++) {
                for (int k = 0; k < m; k++) {
                    data[i][j] += a[i][k] * o.a[k][j] % mod;
                    data[i][j] %= mod;
                }
            }
        }
        return matrix(n, o.m, data);
    }
};

matrix one(int n) {
    vector <vector <ll>> data;
    for (int i = 0; i < n; i++) {
        vector <ll> nw;
        nw.assign(n, 0);
        nw[i] = 1;
        data.push_back(nw);
    }
    return matrix(n, n, data);
}

matrix binpow(matrix const& a, int p) {
    if (!p) return one(a.n);
    if (p == 1) return a;
    if (p % 2 == 1) {
        return a * binpow(a, p - 1);
    } else {
        matrix res = binpow(a, p / 2);
        return res * res;
    }
}

ll calc_umna(int i) {
    if (i < 4) return 0;
    matrix st(3, 1, {{4}, {27}, {1}});
    matrix mv(3, 3, {{26, 1, 3}, {0, 26, 1}, {0, 0, 1}});
    matrix res = binpow(mv, i - 4) * st;
    return res.a[0][0];
}

int main() {
#ifdef local
    //freopen("1input.txt", "r", stdin);
  //  freopen("1output.txt", "w", stdout);
#endif
   /* for (int i = 4; i <= 10; i++) {

        cout << calc_tupa(i) << ' ' << calc_umna(i) << '\n';
        //assert(calc_tupa(i) == calc_umna(i));
    }*/
    int n;
    cin >> n;
    cout << calc_umna(n);
    return 0;
}