#include <bits/stdc++.h>

using namespace std;

int const N = 200100;

vector <int> g[N];
int deg[N];
unordered_map <int, int> cnt;
int mn = 1e9;
int cur;

void try_task(int v, int depth = 0) {
    if (depth == 0) {
        for (int to : g[v]) {
            try_task(to, 1);
        }
    } else {
        for (int to : g[v]) {
            cnt[to]++;
            if (cnt[to] == mn && deg[to] == mn) cur++;
        }
    }
}

int main() {
#ifdef local
    freopen("1input.txt", "r", stdin);
#endif
    int p, t, m;
    cin >> p >> t >> m;
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        u += p;
        g[v].push_back(u);
        g[u].push_back(v);
        deg[u]++;
    }

    for (int i = p; i < p + t; i++) {
        mn = min(mn, deg[i]);
    }
    if (!mn) {
        vector <int> res;
        for (int i = p; i < p + t; i++) if (!deg[i]) res.push_back(i);
        cout << p << ' ' << res.size() <<'\n';
        for (int i : res) cout << i - p + 1 << ' ';
        return 0;
    }
    int ans = 0, id = -1;
    for (int i = p; i < p + t; i++) {
        if (deg[i] == mn) {
            cur = 0;
            cnt.clear();
            try_task(i);
            if (ans < cur) {
                ans = cur;
                id = i;
            }
        }
    }
    assert(id != -1);
    cnt.clear();
    cur = 0;
    try_task(id);
    cout << p - mn << ' ' << cur << '\n';
    for (auto i : cnt) if (i.second == mn && deg[i.first] == mn) {
        cout << i.first + 1 - p << ' ';
    }
    return 0;
}