#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <string>
using namespace std;

void gen(int ind, int n, string &s, string &ans) {
    if (ind == n) {
        ans += s;
        return;
    }
    for (int i = 0; i < 26; i++) {
        s += ('a' + i);
        gen(ind + 1, n, s, ans);
        s.pop_back();
    }
}

int get(string &s) {
    int ans = 0;
    for (int i = 0; i < (int)s.size() - 3; i++) {
        if (s.substr(i, 4) == "icpc") {
            ans++;
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    /*string s = "";
    for (int test = 1; test <= 4; test++) {
        string cur = "";
        string now = "";
        gen(0, test, now, cur);
        s += cur;
        cout << get(s) << " ";
    }
    cout << s << endl;*/
    long long ans = 0;
    long long MOD = 1e9 + 7;
    int n; cin >> n;
    long long power = 1;
    for (int i = 0; i < n - 3; i++) {
        ans += power * (i + 4);
        power *= 26;
        ans %= MOD;
        power %= MOD;
    }
    cout << ans << endl;
    return 0;
}
