#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <string>
using namespace std;

void gen(int ind, int n, string &s, string &ans) {
    if (ind == n) {
        ans += s;
        return;
    }
    for (int i = 0; i < 26; i++) {
        s += ('a' + i);
        gen(ind + 1, n, s, ans);
        s.pop_back();
    }
}

int get(string &s) {
    int ans = 0;
    for (int i = 0; i < (int)s.size() - 3; i++) {
        if (s.substr(i, 4) == "icpc") {
            ans++;
        }
    }
    return ans;
}

const long long MOD = 1e9 + 7;

long long power(long long n, long long x) {
    long long ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans *= x;
            ans %= MOD;
        }
        x *= x;
        x %= MOD;
        n /= 2;
    }
    return ans;
}

long long s(long long n) {
    if (n < 0) {
        return 0;
    }
    long long a = power(n + 1, 26) * (n + 1);
    long long b = (power(MOD - 2, 25) * (26 * (power(n + 1, 26) - 1)) % MOD) % MOD;
    a = (a - b + MOD) % MOD;
    return (power(MOD - 2, 25) * a) % MOD;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    /*string s = "";
    for (int test = 1; test <= 4; test++) {
        string cur = "";
        string now = "";
        gen(0, test, now, cur);
        s += cur;
        cout << get(s) << " ";
    }
    cout << s << endl;*/
    long long n;
    cin >> n;
    if (n < 4) {
        cout << 0 << endl;
        return 0;
    }
    cout << (s(n - 4) + (power(MOD - 2, 25) * (4 * (power(n - 3, 26) - 1)) % MOD) % MOD) % MOD;
    return 0;
}
