#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long lint;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s;
    cin >> s;
    vector<int> t(s.length());
    for (int i = 0; i < s.length(); i++) {
        t[i] = s[s.length() - i - 1] - '0';
    }
    set<int> no_answer = {1, 2, 3, 5, 7};
    map<int, int> small_answer = {
            {4, 2},
            {6, 2},
            {8, 2},
            {9, 3}
    };
    if (t.size() == 1) {
        int number = t[0];
        if (no_answer.count(number)) {
            cout << -1;
        } else {
            cout << 10 << ' ' << small_answer[number];
        }
        return 0;
    }
    else {
        int last = t[0];
        if (last != 1) {
            if (last % 2 == 0) {
                cout << "16 2";
            } else if (last % 3 == 0) {
                cout << "27 3";
            } else if (last % 5 == 0) {
                cout << "10 5";
            } else if (last % 7 == 0) {
                cout << "49 7";
            }
            return 0;
        } else {
            vector<int> dels = {2, 3, 5, 7, 11};
            int left = 867;
            int right = left + 5;
            for (lint b = left; b < right; b++) {
                bool was = false;
                for (lint del: dels) {
                    lint sum = 0;
                    lint step = 1;
                    for (lint a : t) {
                        sum += a * step;
                        step *= b;
                        sum %= del;
                        step %= del;
                    }
                    if (sum == 0) {
                        cout << b << ' ' << del;
                        return 0;
                    }
                }
            }
        }
    }
}