#include <iostream>
#include <cmath>
#include <vector>
using namespace std;


int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    string s;
    char c;
    vector<char> stack;
    bool impossible = false;
    for (long long i = 0; i < n; ++i) {
        cin >> s >> c;
        if (s == "Add") {
            stack.push_back(c);
        } else {
            if (stack.size() > 0 && stack[stack.size() - 1] == c) {
                stack.pop_back();
            } else {
                impossible = true;
            }
        }
    }

    if (impossible || stack.size() > 0) {
        cout << "No" << endl;
    } else {
        cout << "Yes" << endl;
    }

    return 0;
}