#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

int m = 1000000007;
int q = 239;

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int p, t, m;
    cin >> p >> t >> m;
    vector<pair<int, vector<int>>> task(t, {0, vector<int>()});
    for (int i = 0; i < t; i++) {
        task[i].first = i;
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        task[b].second.push_back(a);
    }
    for (int i = 0; i < t; i++) {
        sort(task[i].second.begin(), task[i].second.end());
    }
    sort(task.begin(), task.end(), [](auto& a, auto& b) { return a.second.size() < b.second.size(); });
    size_t sz = task.front().second.size();
    size_t last = task.size();
    for (size_t i = 0; i < task.size(); i++) {
        if (task[i].second.size() != sz) {
            last = i;
            break;
        }
    }
    vector<int> h;
    for (size_t i = 0; i < last; i++) {
        h.push_back(0);
        for (auto el: task[i].second) {
            h[i] = ((long long)h[i] * 239 + (el + 1)) % m;
        }
    }
    unordered_map<int, vector<int>> mp;
    for (size_t i = 0; i < last; i++) {
        mp[h[i]].push_back(task[i].first);
    }
    size_t g = 0;
    for (auto& [k, v]: mp) {
        g = max(g, v.size());
    }
    for (auto& [k, v]: mp) {
        if (g == v.size()) {
            cout << p - sz << ' ';
            cout << v.size() << '\n';
            for (auto a: v) {
                cout << a + 1 << ' ';
            }
            break;
        }
    }

    return 0;
}