#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

#define forn(i,n) for(long long i = 0;i < (n);i++)
#define all(a) (a).begin(),(a).end()

using li = long long;
using vi = vector<li>;
using vpi = vector<pair<li, li>>;
using vvi = vector<vi>;

li M = 1000000007;

li get_hash(vi& a)
{
	li v = 0;
	sort(all(a));
	for (li t : a)
		v = v * M + t;
	return v;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	li p, t, m;
	cin >> p >> t >> m;
	vvi a(t);
	forn(i, m)
	{
		li l, r;
		cin >> l >> r;
		a[r - 1].push_back(l - 1);
	}
	li mn = 1000'000'000;
	for (auto v : a)
		mn = min((li)v.size(), mn);

	vpi b;
	forn(i, t)
		if (a[i].size() == mn) b.push_back({ get_hash(a[i]),i });

	map<li, li> mp;
	li imx = 0;
	mp[imx] = 0;
	for (auto v : b)
	{
		mp[v.first]++;
		if (mp[imx] < mp[v.first])//max hash??
			imx = v.first;
	}

	cout << p - mn << " " << mp[imx] << endl;
	for (auto v : b)
		if (v.first == imx)
			cout << v.second + 1 << " ";

}