#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p, t, m;
    cin >> p >> t >> m;
    vector<set<int>> s(t);
    vector<vector<int>> gr(p);
    for (int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        a--; b--;
        gr[a].push_back(b);
        s[b].insert(a);
    }
    map<set<int>, vector<int>> cnt;
    for (int i = 0; i < t; i++){
        cnt[s[i]].push_back(i);
    }
    int ans = 0;
    for (int i = 1; i < t; i++){
        if (s[i].size() < s[ans].size() || (s[i].size() == s[ans].size() && cnt[s[i]].size() > cnt[s[ans]].size())){
            ans = i;
        }
    }
    cout << p - s[ans].size() << ' ' << cnt[s[ans]].size() << endl;
    vector<int> ansv = cnt[s[ans]];
    for (int v : ansv){
        cout << v + 1 << ' ';
    }
    return 0;
}