﻿#include <iostream>
#include <set>
#include <cmath>

using namespace std;

set <long long> factorization(int p) {
	int i(2), e = sqrt(p + .0) + 1;
	set <long long> d;

	while (i < e) {
		if (p % i == 0) {
			if (i != 2)
				d.insert(i);
			p /= i;
		}
		else
			i++;

	}

	if (p != 1)
		d.insert(p);

	return d;
}

int main() {
	// ...
	long long n;
	cin >> n;

	set <long long> fact = factorization(n);

	if (n % 3 && n % 4 == 0) {
		cout << 4;
		return 0;
	}

	if (*(fact.begin()) == n)
		cout << n;
	else {
		long long i(3);

		do {
			if (n % i == 0) {
				cout << i;
				return 0;
			}

			i++;
		} while (i < n);
	}
}
