// ICPC2019.cpp:      .
//
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> data;
vector<vector<int>> task;

bool fun(int a, int b)
{
	return data[a].size() < data[b].size();
}

int main()
{
	long long p, t, m;
	cin >> p >> t >> m;
	data.resize(t);
	int *mas = new int [t];
	for (int i=0; i < t; i++)
	{
		//data.push_back(vector<int>());
		mas[i]=i;
	}
	int r, u;
	
	for (int i=0; i<m; i++)
	{
		cin >> r >> u;
		data[u - 1].push_back(r);	
	}

	sort(mas, mas + t, fun);
	/*for (int i=0; i<t; i++)
	{
		cout << 'n' << mas[i]+1 << " " <<  data[mas[i]].size();
		cout << ": ";
		for (int j=0; j< data[mas[i]].size(); j++)
			cout << data[mas[i]][j]<< " ";
		cout << '\n';
	}*/
	int start=0, end=0;
	while (data.size()>end && data[mas[start]].size() == data[mas[end]].size())
	{
		end++;
	}
	if (end> data.size() -1 || data[mas[start]].size() != data[mas[end]].size())
		end--;
	vector<int> to_remove;
	for (int i=end+1; i<data.size(); i++)
	{
		to_remove.push_back(mas[i]);
	}
	sort(to_remove.begin(), to_remove.end());
	for (int i=to_remove.size()-1; i>=0;i--)
		data.erase(data.begin()+to_remove[i]);
	/*for (int i=0; i< data.size(); i++)
		cout << 'n' << mas[i]+1 << " :"<< data[i].size();*/
	
	if (data.size() == 1)
	{
		cout << p - data[0].size() << " " << 1 << '\n' << mas[0];
	}
	else
		if(data[0].size() == 0)
		{
			cout << p;
			int temp=0;
			for (int i=0; i< data.size();i++)
				if (!data[0].size())
					temp++;
				else
					break;
			cout << " " << temp << endl;
			for (int i=0; i<temp;i++)
				cout << mas[i] << " ";
		}
	else
	{
		for (int i=0; i<data.size();i++)
		{
			task.push_back(vector<int>());
			task[i].push_back(mas[i]);
			for (int j=i+1;j<data.size();j++)
			{
				bool flag = true;
				for(int k=0; k< data[mas[0]].size();k++)
					if (data[i][k] != data[j][k])
					{
						flag = false;
						break;
					}
				if (flag)
					task[i].push_back(j);
			}
		}
		int maxi=0;
		for (int i=0; i< task.size();i++)
			if (task[maxi].size()<task[i].size())
				maxi=i;
		cout << p - data[mas[0]].size() << " " << task[maxi].size() << endl;
		for (int i=0; i<task[maxi].size(); i++)
		{
			cout << task[maxi][i]+1 << " ";
		}
	}
	return 0;
}

