#pragma GCC optimize("O3") 
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx") 
#define __USE_MINGW_ANSI_STDIO 0
#include<bits/stdc++.h>                               
using namespace std;
 
#define dbg(x) cerr << #x << " == " << x << "\n";
#define PI acos(-1)
#define pb push_back
#define fi first
#define se second
#define TASK ""
#define sz(a) (int)(a).size()
#define all(c) (c).begin(), (c).end()
#define TIMESTAMP fprintf(stderr, "Execution time: %.3lf s.\n", (double)clock()/CLOCKS_PER_SEC)
 
string to_string(string s) {
    return '"' + s + '"';
}
 
string to_string(const char* s) {
    return to_string((string) s);
}
 
template <typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}
 
template <typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}
 
void debug_out() { cerr << endl; }
 
template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}
 
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif
 
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair <int, int> pii;
typedef vector <vi> vvi;
typedef vector <pii> vpii;
typedef vector <string> vs;
	
const int MAXN = 1e5 + 9;
const int MOD = (int)(1e9 + 7);
const int LOG2MAXN = 17;
const int INF = 1e9;
const ld eps = 1e-9;
 
int di[] = {0, 1, 0, -1};
int dj[] = {1, 0, -1, 0};
char ddir[] = {'R', 'U', 'L', 'D'};
 
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 100000;
vector<int> g[N];

void input() {
	int p, t, m;
	cin >> p >> t >> m;
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b;
		a--; b--;

		g[b].push_back(a);
	}

	int minD = m;
	for (int i = 0; i < t; i++) {
		minD = min(minD, (int) g[i].size());
	}

	vector<int> ids;
	for (int i = 0; i < t; i++) {
		if (g[i].size() == minD) {
			ids.push_back(i);
			sort(g[i].begin(), g[i].end());
		}
	}

	sort(ids.begin(), ids.end(), [&] (int i, int j) {
		return g[i] < g[j];
	});
                          
	vector<int> answer;
	answer.push_back(ids[0]);

	vector<int> bigAnswer;
	bigAnswer = answer;
              
	for (int i = 1; i < ids.size(); i++) {
		int a = ids[i - 1];
		int b = ids[i];   
		if (g[a] == g[b]) {
			answer.push_back(b);
		} else {
			if (answer.size() > bigAnswer.size())
				bigAnswer = answer;
			answer.clear();
			answer.push_back(b);
		}
	}

	if (answer.size() > bigAnswer.size())
		bigAnswer = answer;

	cout << p - minD << " " << bigAnswer.size() << "\n";
	for (auto id : bigAnswer) {
		cout << id + 1 << " ";
	}
}
 
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("xxx.in", "r", stdin);
	freopen("xxx.out", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif	
	input();
#ifdef LOCAL
	TIMESTAMP;
#endif	
	return 0;
}