
#include <iostream>
#include <unordered_set>
#include <algorithm>
#include <climits>


using namespace std;


unordered_set<int> pr[100001];
unordered_set<int> notN;
int tasks[100001];
int p, t, m;
bool deleted[100001];
int deletedC = 0;
void deletePart(int id) {
	for (auto task : pr[id])
	{
		tasks[task]--;
		if (tasks[task] == 0)
			notN.insert(task);
	}
	deletedC++;
	deleted[id] = true;
}
bool isInSet(int id, int val) {
	int tmp = pr[id].size();
	pr[id].insert(val);
	return tmp == pr[id].size();
}
void deleteTask(int id) {
	for (int i = 0; i < p; i++)
	{
		if (isInSet(i, id) && !deleted[i])
		{
			deletePart(i);
		}
	}
}
int main()
{
	
	cin >> p >> t >> m;
	for (int i = 1; i <= t; i++)
	{
		notN.insert(i);
		
	}

	
	int tmpP, tmpT;
	for (int i = 0; i < m; i++)
	{
		cin >> tmpP >> tmpT;
		tasks[tmpT]++;
		pr[tmpP].insert(tmpT);
		notN.erase(tmpT);
	}
	while (true) {
		if (notN.size() > 0)
		{
			if (p - deletedC == 0) {
				cout << 0 << ' ' << 0 << endl;
				return 0;
			}
			cout << p - deletedC << ' ' << notN.size() << endl;
			for (auto task : notN)
			{
				cout << task << ' ';
			}
			cout << endl;
			return 0;
		}
		int minTask = tasks[1];
		for (int i = 2; i <= t; i++)
		{
			if (minTask > tasks[i])
				minTask = i;
		}
		deleteTask(minTask);
	}
	

	
	
}

