import java.awt.*;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Main {


    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int pcount = in.nextInt();
        int tcount = in.nextInt();
        int pairCount = in.nextInt();

        int[] tasks = new int[tcount];
        Set<Integer>[] pr = new Set[pcount];
        for (int i = 0; i < pr.length; i++) {
            pr[i] = new HashSet<>();
        }

        Set<Integer> setTasks = new HashSet<>(tcount << 1);

        for (int i = 0; i < pairCount; i++) {
            int p = in.nextInt() - 1;
            int t = in.nextInt() - 1;

            pr[p].add(t);
            setTasks.add(t);
            tasks[t]++;
        }

        if (setTasks.size() != tcount) {
            System.out.println(pcount + " " + (tcount - setTasks.size()));
            for (int i = 0; i < tcount; i++) {
                if (!setTasks.contains(i)) {
                    System.out.print((i + 1) + " ");
                }
            }
            return;
        }

        int minTask = 0;
        for (int i = 0; i < tasks.length; i++) {
            if (tasks[minTask] > tasks[i]) {
                minTask = i;
            }
        }

        Set<Integer> outTask = new HashSet<>(tcount << 1);
        int anscount = pcount;

        for (int i = 0; i < pr.length; i++) {
            if (pr[i].contains(minTask)) {
                anscount--;
                for (int task : pr[i]) {
                    tasks[task]--;
                    if (tasks[task] == 0) {
                        outTask.add(task + 1);
                    }
                }
            }
        }

        System.out.println(anscount + " " + outTask.size());
        for (int task : outTask) {
            System.out.print(task + " ");
        }
    }

}
