import java.util.Map;
import java.util.NavigableMap;
import java.util.Scanner;
import java.util.TreeMap;

public class TaskLos {

    public static void main(String[] args) {
        new TaskLos().run();
    }

    private void run() {

        Scanner in = new Scanner(System.in);

        int n = in.nextInt();
        String[] dict = new String[n];
        Map<String, Integer> map = new TreeMap<>();


        for (int i = 0; i < n; i++) {
            String s = in.next();
            dict[i] = s;
            map.put(s, map.getOrDefault(s, 0) + 1);
        }

        int q = in.nextInt();

        for (int i = 0; i < q; i++) {
            int w = in.nextInt() - 1;
            int k = in.nextInt();
            NavigableMap<Integer, Integer> zFuncMap = new TreeMap<>();

            int res = 0;

            for (Map.Entry<String, Integer> entry : map.entrySet()) {
                int z = zfunc(dict[w], entry.getKey());

                zFuncMap.put(z, zFuncMap.getOrDefault(z, 0) + entry.getValue());
            }

            for (int sign = 0; sign < dict[w].length() + 1; sign++) {
                int count = 0;

                for (Map.Entry<Integer, Integer> entry : zFuncMap.entrySet()) {
                    if (entry.getKey() >= (sign + 1)) {
                        count += entry.getValue();
                    }
                }
                if (count > k) {
                    res += k;
                    if (sign == dict[w].length() - 1) {
                        System.out.println(res);
                        break;
                    }

                    int j = 0;
                    int last = -1;
                    for (Map.Entry<Integer, Integer> entry : zFuncMap.entrySet()) {
                        j += entry.getValue();

                        if (j <= k) {
                            last = entry.getKey();
                        }

                        if (j > k) {
                            entry.setValue(j - k);
                            break;
                        }
                    }

                    if (last != -1) {
                        zFuncMap = zFuncMap.tailMap(last, false);
                    }

                } else {
                    res += count;
                    System.out.println(res);
                    break;
                }
            }
        }
    }

    private int zfunc(String prefix, String findStroke) {
        int result = 0;
        for (int i = 0; i < Math.min(prefix.length(), findStroke.length()); i++) {
            if (findStroke.charAt(i) == prefix.charAt(i))
                result++;
            else
                break;

        }

        return result;
    }

}
