#include <iostream>
#include <stack>
#include <string>
#include <vector>
using namespace std;

using ll = long long;

bool check0(vector<int>& x, vector<int>& mx, vector<int>& mn) {
	if (x[0] <= mx[0] && x[1] <= mx[1]) return false;
	int cnt = 0;
	for (int i = 0; i < 5; ++i) {
		if (x[i] > mx[i]) ++cnt;
	}
	return (cnt >= 3);
}

bool check1(vector<int>& x, vector<int>& mx, vector<int>& mn) {
	int cnt1 = 0;
	int cnt2 = 0;
	int cnt3 = 0;
	for (int i = 0; i < 5; ++i) {
		if (x[i] > mx[i]) {
			++cnt1;
		}
		if (x[i] >= (mx[i] + mn[i]) / 2) {
			++cnt2;
		}
		if (x[i] >= mn[i]) ++cnt3;
	}

	return (cnt1 >= 2 && cnt2 >= 3) || (cnt3 == 5 && cnt2 >= 3);
}

bool check2(vector<int>& x, vector<int>& mx, vector<int>& mn) {
	int cnt1 = 0;
	int cnt2 = 0;
	int cnt3 = 0;
	for (int i = 0; i < 5; ++i) {
		if (x[i] > mx[i]) {
			++cnt1;
		}
		if (x[i] >= (mx[i] + mn[i]) / 2) {
			++cnt2;
		}
		if (x[i] >= mn[i]) ++cnt3;
	}

	return (cnt1 >= 1 && cnt2 >= 2) || (cnt2 >= 3);
}

int main()
{
	int n;
	cin >> n;
	vector<int> mn = { 190, 200, 10, 2, 3 };
	vector<int> mx = { 220, 250, 20, 6, 7 };
	
	for (int i = 0; i < n; ++i) {
		vector<int> cur(5);
		for (int i = 0; i < 5; ++i) cin >> cur[i];

		if (check0(cur, mx, mn)) {
			cout << 0 << '\n';
		}
		else if (check1(cur, mx, mn)) {
			cout << 1 << '\n';
		}
		else if (check2(cur, mx, mn)) {
			cout << 2 << '\n';
		}
		else {
			cout << 3 << '\n';
		}
		
	}

	vector<int> a(n), b(n), c(n), d(n), e(n);

}