#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <string>
#define int long long
#define pb push_back
using namespace std;

int n, m, par;
vector<int> a[100005];
vector<int> b[100005];
pair<int,int> b_new[100005];
bool good[100005];

pair<int,int> del(int k) {
	int count = 0;
	for (int x : b[k]) {
		for (int zad : a[x]) {
			if (b_new[zad].first == k)
				b_new[zad].second--;
			else
				b_new[zad] = { k, b[zad].size() - 1 };
			if (b_new[zad].first == k) {
				if (b_new[zad].second == 0) {
					count++;
				}
			}
		}
	}
	return make_pair(n - b[k].size(), count);
}

void result(int k) {
	for (int x : b[k]) {
		for (int zad : a[x]) {
			if (b_new[zad].first == k)
				b_new[zad].second--;
			else
				b_new[zad] = { k, b[zad].size() - 1 };
		}
	}
	for (int i = 1; i <= m; i++) {
		auto u = b_new[i];
		int now_k = u.first, kol = u.second;
		if (now_k == k) {
			if (kol == 0) {
				cout << i << " ";
			}
		}
	}
}

int32_t main(){
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	fill(b_new, b_new + 100005, make_pair(-1,-1));
	fill(good, good + 100005, false);
	cin >> n >> m >> par;
	for (int i = 0; i < par; i++) {
		int x, y;
		cin >> x >> y;
		a[x].pb(y);
		b[y].pb(x);
	}
	vector<int> zad_res;
	bool f = false;
	int mn = b[1].size();
	for (int i = 1; i <= m; i++) {
		mn = min(mn, 1ll*b[i].size());
		if (b[i].empty()) {
			f = true;
			zad_res.pb(i);
		}
	}
	if (f) {
		cout << n << " " << zad_res.size() << '\n';
		for (int h : zad_res)
			cout << h << ' ';
		return 0;
	}
	for (int i = 1; i <= m; i++) {
		if (b[i].size() == mn) {
			good[i] = true;
		}
	}
	int ind = 0, max_chel = 0, max_zad = 0;
	for (int k = 1; k <= m; k++) {
		if (good[k] && !b[k].empty()) {
			auto p = del(k);
			int kol_chel = p.first, kol_zad = p.second;
			if (kol_chel > max_chel) {
				ind = k;
				max_chel = kol_chel;
				max_zad = kol_zad;
			} else if (kol_chel == max_chel && kol_zad > max_zad) {
				ind = k;
				max_zad = kol_zad;
			}
		}
	}
	fill(b_new, b_new + 100005, make_pair(-1, -1));
	cout << max_chel << " " << max_zad << '\n';
	result(ind);
}
