#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <string>

// #define THIRD_ROOM
#define NUM_TEST 11


void run(FILE* in, FILE* out) {
	long long N;
	fscanf(in, "%lld", &N);
	if (N & 1 == 1) {
		for (long long i = 3; i <= 1000000; i += 2) {
			if (N % i == 0) {
				fprintf(out, "%lld", i);
				return;
			}
		}
		fprintf(out, "%lld", N);
	}
	else {
		N >>= 1;
		if (N % 3 == 0) {
			fprintf(out, "3");
			return;
		}
		if ((N & 1) == 0) {
			fprintf(out, "4");
			return;
		}
		for (long long i = 5; i <= 1000000; i += 2) {
			if (N % i == 0) {
				fprintf(out, "%lld", i);
				return;
			}
		}
		fprintf(out, "%lld", N);
	}
}

#ifndef THIRD_ROOM
int main() {
	run(stdin, stdout);
	return 0;
}
#else

#include <direct.h>

int compareFiles(FILE* f1, FILE* f2) {
	int c1, c2;

	do {
		c1 = fgetc(f1);
		c2 = fgetc(f2);
		if (c1 != c2) {
			return 0; //false
		}
	} while (c1 != EOF && c2 != EOF);

	if (c1 == EOF && c2 == EOF) {
		return 1; //true
	}
	return 0; //false
}

int main() {
	FILE* in;
	FILE* out;
	FILE* test;
	char inputName[25];
	char outputName[25];

	for (int i = 0; i < NUM_TEST; i++) {
		sprintf(inputName, "input%d.txt", i);
		sprintf(outputName, "output%d.txt", i);

		in = fopen(inputName, "rt");
		out = fopen("output.txt", "wt");
		test = fopen(outputName, "rt");

		run(in, out);

		fclose(in);
		fclose(out);

		out = fopen("output.txt", "rt");
		printf("TEST #%2d: %s\n", i, compareFiles(out, test) ? "OK" : "FAIL");

		fclose(test);
		fclose(out);
	}
}

#endif
