#include <iostream>
#include <vector>
#include <stack>

#define MOD 1000000007
using namespace std;

long long sts[35];

long long pow2_m(long long n) {
	if (n == 1) {
		sts[n] = 26;
		return 26;
	}
	long long x = pow2_m(n - 1);
	x = (x * x) % MOD;
	sts[n] = x;
	return x;
}

long long pow_m(long long n) {
	long long ans = 1;
	for (int i = 0; n > 0; i++) {
		if (n % 2 == 1) {
			ans *= sts[i+1];
			ans %= MOD;
		}
		n /= 2;
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	pow2_m(32);
	sts[0] = 1;
	long long n;
	cin >> n;
	long long x = pow_m(n - 3);
	cout << (((((n - 3) * ((x * 26) % MOD) - (n - 2) * x + 1) / (26 - 1) / (26 - 1) + 3 * (x - 1) / (26 - 1)) % MOD) + MOD) % MOD;
}