import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class DividerFinder {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);

        String input = in.next();

        if (input.length() == 1) {
            int a = Integer.parseInt(input);
            ArrayList<Integer> good = new ArrayList<>(Arrays.asList(4, 6, 8));
            if (good.contains(a)) {
                System.out.println(10 + " " + 2);
            } else {
                if (a == 9) {
                    System.out.println(10 + " " + 3);
                } else {
                    System.out.println(-1);
                }
            }
            return;
        }

        ArrayList<Integer> numsInInput = new ArrayList<>();
        int max = 1;

        for (int i = input.length() - 1; i >= 0; i--) {
            int dig = Integer.parseInt(String.valueOf(input.charAt(i)));
            numsInInput.add(dig);
            if (dig > max) {
                max = dig;
            }
        }

        ArrayList<BigInteger> sums = new ArrayList<>();

        int ansB = 0;
        BigInteger ansX = new BigInteger("0");

        for (int base = max + 1; base <=1000000000; base++) {
            sums.clear();
            BigInteger modSum = new BigInteger("0");
            for (int i = 0; i < numsInInput.size(); i++) {
                BigInteger p = BigInteger.valueOf(base).pow(i);
                BigInteger s = p.multiply(BigInteger.valueOf(numsInInput.get(i)));
                sums.add(s);
            }
            BigInteger index = new BigInteger("2");
            for (; index.compareTo(sums.get(sums.size() - 1).sqrt().add(BigInteger.valueOf(1))) < 0; index = index.add(BigInteger.valueOf(1))) {
                modSum = BigInteger.valueOf(0);
                for (BigInteger sum: sums) {
                    modSum = modSum.add(sum.mod(index));
                }

                if (modSum.mod(index).equals(BigInteger.valueOf(0))) {
                    ansB = base;
                    ansX = index;
                    break;
                }
            }

            if (ansB != 0) {
                break;
            }
        }

        if (ansB == 0) {
            System.out.println(-1);
        } else {
            System.out.println(ansB + " " + ansX);
        }
    }
}
