#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <stack>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>

using namespace std;

vector<vector<int>> p_t, t_p;
unordered_map<int, int> m;
unordered_set<int> s, ansS;
vector<int> unknown;

int main()
{
	int P, T, M;

	scanf("%d %d %d", &P, &T, &M);

	p_t.resize(P + 1);
	t_p.resize(T + 1);

	for (int i = 0; i < M; i++)
	{
		int u, v;

		scanf("%d %d", &u, &v);

		p_t[u].push_back(v);
		t_p[v].push_back(u);
	}

	int minCntP = INT_MAX;
	for (int i = 1; i < (int)t_p.size(); i++)
	{
		minCntP = min(minCntP, (int)t_p[i].size());

		if (t_p[i].size() == 0)
			unknown.push_back(i);
	}

	int ansP = P - minCntP;
	int ansT = INT_MIN;

	for (int i = 1; i < (int)t_p.size(); i++)
	{
		if (t_p[i].size() == minCntP)
		{
			m.clear();
			s.clear();

			for (auto p : t_p[i])
			{
				for (auto t : p_t[p])
				{
					if (m.find(t) != m.end())
						m[t]++;
					else
						m[t] = 1;
				}
			}

			for (auto t : m)
			{
				if (t_p[t.first].size() == t.second)
					s.insert(t.first);
			}

			if ((int)s.size() > ansT)
			{
				ansT = s.size();
				ansS = s;
			}

			break;
		}
	}

	cout << ansP << " " << ansT + unknown.size() << endl;

	for (auto t : ansS)
		cout << t << " ";

	for (auto t : unknown)
		cout << t << " ";

	cout << endl;

	return 0;
}