#include <algorithm>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;

#define forn(i, n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define endl '\n'

namespace {
	istream& operator >> (istream& is, pair<int, int>& value) {
		is >> value.first >> value.second;
		return is;
	}

	ostream& operator << (ostream& os, const pair<int, int>& value) {
		os << value.first << " " << value.second << "\n";
		return os;
	}

	template<class T = int>
	T read() {
		T x; cin >> x; return x;
	}

	template<class T>
	void sort(vector<T>& v) {
		sort(all(v));
	}

	template<class T>
	void unique(vector<T>& v) {
		sort(v);
		v.erase(unique(all(v)), v.end());
	}

	template<class T>
	void print(T value) {
		cout << value << "\n";
	}

	template<class T, class... Args>
	void print(T value, Args... args) {
		cout << value << " ";
		print(args...);
	}
}

const int mod = 1e9 + 7;

ll mul(ll x, ll y) { return (x * y) % mod; }
ll add(ll x, ll y) { return ((x + y) % mod + mod) % mod; }

ll mpow(ll x, ll p) {
	if (!p) return 1;
	ll res = mpow(x, p / 2);
	res = mul(res, res);
	if (p & 1) res = mul(res, x);
	return x;
}

void solve() {
	/*int n = read();
	ll rev_252 = mpow(25 * 25, mod - 2);
	ll rev_264 = mpow(26 * 26 * 26 * 26, mod - 2);

	ll p1 = mul(n, mpow(26, n + 1));
	ll p2 = mul((n + 1), mpow(26, n));

	ll upper = mul(26, add(p1, -p2 + 1));
	
	print(upper / (25 * 25));

	ll all_upper = mul(rev_252, upper);

	ll all_all_upper = add(all_upper, -3 * 26 * 26 * 26 - 2 * 26 * 26 - 26 - 1);

	print(mul(all_all_upper, rev_264));*/
	string s; cin >> s;
	ll t = s.back() - '0';
	if (s.size() == 1) {
		set<ll>st = { 1,2,3,5,7 };
		if (st.count(t)) {
			cout << -1 << endl;
		}
		else {
			for (ll x = 2; x < t; x++) {
				if (t % x == 0) {
					cout << 10 << " " << x << endl;
					break;
				}
			}
		}
		return;
	}
	if (t > 1) {
		cout << t * 100 << " " << t << endl;
		return;
	}
	else if (t == 0) {
		cout << 10 << " " << 10 << endl;
	}
	else {
		ll sm = 0;
		for (ll i = 0; i < sz(s) - 1; i++) {
			sm += s[i] - '0';
		}
		cout << sm + 2 << " " << sm + 1 << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;
	while (t--) {
		auto timer = clock();
		solve();
		fprintf(stderr, "Time = %.3f\n", (double)(clock() - timer) / CLOCKS_PER_SEC);
	}
}