import java.lang.IllegalArgumentException

fun readLn() = readLine()!!
fun readInt() = readLn().toInt()
fun readInts() = readLn().split(' ').map { it.toInt() }
fun Boolean.toInt() = if (this) 1 else 0

fun main() {
    val n = readInt()

    val stack = mutableListOf<String>()
    repeat(n) {
        val (act, name) = readLn().split(' ')
        when (act) {
            "Add" -> stack.add(name)
            "Vote" -> {
                if (stack.isEmpty() || stack.last() != name) {
                    println("No")
                    return
                }
                stack.removeAt(stack.lastIndex)
            }
            else -> throw IllegalArgumentException()
        }
    }

    println(if (stack.isEmpty()) "Yes" else "No")
}