using namespace std;

#ifdef DEBUG
#include <fstream>

ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif // DEBUG

#include <vector>
#include <utility>
#include <algorithm>
#include <set>

//typedef pair<int, pair<vector<int>,int> > pp;
typedef pair<int, pair<set<int>,int> > tt;

#define endl '\n'

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int pn,tn,mn;
    int p0,t0;
    cin>>pn>>tn>>mn;
    if(mn == 0) {
        cout<<pn<<' '<<tn<<endl;
        for(int i = 1; i <= tn; ++i) cout<<i<<' ';
        return 0;
    }

    vector< tt > t(tn);
    for(int i = 0; i < tn; ++i) {
        auto& task = t[i];
        task.first = 0;
        task.second.second = i;
    }
    for(int i = 0; i < mn; ++i) {
        cin>>p0>>t0; --p0, --t0;
        auto& task = t[t0];
        task.second.first.insert(p0);
        ++task.first; //    
    }
    sort(t.begin(), t.end(), [](const tt& o1, const tt& o2){
            if(o1.first == o2.first) {
                if(o1.second.first.empty()) return true;

                for(auto it1 = o1.second.first.begin(),
                    it2 = o2.second.first.begin();
                    it1 != o1.second.first.end();
                    ++it1, ++it2) {
                        if(*it1 == *it2) {
                            continue;
                        }
                        return *it1 < *it2;
                    }
                return o1.first<o2.first;
            }
            return o1.first<o2.first;
         });
    int ansp = 0;
    int anst = 0;
    if(t[0].first == 0) {
        int szanst = 0;
        for(int i = 0; i < tn; ++i) {
            if(t[i].first==0) {
                ++szanst;
            } else break;
        }
        cout<<pn<<' '<<szanst<<endl;
        for(int i = 0, j = 0; j < szanst; ++i, ++j)
            cout<<t[i].second.second+1<<' ';
        return 0;
    }

    if(tn == 1) {
        if(t[0].first == pn) {
            cout<<0<<' '<<0;
        }
        else cout<<pn-t[0].first<<' '<<1;
        return 0;
    }

    int anstmptask = 1;
    int tasksbeginind = 0;
    int fi = 0;
    for(int j = fi+1; j < tn && fi < tn-1; ++j) {
        auto& tis = t[fi].second.first;
        auto& tjs = t[j].second.first;
        auto it1 = tis.begin();
        auto it2 = tjs.begin();

        for(;
        it1 != tis.end() && it2 != tjs.end() && *it1 == *it2; ++it1, ++it2) {
        }

        if(it1 == tis.end() && it2 == tjs.end()) {
            anstmptask++;
        } else {
            if(anstmptask > anst) {
                anst=max(anst,anstmptask);
                tasksbeginind = fi;
            }
            fi = j;
            anstmptask = 1;
        }
    }
    if(anstmptask > anst) {
        anst=max(anst,anstmptask);
        tasksbeginind = fi;
    }

    if(anstmptask == tn) {
        cout<<"0 0";
        return 0;
    } else {
        cout<<pn-t[0].first<<' '<<anst<<endl;
        for(int i = tasksbeginind, j = 0; j < anst; ++i, ++j)
            cout<<t[i].second.second+1<<' ';
        return 0;
    }

    cout<<ansp<<' '<<anst<<endl;

    return 0;
}
